#include "ced.h"
#include "keys.h"
#include "mymem.h"
#include "window.h"
#include "poly.h"
#include "ed2.h"
#include "polyinit.h"
#include "writeddc.h"
 
void
DrawAllViews(Dungeon *dung,XImage *VScreen,struct ControlInfo *Controls,
			 int dots[],int basepix)
{
    int i;
    int z,x,y;
    int px,py;
    int fx,fy;
    int sx,sy;
 
    px=3*MAX_WINDOW_WIDTH/4;
    py=MAX_WINDOW_HEIGHT/4;
    fx=3*MAX_WINDOW_WIDTH/4;
    fy=3*MAX_WINDOW_HEIGHT/4;
    sx=MAX_WINDOW_WIDTH/4;
    sy=3*MAX_WINDOW_HEIGHT/4;
    if(Controls->Zoomed) {
        px=MAX_WINDOW_WIDTH/2;
        py=MAX_WINDOW_HEIGHT/2;
        fx=MAX_WINDOW_WIDTH/2;
        fy=MAX_WINDOW_HEIGHT/2;
        sx=MAX_WINDOW_WIDTH/2;
        sy=MAX_WINDOW_HEIGHT/2;
    }
	
	if ((Controls->ShowMode==1) && (!Controls->Zoomed)) {
    	TwoDSortPolygons(dung->SortingPolygons,dung->twoDY);
		for (i=0 ; i < dung->NumPolygons ; i++) {
			DrawViewWireFrame(dung,dung->SortingPolygons[i],
						(VScreen->data),px,py,
						dung->twoDX,dung->twoDZ);
			DrawViewWireFrame(dung,dung->SortingPolygons[i],
						(VScreen->data),fx,fy,
						dung->twoDX,dung->twoDY);
			DrawViewWireFrame(dung,dung->SortingPolygons[i],
						(VScreen->data),sx,sy,
						dung->twoDZ,dung->twoDY);
		}
	
	}

    for (i=0;i<dung->NumPoints;i++){
        x=dung->twoDX[i];
        y=dung->twoDY[i];
        z=dung->twoDZ[i];
        if(Controls->Zoomed) {
            x<<=1;
            y<<=1;
            z<<=1;
        }
		
        if((Controls->Zoomed && Controls->ViewWindow==PLAN_WIN) || !Controls->Zoomed) {
	    DrawPt(VScreen,x+px,z+py,dots[i]);  /*plan*/      				
	     
        }
        if((Controls->Zoomed && Controls->ViewWindow==ELEV_WIN) || !Controls->Zoomed) {
            DrawPt(VScreen,x+fx,y+fy,dots[i]);  /*Front*/
        }
        if((Controls->Zoomed && Controls->ViewWindow==SIDE_WIN) || !Controls->Zoomed) {
            DrawPt(VScreen,z+sx,y+sy,dots[i]);  /*side*/
        }
    }
}

void 
RotateTexture(Dungeon *dung,int Polynum)
{
	int tmp;
	tmp= dung->PolygonArray[Polynum]->Points[0];
	dung->PolygonArray[Polynum]->Points[0]= dung->PolygonArray[Polynum]->Points[1];
	dung->PolygonArray[Polynum]->Points[1]= dung->PolygonArray[Polynum]->Points[2];
	dung->PolygonArray[Polynum]->Points[2]= dung->PolygonArray[Polynum]->Points[3];
	dung->PolygonArray[Polynum]->Points[3]=tmp;
}

void 
AddPolygon(Dungeon *dung,int points[]) //p1,int p2,int p3,int p4,int p5)
{
    Polygon *p;
    p=MyMalloc(sizeof(Polygon),"NewPolygon");
    if(p) {
        dung->SortingPolygons[dung->NumPolygons]=p;
        dung->PolygonArray[dung->NumPolygons++]=p;
        dung->SortingPolygons[dung->NumPolygons]=NULL;
        dung->SortingPolygons[dung->NumPolygons+1]=NULL;
        dung->PolygonArray[dung->NumPolygons]=NULL;
        p->Points[0]=points[1];
        p->Points[1]=points[2];
        p->Points[2]=points[3];
        p->Points[3]=points[4];
        p->CentrePt=points[5];
        p->Style=1; // Texture
        p->Texture=1;
        p->Color=64;
    }
}
 
Segment *
AddObject(Segment *Prev,Dungeon *dung,int *NumO)
{
    int i;
    int Num=*NumO;
    Segment **objs=dung->ObjectArray;
    objs[Num]=MyMalloc(sizeof(Segment),"New Object");
    objs[Num+1]=NULL;
    if(objs[Num]) {
        objs[Num]->ID=Num;
        objs[Num]->Moves=NULL;
        objs[Num]->Numpoints=6;
        objs[Num]->Poffset=dung->NumPoints;
 
        objs[Num]->Prev=Prev;
        for(i=0;i<5;i++) {
            objs[Num]->Next[i]=NULL;
        }
        objs[Num]->CurrXAng=0;
        objs[Num]->CurrYAng=0;
        objs[Num]->CurrZAng=0;
        objs[Num]->Waiter=0;
        for(i=0;i<6;i++) {
            (dung->Points[0])[(objs[Num]->Poffset)+i]=0;
            (dung->Points[1])[(objs[Num]->Poffset)+i]=0;
            (dung->Points[2])[(objs[Num]->Poffset)+i]=0;
        }
        dung->NumPoints+=6;
        dung->NumObjects++;
        return(objs[Num]);
    }
    return(NULL);
}
 
void 
AddPoint(Dungeon *dung,Segment *addto)
{
    int i,j,k;
    Segment *thisone;
 
    for(i=addto->ID+1 ; i<dung->NumObjects ; i++) {
        thisone=GetObj(i,dung->ObjectArray);
        thisone->Poffset++;
    }
 
    for(j=0 ; j<dung->NumPolygons ; j++) {
        for(k=0;k<4;k++) {
            if(dung->PolygonArray[j]->Points[k]>= addto->Poffset+addto->Numpoints) {
                dung->PolygonArray[j]->Points[k]++;
            }
        }
    }
    for(i=dung->NumPoints;i>addto->Poffset+addto->Numpoints;i--) {
        (dung->Points[0])[i]=(dung->Points[0])[i-1];
        (dung->Points[1])[i]=(dung->Points[1])[i-1];
        (dung->Points[2])[i]=(dung->Points[2])[i-1];
    }
    (dung->Points[0])[i]=10;
    (dung->Points[1])[i]=10;
    (dung->Points[2])[i]=10;
    dung->NumPoints++;
    addto->Numpoints++;
}
 
void
ZeroObjectAngles(Dungeon *dung)
{
    int i;
 
    for(i=0;i<dung->NumObjects;i++) {
        dung->ObjectArray[i]->CurrXAng=0;
        dung->ObjectArray[i]->CurrYAng=0;
        dung->ObjectArray[i]->CurrZAng=0;
    }
}
 

void 
ZeroAngles(Dungeon *dung)
{
    int i;
    for(i=0;i<5;i++) {
        if(dung->ObjectArray[0]->Next[i]) {
            UpdateSaveObjects(dung->ObjectArray[0]->Next[i]);
        }
    }
    for(i=0;i<dung->NumObjects;i++) {
        dung->ObjectArray[i]->CurrXAng=0;
        dung->ObjectArray[i]->CurrYAng=0;
        dung->ObjectArray[i]->CurrZAng=0;
    }
}
 
void 
Copy2D2Points(int px,int py,int pz,Dungeon *dung,Segment *obj)
{
    int i;
    for(i=obj->Poffset;i<obj->Poffset+obj->Numpoints;i++) {
        (dung->Points[0])[i]=dung->twoDX[i]-px;
        (dung->Points[1])[i]=dung->twoDY[i]-py;
        (dung->Points[2])[i]=dung->twoDZ[i]-pz;
    }
    for(i=0;i<5;i++) {
        if(obj->Next[i]) {
            Copy2D2Points(px+(dung->Points[0])[obj->Poffset+i+1],
                      py+(dung->Points[1])[obj->Poffset+i+1],
                      pz+(dung->Points[2])[obj->Poffset+i+1],dung,
                      obj->Next[i]);
        }
    }
}
 
void 
DoAngles(Dungeon *dung)
{
    Copy2D2Points(0,0,0,dung,dung->ObjectArray[0]);
}
 
void 
HitCollPoint(int arr[MAX_COLLISION_PTS],int *num,int pt)
{
    int i;
    int flag=0;
    fprintf(stdout,"Bfore: %d  :::  ",pt);
    fprintf(stdout,"Points: ");
    for(i=0;i<*num;i++) {
        fprintf(stdout,"%d ",arr[i]);
    }
    fprintf(stdout,"\n");
    for(i=0;i<*num;i++) {
        if(arr[i]==pt) {
            flag=i+1;
        }
    }
    if(!flag) {
        arr[(*num)++]=pt;
    } else {
        for(i=flag-1;i<*num;i++) {
            arr[i]=arr[i+1];
        }
        (*num)--;
    }
    fprintf(stdout,"Point: %d  :::  ",pt);
    fprintf(stdout,"Points: ");
    for(i=0;i<*num;i++) {
        fprintf(stdout,"%d ",arr[i]);
    }
    fprintf(stdout,"\n");
}  
 
void 
DoMinusPressed(Dungeon *dung,struct ControlInfo *Controls)
{
    switch(Controls->Mode) {
        case 0:
            Controls->ActivePoint--;
            if(Controls->ActivePoint<0) Controls->ActivePoint=0;
            break;
        case 1:
            Controls->ActiveObject =
                    GetObj( (Controls->ActiveObject->ID-1+dung->NumObjects)%dung->NumObjects, dung->ObjectArray);
            break;
        case 2:
            if(dung->NumPolygons) {
                Controls->ActivePoly = (Controls->ActivePoly -1 + dung->NumPolygons ) % dung->NumPolygons;
            }
        break;
    }
}
 
void 
DoPlusPressed(Dungeon *dung,struct ControlInfo *Controls)
{
    switch(Controls->Mode) {
        case 0:
            Controls->ActivePoint++;
            if(Controls->ActivePoint>=dung->NumPoints) Controls->ActivePoint=dung->NumPoints-1;
            break;  
        case 1:
            Controls->ActiveObject=GetObj((Controls->ActiveObject->ID+1)%dung->NumObjects,
                                           dung->ObjectArray);
            break;
        case 2:
            if(dung->NumPolygons) {
                Controls->ActivePoly= (Controls->ActivePoly +1 ) % dung->NumPolygons;
            }
            break;
    }
}
 
void SetViewMode(struct ControlInfo *Controls,int showmode)
{
    Controls->ShowMode=showmode;
    switch(Controls->ShowMode) {          /*   0x44  */
        case 0:
            Controls->Flags= (Controls->Flags & 0xFFFFFFBB) | 0x00;
            break;
        case 1:
            Controls->Flags= (Controls->Flags & 0xFFFFFFBB) | 0x40;
            break;
        case 2:
            Controls->Flags= (Controls->Flags & 0xFFFFFFBB) | 0x04;
            break;
        case 3:
            Controls->Flags= (Controls->Flags & 0xFFFFFFBB) | 0x44;
            break;
    }
}
void
DoSave(Dungeon *dung,Display *display,Window win,GC gc,
        struct ControlInfo *Controls, int PaletteO)
{
    char tmpstr[70];
    int i;
   
    ZeroAngles(dung);
    strcpy(tmpstr,"HOHOHOHO.dso");
    if(!RequestFilename(display,win,gc,tmpstr,
                    "Save File...",0,PaletteO,".ddc",0)) {
        return;  // DONT save
    }
    for ( i=0 ;i< dung->NumPoints;i++) {
        (dung->Points[0])[i]*=Controls->ScaleFactor;
        (dung->Points[1])[i]*=Controls->ScaleFactor;
        (dung->Points[2])[i]*=Controls->ScaleFactor;
    }
    Controls->ScaleFactor=1;
    WriteCharacter(dung,tmpstr);
}
 
void CyclePickMode(struct ControlInfo *Controls)
{
    switch(Controls->Mode) {
        case 0:
            Controls->Mode=1;
            Controls->Flags= (Controls->Flags & 0xFFFFFF7D) | 0x02;
            break;
        case 1:
            Controls->Mode=2;
            Controls->Flags= (Controls->Flags & 0xFFFFFF7D) | 0x80;
            break;
        case 2:
            Controls->Mode=0;
            Controls->Flags= (Controls->Flags & 0xFFFFFF7D) | 0x00;
            break;
    }
}
 
void AddObjectWrap(Dungeon *dung,struct ControlInfo *Controls)
{
    int j;
    int which_next;
    for(j=0;j<5;j++) {
        if(Controls->ActiveObject->Next[j]==NULL) break;
    }
    if(j!=6) {
        which_next=j;
        Controls->ActiveObject->Next[which_next]=
            AddObject(Controls->ActiveObject,dung, &dung->NumObjects);
        (dung->Points[0])[(Controls->ActiveObject->Poffset)+1+which_next]=20;
        (dung->Points[1])[(Controls->ActiveObject->Poffset)+1+which_next]=20;
        (dung->Points[2])[(Controls->ActiveObject->Poffset)+1+which_next]=20;
    }
}
 
void DeletePolygon(Dungeon *dung,struct ControlInfo *Controls)
{
    int j;
    Polygon **polygon_array=dung->PolygonArray;
    for(j=Controls->ActivePoly;j<dung->NumPolygons-1;j++) {
        polygon_array[j]=polygon_array[j+1];
    }
    polygon_array[--(dung->NumPolygons)]=NULL;
    for(j=0;j<dung->NumPolygons+1;j++) {
        dung->SortingPolygons[j]=polygon_array[j]; /*That's the easiest way*/
    }
    if(Controls->ActivePoly>=dung->NumPolygons) {
        Controls->ActivePoly--;
    }
}
 
void AddPolyPoint(Dungeon *dung,struct ControlInfo *Controls)
{
    int j;
    if(Controls->newpoly[0]==5) {
        AddPolygon(dung,Controls->newpoly); //newpoly[1],newpoly[2],newpoly[3],newpoly[4], newpoly[5]);
        for(j=0;j<6;j++) {
            Controls->newpoly[j]=0;
        }
    } else {
        Controls->newpoly[++Controls->newpoly[0]]=Controls->ActivePoint;
    }
}
 
void DeletePolyPoint(struct ControlInfo *Controls)
{
    if(Controls->newpoly[0]) {
        Controls->newpoly[Controls->newpoly[0]--]=0;
    }
}
 
void PreviousTexture(Dungeon *dung,struct ControlInfo *Controls)
{
    if(dung->NumPolygons) {
        dung->PolygonArray[Controls->ActivePoly]->Texture=
                (dung->PolygonArray[Controls->ActivePoly]->Texture-1+NUM_TEXTURES) % NUM_TEXTURES;
        dung->PolygonArray[Controls->ActivePoly]->Color= 0;
    }
}
 
void NextTexture(Dungeon *dung,struct ControlInfo *Controls)
{
    if(dung->NumPolygons) {
        dung->PolygonArray[Controls->ActivePoly]->Texture=
                (dung->PolygonArray[Controls->ActivePoly]->Texture+1) % NUM_TEXTURES;
        dung->PolygonArray[Controls->ActivePoly]->Color= 0;
    }
}
 
void PreviousColourGroup(Dungeon *dung,struct ControlInfo *Controls)
{
    if(dung->NumPolygons) {
        dung->PolygonArray[Controls->ActivePoly]->Color = (dung->PolygonArray[Controls->ActivePoly]->Color + GROUP_SIZE);
		if( dung->PolygonArray[Controls->ActivePoly]->Color>=192 ) {
			dung->PolygonArray[Controls->ActivePoly]->Color-=64; 
		}
    }
}
 
void NextColourGroup(Dungeon *dung,struct ControlInfo *Controls)
{
    if(dung->NumPolygons) {
        dung->PolygonArray[Controls->ActivePoly]->Color = dung->PolygonArray[Controls->ActivePoly]->Color - GROUP_SIZE;
		if( dung->PolygonArray[Controls->ActivePoly]->Color <128) {
			dung->PolygonArray[Controls->ActivePoly]->Color +=64;
		}
    }
}
 
void PreviousColour(Dungeon *dung,struct ControlInfo *Controls)
{
    if(dung->NumPolygons) {
        dung->PolygonArray[Controls->ActivePoly]->Color = (dung->PolygonArray[Controls->ActivePoly]->Color +1 ) % HIGHEST_COL;
    }
}
 
void NextColour(Dungeon *dung,struct ControlInfo *Controls)
{
    if(dung->NumPolygons) {
        dung->PolygonArray[Controls->ActivePoly]->Color = (dung->PolygonArray[Controls->ActivePoly]->Color - 1+ HIGHEST_COL) %
HIGHEST_COL;
    }
}
 
 
void
AdvanceStyle(Dungeon *dung, struct ControlInfo *Controls)
{
    if (dung->NumPolygons) {
        dung->PolygonArray[Controls->ActivePoly]->Style=(dung->PolygonArray[Controls->ActivePoly]->Style+1)%3;
		if (dung->PolygonArray[Controls->ActivePoly]->Style==2) {
			dung->PolygonArray[Controls->ActivePoly]->Color=128;
		}
    }
}
 
void
SetStyle(Dungeon *dung, struct ControlInfo *Controls,int num)
{
    if (dung->NumPolygons) {
        dung->PolygonArray[Controls->ActivePoly]->Style=num;
    }
}
 
 
int NearestPt(int x,int y,short xarr[],short yarr[],int Length)
{
    int Dist=50000;
    int Best=0;
    int i;
    int thisdist;
    for(i=0;i<Length;i++) {
    thisdist=((xarr[i]-x) * (xarr[i]-x) ) + ( (yarr[i]-y) * (yarr[i]-y));
    if(thisdist<Dist) {
        Dist=thisdist;
        Best=i;
    }
    }
    return(Best);
}
 
int SelectPoint(Dungeon *dung,int x,int y,struct ControlInfo *Controls,
				Display *display,struct Button ControlButtons[])
{
	if(Controls->Zoomed) {
		x-=MAX_WINDOW_WIDTH/2;
		y-=MAX_WINDOW_HEIGHT/2;
		switch(Controls->ViewWindow) {
			case THREE_WIN:
            	Controls->ActivePoint=NearestPt(x>>1,y>>1,
                      				(dung->newpts[0]),(dung->newpts[1]),dung->NumPoints);
				return(0);
				break;
			case PLAN_WIN:
            	Controls->ActivePoint=NearestPt(x>>1,y>>1,
                      				dung->twoDX,dung->twoDZ,dung->NumPoints);
				return(1);
				break;
			case SIDE_WIN:
            	Controls->ActivePoint=NearestPt(x>>1,y>>1,
                      				dung->twoDZ,dung->twoDY,dung->NumPoints);
				return(1);
				break;
			case ELEV_WIN:
            	Controls->ActivePoint=NearestPt(x>>1,y>>1,
                      				dung->twoDX,dung->twoDY,dung->NumPoints);
				return(1);
				break;
		}
	} else {
    	if(x<MAX_WINDOW_WIDTH/2 && y<MAX_WINDOW_HEIGHT/2) {
            Controls->ActivePoint=NearestPt(x,y,(dung->newpts[0]),(dung->newpts[1]),dung->NumPoints);
            Controls->ViewWindow=THREE_WIN;
        	AffectButtons(display,ControlButtons,KEY_1,Controls);
            return(0);
    	} else if(x>=MAX_WINDOW_WIDTH/2 && y<MAX_WINDOW_HEIGHT/2) {
            Controls->ActivePoint=NearestPt(x-(3*MAX_WINDOW_WIDTH/4),y-(MAX_WINDOW_HEIGHT/4),
                      dung->twoDX,dung->twoDZ,dung->NumPoints);
            Controls->ViewWindow=PLAN_WIN;
        	AffectButtons(display,ControlButtons,KEY_2,Controls);
            return(1);
    	} else if(x<MAX_WINDOW_WIDTH/2 && y>=MAX_WINDOW_HEIGHT/2) {
            Controls->ActivePoint=NearestPt(x-(MAX_WINDOW_WIDTH/4),y-(3*MAX_WINDOW_HEIGHT/4),
                      dung->twoDZ,dung->twoDY,dung->NumPoints);
            Controls->ViewWindow=SIDE_WIN;
        	AffectButtons(display,ControlButtons,KEY_3,Controls);
            return(1);
    	} else if(x>=MAX_WINDOW_WIDTH/2 && y>=MAX_WINDOW_HEIGHT/2) {
            Controls->ActivePoint=NearestPt(x-(3*MAX_WINDOW_WIDTH/4),y-(3*MAX_WINDOW_HEIGHT/4),
                      dung->twoDX,dung->twoDY,dung->NumPoints);
            Controls->ViewWindow=ELEV_WIN;
        	AffectButtons(display,ControlButtons,KEY_4,Controls);
            return(1);
    	}
	}
    return(0);
}


