#include "palette.h"
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>
#include <X11/cursorfont.h>
#include <dirent.h> 
#include <math.h>
#include "gameicon.h"
#include <stdio.h>
#include <strings.h>
#include <time.h>
#include "writeddm.h"
#include "readddm.h"
#include "help.h"
#include "med.h"


int DEbug_flag=0;


#define icon_bitmap_width newicon_width
#define icon_bitmap_height newicon_height
#define icon_bitmap_bits newicon_bits

/*#define DEBUG_NEW_POLY*/

#include "ed2.h"
#include "dirs.h"
#include "pcx.h"
#include "poly.h"
#include "mymem.h"
#include "polyinit.h"
#include "graph.h"
#include "text.h"
#include "gui.h"
#include "keys.h"
#include "window.h"
#include "generic.h"
#include "med.h"
#include "ced.h"

#define Print(a) fprintf(stderr,a)

/* GLOBALS */

Segment *Torso;
short int *PointsX,*PointsY,*PointsZ;
short int *newptsX,*newptsY,*newptsZ;
int HIGHLIGHT_DOT;
int HOT_DOT;
int NORMAL_DOT;
int dots[1000];				// Shouldn't be global....


#define progname "DUNGEON of DEATH (editor)"

#define DefRootWindow(d) RootWindow(d,DefaultScreen(d))
#define DefBlackPixel(d) BlackPixel(d,DefaultScreen(d))
#define DefWhitePixel(d) WhitePixel(d,DefaultScreen(d))

#define RoteWorldX(a) a->CurrXAng = (a->CurrXAng + 4 ) & 127
#define RoteWorldY(a) a->CurrYAng = (a->CurrYAng + 4 ) & 127
#define RoteWorldZ(a) a->CurrZAng = (a->CurrZAng + 4 ) & 127

/*
int ButtonReact(Display *display,GC gc,XEvent *report,struct Button *button);
void getGC(Display *,Window,GC *,XFontStruct *,int);
void load_font(Display *,XFontStruct **);
void linedraw(int,int,int,int,int,uchar*);
void AddButton(Display *display,struct Button *ThisButton,int x,int y,
			   int w,int h, char *imagename,int udPos,int PaletteOffset,
			   Window ParentWin,GC gc,int Flags);
Dungeon *SetupStuffed(char *fname,int NumText,int);

void DrawViewWireFrame(Dungeon *, Polygon *,uchar *,int,int,short int *,short int *);
*/

void 
DrawPt(XImage *VScreen,int x,int z,int Mode)
{
    if(x<2 || z<2 || x>MAX_WINDOW_WIDTH-3 || z>MAX_WINDOW_HEIGHT-3) 
	return;
    PutVPix(VScreen,x,z,Mode);
    PutVPix(VScreen,x+1,z,Mode);
    PutVPix(VScreen,x-1,z,Mode);
    PutVPix(VScreen,x,z+1,Mode);
    PutVPix(VScreen,x,z-1,Mode);
    if(Mode==HIGHLIGHT_DOT) {
	PutVPix(VScreen,x+2,z,Mode);
	PutVPix(VScreen,x-2,z,Mode);
	PutVPix(VScreen,x,z+2,Mode);
	PutVPix(VScreen,x,z-2,Mode);
	PutVPix(VScreen,x+1,z+1,Mode);
	PutVPix(VScreen,x-1,z+1,Mode);
	PutVPix(VScreen,x-1,z-1,Mode);
	PutVPix(VScreen,x+1,z-1,Mode);
    }
}

void
XXXXXHLine(char *rast,int x,int y,int len,int colour)
{
    rast+=(y*MAX_WINDOW_WIDTH)+x;
    while(len--) {
        *(rast++)=colour;
    }
}
 
void
XXXXXVLine(char *rast,int x,int y,int len,int colour)
{
    rast+=(y*MAX_WINDOW_WIDTH)+x;
    while(len--) {
        *rast=colour;
        rast+=MAX_WINDOW_WIDTH;
    }
}
 
void
DrawRectangle(char *raster,int x,int y,int w,int h,int colour)
{
    w--;
    HLine(raster,x,y,w,colour);
    HLine(raster,x,y+h-1,w,colour);
    VLine(raster,x,y,h,colour);
    VLine(raster,x+w,y,h,colour);
}

void 
Box(XImage *vscreen,int x1,int y1,int x2,int y2)
{
    int i;
    for(i=x1;i<=x2;i++) {
	PutVPix(vscreen,i,y1,3);
	PutVPix(vscreen,i,y1+1,3);
	PutVPix(vscreen,i,y1+3,4);
	PutVPix(vscreen,i,y2,3);
	PutVPix(vscreen,i,y2-1,3);
	PutVPix(vscreen,i,y2-3,4);
    }
    for(i=y1+1;i<y2;i++) {
	PutVPix(vscreen,x1,i,3);
	PutVPix(vscreen,x1+1,i,3);
	PutVPix(vscreen,x1+3,i,4);
	PutVPix(vscreen,x2,i,3);
	PutVPix(vscreen,x2-1,i,3);
	PutVPix(vscreen,x2-3,i,4);
    }
}

void
Rim(XImage *vscreen,int BasePix,int x,int y)
{
	Draw3DBox2(vscreen,x,y,MAX_WINDOW_WIDTH/2,MAX_WINDOW_HEIGHT/2,
									BasePix+LITE_GRAY,BasePix+DARK_GRAY,1);
	Draw3DBox2(vscreen,x+1,y+1,MAX_WINDOW_WIDTH/2-2,MAX_WINDOW_HEIGHT/2-2,
									BasePix+LITE_GRAY,BasePix+DARK_GRAY,1);
	Draw3DBox2(vscreen,x+2,y+2,MAX_WINDOW_WIDTH/2-4,MAX_WINDOW_HEIGHT/2-4,
									BasePix+LITE_GRAY,BasePix+DARK_GRAY,1);
	Draw3DBox2(vscreen,x+3,y+3,MAX_WINDOW_WIDTH/2-6,MAX_WINDOW_HEIGHT/2-6,
									BasePix+LITE_GRAY,BasePix+DARK_GRAY,1);
}


void DrawWinBox(struct ControlInfo *Controls,XImage *vscreen,int BasePix)
{
	int dims[4][2] = {  
		{ 0,0 },
		{ MAX_WINDOW_WIDTH/2,0 },
		{ MAX_WINDOW_WIDTH/2,MAX_WINDOW_HEIGHT/2 },
		{ 0,MAX_WINDOW_HEIGHT/2 }
	};
	int *ptr;
		

	if(Controls->Zoomed) return;
	ptr=dims[Controls->ViewWindow];
	Rim(vscreen,BasePix,ptr[0],ptr[1]);
}

void SetupWindow(Display **display,Window *win,int argc,char *argv[],GC *gc,
				 XFontStruct **font_info,long pixels[256],
				 Colormap *OurColours)
{
    uint border_width=4;  /* Makes no difference !!  */
    char *window_name="Lord Baylor Vs UNIX";
    char *icon_name="Mantisoft: Sweet-fight";
    Pixmap icon_pixmap;
    XSizeHints *size_hints;
    XIconSize *size_list;
    XWMHints *wm_hints;
    XClassHint *class_hints;
    unsigned long planemasks[256];
    XTextProperty windowName, iconName;
    char *display_name=NULL;
    int screen_num;
    int count;
    struct Picture_Type *PalettePic;

    if(!(size_hints=XAllocSizeHints())) {
	fprintf(stderr,"%s: no-mem\n",progname);
	exit(0);
    }
    if(!(wm_hints=XAllocWMHints())) {
	fprintf(stderr,"%s: no-mem\n",progname);
	exit(0);
    }
    if(!(class_hints=XAllocClassHint())) {
	fprintf(stderr,"%s: no-mem\n",progname);
	exit(0);
    }
    if(!(*display=XOpenDisplay(display_name))) {
	fprintf(stderr,"%s: Cannot connect to X server %s\n",
		progname,XDisplayName(display_name));
	exit(-1);
    }

    screen_num= DefaultScreen(*display);
    /* I'd rather not use a "simple" window, I think ...
       I want to get rid of sizing gadgets !!! */
    *win=XCreateSimpleWindow(*display,RootWindow(*display,screen_num),0,0,
			     MAX_WINDOW_WIDTH+156,MAX_WINDOW_HEIGHT,
			     border_width,BlackPixel(*display,screen_num),
			     BlackPixel(*display,screen_num));
    if(!XGetIconSizes(*display, RootWindow(*display,screen_num),
		     &size_list,&count))
	fprintf(stderr,"%s: Window manager didn't set icon sizes"
		" - using default.\n",progname);
    else {
	/* Pick an icon size close to these values (or some shite) */
    }
    icon_pixmap =XCreateBitmapFromData(*display,*win,icon_bitmap_bits,
				       icon_bitmap_width,icon_bitmap_height);
    size_hints->flags = PPosition | PSize | PMinSize | PMaxSize;
    size_hints->min_width=MAX_WINDOW_WIDTH+156;
    size_hints->min_height=MAX_WINDOW_HEIGHT;
    size_hints->max_width=MAX_WINDOW_WIDTH+156;
    size_hints->max_height=MAX_WINDOW_HEIGHT;

    if(!XStringListToTextProperty(&window_name,1,&windowName)) {
	fprintf(stderr,"%s: structure allocation for windowName failed.\n",
		progname);
	exit(-1);
    }
    if(!XStringListToTextProperty(&icon_name,1,&iconName)) {
	fprintf(stderr,"%s: structure allocation for iconName failed.\n",
		progname);
	exit(-1);
    }
    
    wm_hints->initial_state = NormalState;
    wm_hints->input = True;
    wm_hints->icon_pixmap = icon_pixmap;
    wm_hints->flags = StateHint | IconPixmapHint | InputHint;

    class_hints->res_name = progname;
    class_hints->res_class = "BasicWin";

    XSetWMProperties(*display,*win,&windowName,&iconName,argv,argc,
		     size_hints,wm_hints,class_hints);
    
    XSelectInput(*display, *win, KeyPressMask |
		 ButtonPressMask | StructureNotifyMask);
    /* We wont have to do any-thing for Exposure, because we update so 
       frequently !!! */
    load_font(*display,font_info);
    getGC(*display,*win,gc,*font_info,screen_num);

    PalettePic=Load_PCX("textures/player1.pcx",1);
    if(PalettePic) {
	*OurColours=XDefaultColormap(*display,DefaultScreen(*display));
	if(XAllocColorCells(*display,*OurColours,True,planemasks,4,pixels, 12)) {
	    SetPalette3(*display,*OurColours,PalettePic->Palette,pixels[0],192);
	} else {
	    fprintf(stderr,"Couldn't get colours\n");
        *OurColours=XCopyColormapAndFree(*display,*OurColours);
        if(*OurColours) {
            XSetWindowColormap(*display,*win,*OurColours);
            XAllocColorCells(*display, *OurColours, True, planemasks, 4,
                            pixels, 16);
            pixels[0]=48; // Skip 48 colours.
            SetPalette3(*display, *OurColours, PalettePic->Palette,
                    pixels[0], 192);
		}
 
	}
	FreePic(PalettePic);
    } else {
	fprintf(stderr,"Couldn't find palette\n");
    }
    XMapWindow(*display,*win);
}

void XXXXGetFilename(char *buff)
{
	int len;
	fprintf(stdout,"Enter filename to save to\n");
	fgets(buff,28,stdin);
	buff[len=strlen(buff)-1]=0;  /* chop off the newline char */
	if(len==0) {
		strcpy(buff,"new.ddc");
	} else if(len<5) {
		buff[len]='.';
		buff[len+1]='d';
		buff[len+2]='s';
		buff[len+3]='o';
		buff[len+4]=0;
	} else if((buff[len-1]!='o') || (buff[len-2]!='s') ||
		(buff[len-3]!='d') || (buff[len-4]!='.')) {
		buff[len]='.';
		buff[len+1]='d';
		buff[len+2]='s';
		buff[len+3]='o';
		buff[len+4]=0;
	}
	fprintf(stdout,"Opening \"%s\"",buff);
}

#define TransUp(con) con->YTrans-=5;
#define TransDown(con) con->YTrans+=5;
#define TransLeft(con) con->XTrans-=5;
#define TransRight(con) con->XTrans+=5;

void RotateSegment(struct ControlInfo *Controls,int Angle)
{
	switch(Controls->ViewWindow) {
		case PLAN_WIN:
			Controls->ActiveObject->CurrYAng=(Controls->ActiveObject->CurrYAng+Angle) & 127;
			break;
		case SIDE_WIN:
			Controls->ActiveObject->CurrXAng=(Controls->ActiveObject->CurrXAng+Angle) & 127;
			break;
		case ELEV_WIN:
			Controls->ActiveObject->CurrZAng=(Controls->ActiveObject->CurrZAng+Angle) & 127;
			break;
	}
}

void 
LoadSegment(Dungeon *dung,struct ControlInfo *Controls,char *fname)
{
	int i;
	for ( i=0 ;i< dung->NumPoints;i++) {
		(dung->Points[0])[i]*=Controls->ScaleFactor;
		(dung->Points[1])[i]*=Controls->ScaleFactor;
		(dung->Points[2])[i]*=Controls->ScaleFactor;
	}
	Controls->ScaleFactor=1;
	LoadNewBit(dung,Controls->ActiveObject,fname);
}

int 
PointsInPoly(Polygon *p,int start,int end)
{
    int i;
    for(i=start;i<end;i++) {
        if((p->Points[0]==i) || (p->Points[1]==i) ||
        (p->Points[2]==i) || (p->Points[3]==i) ||
        (p->Points[4]==i)) {
            fprintf(stdout,"s:%d, e:%d, [%d,%d,%d,%d,%d] ",start,end,p->Points[0],p->Points[1],
                                                    p->Points[2],p->Points[3],p->Points[4]);
            fprintf(stdout,"-gone\n");
            return(1);
        } 
    }
    return(0);
}


void 
DeleteSegment(Dungeon *dung,Segment *Kill,struct ControlInfo *Controls)
{
    int i,j;
    for(i=0;i<5;i++) {
        if(Kill->Next[i]) {
            fprintf(stdout,"Wont delete\n");
            return;
        }
    }
    fprintf(stdout,"Will delete\n");
    for(i=0;i<5;i++) {
        if(Kill->Prev->Next[i]==Kill) {
            Kill->Prev->Next[i]=NULL;
            for(j=i+1;j<4;j++) {
                Kill->Prev->Next[j]=Kill->Prev->Next[j+1];
            }
            Kill->Prev->Next[4]=NULL;
        }
    }
    // Shift Points back. 
    for(i=Kill->Poffset;i<dung->NumPoints-Kill->Numpoints;i++) {
        (dung->Points[0])[i]= (dung->Points[0])[i+Kill->Numpoints];
        (dung->Points[1])[i]= (dung->Points[1])[i+Kill->Numpoints];
        (dung->Points[2])[i]= (dung->Points[2])[i+Kill->Numpoints];
    }
    // Reduce numpoints.
    dung->NumPoints-=Kill->Numpoints;
    // Kill all polygons (for those points) and reduce numpolys.
    for(i=0;i<dung->NumPolygons;i++) {
        if(PointsInPoly(dung->PolygonArray[i],Kill->Poffset,Kill->Poffset+Kill->Numpoints)) {
            Controls->ActivePoly=i;
            DeletePolygon(dung,Controls);
            i--;
        }
    }
    for(i=0;i<dung->NumPolygons;i++) {
        for(j=0;j<5;j++) {
            if(dung->PolygonArray[i]->Points[j]>=Kill->Poffset) {
                dung->PolygonArray[i]->Points[j]-=Kill->Numpoints;
            }
        }
    }
    for(i=0;i<dung->NumObjects;i++) {
        if(dung->ObjectArray[i]->Poffset>=Kill->Poffset+Kill->Numpoints) {
            dung->ObjectArray[i]->Poffset-=Kill->Numpoints;
        }
    }
    // Free Object.
}

void 
ToggleMotionEditor(Dungeon *dung,struct ControlInfo *Controls,Display *display,
						struct Button ControlButtons[])
{
   	Controls->ActiveObject=dung->ObjectArray[0];
    Controls->Mode=1;
	Controls->Flags= (Controls->Flags & 0xFFFFFF7D) | 0x02;
    Controls->MotionEditor^=1;        
	Controls->FullRedraw=1;
	if(Controls->Flags & 32) {
		AffectButtons(display,ControlButtons,KEY_B,Controls);
		Controls->Flags-=32;
	}
	if(Controls->Flags & 16) {
		AffectButtons(display,ControlButtons,KEY_V,Controls);
		Controls->Flags-=16;
	}
	if(Controls->Flags & 8) {
		AffectButtons(display,ControlButtons,KEY_C,Controls);
		Controls->Flags-=8;
	}
	if(Controls->Zoomed) {
		AffectButtons(display,ControlButtons,KEY_J,Controls);
		Controls->Zoomed=0;
	}
}

void 
EdLoadMoves(Display *display,Window win,GC gc,int BasePix,Dungeon *dung,XImage *back)
{
	int stat;
	char name[50]="snake.ddm";
	dung->Moves=MyMalloc(sizeof(struct Bigmove **),"loadbm");
	if(dung->Moves) {
		stat=RequestFilename(display,win,gc,name,"Load Move",0,BasePix,".ddm",1);
		if(stat) {
			dung->Moves[0]=LoadMoves(name);
			if(!dung->Moves[0]) {
				XPutImage(display,win,gc,back,0,0,156,0,MAX_WINDOW_WIDTH,MAX_WINDOW_HEIGHT);
				XBell(display,ERROR_VOLUME);
				MessageBox(display,win,gc,"bollix-moves-load",BasePix);
			}
		} else {
            dung->Moves[0]=NULL;
		}
	}
}
void 
SetupControls(Display *display,Window win,struct Button Controls[],
			  int PaletteOffset,GC gc,struct ControlInfo control_info)
{
	int k=1,i,j;
	char filename[25];
	char ButtonTypes[]= { 
		0,0,0,0,1,
			1,1,1,1,
			1,1,1,1,
			0,0,0,0,
			1,1,1,0,
			0,0,0,0,
			0,0,0,0,
			0,0,0,0,
			1,0,0,0,
			0,1,1,1
	};

	Controls[0].ButtonWin=XCreateSimpleWindow(display,win,
							0,0,156,MAX_WINDOW_HEIGHT,0,
							DefBlackPixel(display),PaletteOffset+MID_GRAY);
	//Controls[0].ButtonWin=win;
	// Make Area around buttons "PaletteOffset+MID_GRAY"
	//XSetForeground(display,gc,PaletteOffset+MID_GRAY);
	//XSetBackground(display,gc,PaletteOffset+MID_GRAY);
	//XClearArea(display,win,MAX_WINDOW_WIDTH,0,156,MAX_WINDOW_HEIGHT,False);
	for(j=0;j<10;j++) {
		for(i=0;i<4;i++) {
			sprintf(filename,"data/buttons/%02du.pcx",k);
			AddButton(display,&Controls[k],8+(i*36),8+(j*36),32,32,
					  filename,15,
					  PaletteOffset,Controls[0].ButtonWin,gc,ButtonTypes[k]);
			k++;
		}
	}
	Radio4(Controls,5,6,7,8);
	Radio4(Controls,9,10,11,12);
	Radio3(Controls,17,18,19);
	XMapWindow(display,Controls[0].ButtonWin);
	DrawTextBox(display,Controls[0].ButtonWin,gc,PaletteOffset+MID_GRAY,8,384,140,300);

	XSync(display,False);
}

int 
ButtonReact(Display *display,GC gc,XEvent *report,struct Button *button)
{
	int ret=0,i;
	switch(report->type) {
		case ButtonPress: {
			if(button->Flags & 4) {
				XBell(display,ERROR_VOLUME);
			}
			switch(button->Flags) {
				case 0: {
					button->Pressed=1;
					XSetWindowBackgroundPixmap(display,button->ButtonWin,button->DownPix);
					XClearWindow(display,button->ButtonWin);
    				XSelectInput(display, button->ButtonWin, ButtonPressMask|ButtonReleaseMask|LeaveWindowMask);
					XSync(display,False);
					break;
				}
				case 1: {
					if(!(button->Pressed)) {
						button->Pressed=1;
						XSetWindowBackgroundPixmap(display,button->ButtonWin,button->DownPix);
						XClearWindow(display,button->ButtonWin);
						for(i=0;i<4;i++) {
							if(button->radio[i]){
								if(button->radio[i]->Pressed) {
									button->radio[i]->Pressed=0;
									XSetWindowBackgroundPixmap(display,button->radio[i]->ButtonWin,button->radio[i]->UpPix);
									XClearWindow(display,button->radio[i]->ButtonWin);
								}
								//Release me if i'm down.
							}
						}
					} else {
						if(button->radio[0]) {
							break;
						}
						button->Pressed=0;
						XSetWindowBackgroundPixmap(display,button->ButtonWin,button->UpPix);
						XClearWindow(display,button->ButtonWin);
					}
					ret=1;
					break;
				}
				case 2: {
					button->Pressed=1;
					XSetWindowBackgroundPixmap(display,button->ButtonWin,button->DownPix);
					XClearWindow(display,button->ButtonWin);
    				XSelectInput(display, button->ButtonWin, ButtonPressMask|ButtonReleaseMask|LeaveWindowMask);
					XSync(display,False);
					ret=1;
					break;
				}
			}
			break;
		}
		case ButtonRelease: {
			if(button->Pressed) {
				switch(button->Flags) {
					case 0: {
						ret=1;
						button->Pressed=0;
						XSetWindowBackgroundPixmap(display,button->ButtonWin,button->UpPix);
						XClearWindow(display,button->ButtonWin);
    					XSelectInput(display, button->ButtonWin, ButtonPressMask|ButtonReleaseMask);
						XSync(display,False);
						break;
					}
					case 1: {
						break;
					}
					case 2: {
						ret=1;
						button->Pressed=0;
						XSetWindowBackgroundPixmap(display,button->ButtonWin,button->UpPix);
						XClearWindow(display,button->ButtonWin);
    					XSelectInput(display, button->ButtonWin, ButtonPressMask|ButtonReleaseMask);
						XSync(display,False);
						break;
					}
				}
			}
			break;
		}
		case LeaveNotify: {
			if(button->Pressed) {
				if(button->Flags==2) {
					ret=1;
				}
				XSetWindowBackgroundPixmap(display,button->ButtonWin,button->UpPix);
				XClearWindow(display,button->ButtonWin);
				button->Pressed=0;
    			XSelectInput(display, button->ButtonWin, ButtonPressMask|ButtonReleaseMask);
				XSync(display,False);
			} else {
				fprintf(stdout,"bug (%08X)\n",(int)button);
			}
			break;
		}
	}
	return(ret);
}

int 
ProcessControlEvent(Display *display,GC gc,XEvent *report,
					struct Button ControlButtons[])
{
	int i=1,found=0;
	int ret=0;
	while(ControlButtons[i].ButtonWin && !found) {
		/* try all buttons until either found or no more left */
		if(report->xany.window==ControlButtons[i].ButtonWin) {
			if(ButtonReact(display,gc,report,&ControlButtons[i])) {
				ret=i;
			}
			found=1;
		}
		i++;
	}
	return(ret);
}


int lookupCED[40]= {
	KEY_Q   , KEY_S   , KEY_L   , KEY_J   ,
	KEY_1   , KEY_2   , KEY_3   , KEY_4   ,
	KEY_FAL1, KEY_FAL2, KEY_FAL3, KEY_FAL4,
	KEY_I   , KEY_O   , KEY_F   , KEY_PLUS,
	KEY_FAL5, KEY_FAL6, KEY_FAL7, KEY_MINUS,
	KEY_P   , KEY_LSQR, KEY_RSQR, KEY_Z,
	KEY_6   , KEY_5   , KEY_7,    KEY_K,
	KEY_NUM_MINUS, KEY_NUM_PLUS, KEY_HASH, KEY_QUOTE,
	KEY_ENTER, KEY_NOT, KEY_COMMA, KEY_DOT,
	KEY_H   , KEY_C   , KEY_V   , KEY_B   
};

int lookupMED[40]= {
	KEY_Q   , KEY_S   , KEY_L   , KEY_NONE,
	KEY_NONE, KEY_NONE, KEY_NONE, KEY_NONE,
	KEY_FAL1, KEY_FAL2, KEY_FAL3, KEY_FAL4,
	KEY_NONE, KEY_NONE, KEY_NONE, KEY_NONE,
	KEY_NONE, KEY_NONE, KEY_NONE, KEY_PLUS,
	KEY_NONE, KEY_NONE, KEY_NONE, KEY_MINUS,
	KEY_NONE, KEY_NONE, KEY_NONE, KEY_K,
	KEY_NUM_MINUS, KEY_NUM_PLUS, KEY_NONE, KEY_NONE,
	KEY_ENTER, KEY_NOT, KEY_COMMA, KEY_DOT,
	KEY_H   , KEY_C   , KEY_V   , KEY_B   
};

int DoControls(Dungeon *dung,Display *display,Window win,GC gc,XEvent *report,
				struct Button ControlButtons[], struct ControlInfo *Controls,
				Segment *world,int PaletteOffset,XImage *MyImage)
{
	int ButtonHit;
	/* lookup table, says what key to fake for each button */
	ButtonHit=ProcessControlEvent(display,gc,report,ControlButtons);
	if(ButtonHit) {
		switch(Controls->MotionEditor) {
			case 1: return(DoKeysMED(dung,display,win,gc,lookupMED[ButtonHit-1],Controls,
								   world, PaletteOffset,ControlButtons,MyImage));
				break;
			case 0: return(DoKeysCED(dung,display,win,gc,lookupCED[ButtonHit-1],Controls,
								   world, PaletteOffset,ControlButtons,MyImage));
				break;
		}
	}
	return(0);
}

void 
AffectButton(Display *display,struct Button *button)
{
	int i;
	if(button->Flags==1) {
		if(button->Pressed) {
			if(button->radio[0]) return;
			button->Pressed=0;
			XSetWindowBackgroundPixmap(display,button->ButtonWin,button->UpPix);
			XClearWindow(display,button->ButtonWin);
		} else {
			button->Pressed=1;
			XSetWindowBackgroundPixmap(display,button->ButtonWin,button->DownPix);
			XClearWindow(display,button->ButtonWin);
			for(i=0;i<4;i++) {
				if(button->radio[i]){
					if(button->radio[i]->Pressed) {
						button->radio[i]->Pressed=0;
						XSetWindowBackgroundPixmap(display,button->radio[i]->ButtonWin,button->radio[i]->UpPix);
						XClearWindow(display,button->radio[i]->ButtonWin);
					}
					//Release me if i'm down.
				}
			}
		}
	}
}

void 
AffectButtons(Display *display,struct Button Buttons[],char key,
			  struct ControlInfo *Controls)
{
	int i=0;
	
	while(i<40) {
		if(key==Controls->lookupkeys[i]) {
			AffectButton(display,&Buttons[i+1]);
		}
		i++;
	}
}

/* For buttons which don't corespond to keys */
void 
AffectSpecialButtons(Display *display,Dungeon *d,struct Button Buttons[],
					 struct ControlInfo *Controls,char key)
{
	switch(key) {
		case KEY_X: 
			AffectButton(display,&Buttons[9+Controls->ShowMode]);
			break;
    	case KEY_G: 
			if(Controls->ActivePoly<d->NumPolygons) {
				AffectButton(display,&Buttons[17+d->PolygonArray[Controls->ActivePoly]->Style]);
			}
			break;
	}
}


void 
CheckRotations(struct ControlInfo *Controls,Segment *Torso)
{
	if (Controls->Flags & 1) {
	    if (Torso->CurrXAng) Torso->CurrXAng--;
		if (Torso->CurrYAng) Torso->CurrYAng--;
		if (Torso->CurrZAng) Torso->CurrZAng--;
		    
		if (((Torso->CurrXAng) | (Torso->CurrYAng) | (Torso->CurrZAng))==0) 
			Controls->Flags &=~1;
	} else {
		if(Controls->Flags & 8) 
			Torso->CurrXAng=(Torso->CurrXAng + 1) & 0x7F;
		if(Controls->Flags & 16)
			Torso->CurrYAng=(Torso->CurrYAng + 1) & 0x7F;
		if(Controls->Flags & 32)
			Torso->CurrZAng=(Torso->CurrZAng + 1) & 0x7F;
	}
}

void 
MoveToScreen(Dungeon *dung,struct ControlInfo *Controls)
{
    int i;
    float scalefactor;
    int xt,yt,zt;
	int NumP=dung->NumPoints;
    xt=Controls->XTrans;
    yt=Controls->YTrans;
    zt=Controls->YTrans;
    scalefactor=Controls->ScaleFactor;
 
    for (i = 0; i < NumP; i++) {
        (dung->newpts[0])[i]*=scalefactor;
        (dung->newpts[1])[i]*=scalefactor;
        (dung->newpts[2])[i]*=scalefactor;
 
#ifdef PERSPECTIVE
        (dung->newpts[0])[i] = (((dung->newpts[0])[i] * 1000) / (zt - (dung->newpts[2])[i])) + xt;
        (dung->newpts[1])[i] = (((dung->newpts[1])[i] * 1000) / (zt - (dung->newpts[2])[i])) + yt;
#else
        zt = zt;
        (dung->newpts[0])[i] += xt;
        (dung->newpts[1])[i] += yt;
#endif
    }
}

int
IsHitPoint(int pt,Dungeon *d)
{
	int i;
	for(i=0;i<d->NumHits[0];i++) {
		if(pt==d->Hits[0][i]) {
			return(5);
		}
	}
	for(i=0;i<d->NumColls[0];i++) {
		if(pt==d->Colls[0][i]) {
			return(3);
		}
	}
	return(0);
}

void MakeHighlights(Dungeon *dung,struct ControlInfo *Controls,
		int dots[],int BasePix)
{
	int i,j;
		/* Make all normal */
	for(j=0;j<dung->NumPoints;j++) {
	    dots[j]=NORMAL_DOT+IsHitPoint(j,dung);
		if(j==dung->feet[0][0] || j==dung->feet[0][1]) {
			dots[j]=115+BasePix;
		}
	}
	if((Controls->Flags & 0x82)==0x02) {
	    for(i=Controls->ActiveObject->Poffset; i<Controls->ActiveObject->Poffset+Controls->ActiveObject->Numpoints;i++) {
			dots[i]=HIGHLIGHT_DOT;
	    }
	} else if ((Controls->Flags & 0x82)==0x80) {
	    /* highlight this poly */
	    if(dung->NumPolygons) {
			for(i=0;i<4;i++) {
			    dots[dung->PolygonArray[Controls->ActivePoly]->Points[i]]= HIGHLIGHT_DOT;
			}
			dots[dung->PolygonArray[Controls->ActivePoly]->CentrePt]=HOT_DOT;
	    }
	} else {
	    dots[Controls->ActivePoint]=HIGHLIGHT_DOT;
	}
}

void
FreeMoveButtons(Display *display,struct ControlInfo *Controls)
{
	int i;
	for(i=0;i<20;i++) {
		XUnmapWindow(display,Controls->MoveButtons[i+1].ButtonWin);
		XDestroyWindow(display,Controls->MoveButtons[i+1].ButtonWin);
	}
	MyFree(Controls->MoveButtons,"movebuttons");
}


int 
DoKeysALL(Display *display,Window win,GC gc,Dungeon *dung,
		  struct ControlInfo *Controls, Segment *world,uchar keycode, 
		  int BasePix,XImage *MyImage,struct Button ControlButtons[])
{
	switch(keycode) {
		case KEY_NOT:		GetHelp(display,win,gc,Controls,ControlButtons,BasePix);
			break;
		case KEY_Q:			return(2);
			break;
		case KEY_MINUS: 	DoMinusPressed(dung,Controls);
				break;
		case KEY_PLUS: 		DoPlusPressed(dung,Controls);
				break;
		case KEY_R: 		RoteWorldZ(world);
				break;
		case KEY_T: 		RoteWorldX(world);
				break;
		case KEY_Y: 		RoteWorldY(world);
				break;
		case KEY_H: 		Controls->Flags |= 1;  /* home=1; bit 0 */
				break;
		case KEY_X: 		SetViewMode(Controls,(Controls->ShowMode+1)%4);
				break;
		case KEY_C:			Controls->Flags ^=8;
				break;
		case KEY_V:			Controls->Flags ^=16;
				break;
		case KEY_B: 		Controls->Flags ^=32;
				break;
        case KEY_HOME:		TransUp(Controls);
				break;	
		case KEY_DELETE:	TransLeft(Controls);
				break;
		case KEY_END:		TransDown(Controls);
				break;		
		case KEY_PGDN:		TransRight(Controls);
				break;		
        case KEY_ENTER: ZeroObjectAngles(dung);	
                            InitMove(dung);
                            ToggleMotionEditor(dung,Controls,display,ControlButtons);
							ControlButtons[4].Flags^=4;
							if(Controls->MotionEditor) {
								DrawMotionPanel(display,win,gc,MyImage,dung,Controls,BasePix,1);
								XPutImage(display,win,gc,MyImage,0,0,156,0,
										  MAX_WINDOW_WIDTH,MAX_WINDOW_HEIGHT);
								Controls->lookupkeys=lookupMED;
								CreateMoveButtons(display,win,gc,Controls,BasePix);
								XSelectInput(display,win,ExposureMask|KeyPressMask|ButtonPressMask);
							} else {
								FreeMoveButtons(display,Controls);
								XSelectInput(display,win,KeyPressMask|ButtonPressMask);
								Controls->lookupkeys=lookupCED;
							}
                break;
		case KEY_COMMA:		RotateSegment(Controls,-1);
				break;
		case KEY_DOT:		RotateSegment(Controls,1);
				break;
		case KEY_F2:		ZeroObjectAngles(dung);
				break;
        case KEY_FAL1: 		SetViewMode(Controls,0);
				break;
		case KEY_FAL2: 		SetViewMode(Controls,1);
				break;
		case KEY_FAL3: 		SetViewMode(Controls,2);
				break;
		case KEY_FAL4: 		SetViewMode(Controls,3);
				break;
		default:			return(0);  // No key
				break;
	}
	return(1);	// A Key pressed
}

void
ZoomView(struct ControlInfo *Controls)
{
	Controls->Zoomed ^=1;
}

int
DoKeysCED(Dungeon *dung,Display *display,Window win,GC gc,uchar keycode,
        struct ControlInfo *Controls,Segment *world,int PaletteOffset,
        struct Button ControlButtons[],XImage *MyImage)
{
	char tmpstr[100];
	int quiting;
	quiting=DoKeysALL(display,win,gc,dung,Controls,world,keycode,PaletteOffset,MyImage,ControlButtons);
	if(!quiting) {
		switch(keycode) {
			case KEY_1: 		Controls->ViewWindow=THREE_WIN;
					break;
			case KEY_2: 		Controls->ViewWindow=PLAN_WIN;
					break;
			case KEY_3:			Controls->ViewWindow=SIDE_WIN;
					break;
			case KEY_4:			Controls->ViewWindow=ELEV_WIN;
					break;
			case KEY_5:			if(Controls->Mode==0) {
									HitCollPoint(dung->Hits[0],&(dung->NumHits[0]),Controls->ActivePoint);
								} else {
									XBell(display,ERROR_VOLUME);
								}
					break;
			case KEY_6:			if(Controls->Mode==0) {
									HitCollPoint(dung->Colls[0],&(dung->NumColls[0]),Controls->ActivePoint);
								} else {
									XBell(display,ERROR_VOLUME);
								}
					break;
			case KEY_7:			if(Controls->Mode==0) {
									dung->feet[0][1]=dung->feet[0][0];
									dung->feet[0][0]=Controls->ActivePoint;
								} else {
									XBell(display,ERROR_VOLUME);
								}
					break;
			case KEY_I: 		AddPoint(dung,Controls->ActiveObject); 
					break;
			case KEY_O: 		AddObjectWrap(dung,Controls);
					break;
			case KEY_P:         if(Controls->Mode==0) {
									AddPolyPoint(dung,Controls);
								} else {
									XBell(display,ERROR_VOLUME);
								}
					break;
			case KEY_LSQR:		if(Controls->Mode==2) {
									DeletePolyPoint(Controls);
								} else {
									XBell(display,ERROR_VOLUME);
								}
					break;
			case KEY_RSQR: 		if(Controls->Mode==2) {
									DeletePolygon(dung,Controls);
								} else {
									XBell(display,ERROR_VOLUME);
								}
					break;
			case KEY_S: 		DoSave(dung,display,win,gc,Controls,PaletteOffset);
					break;
			case KEY_F:         DeleteSegment(dung,Controls->ActiveObject,Controls);
					break;
			case KEY_G:         if(Controls->Mode==2) {
									AdvanceStyle(dung,Controls);
								} else {
									XBell(display,ERROR_VOLUME);
								}
					break;
			case KEY_J:			ZoomView(Controls);
					break;
			case KEY_K:			if(Controls->Mode==2) {
									RotateTexture(dung,Controls->ActivePoly);
								} else {
									XBell(display,ERROR_VOLUME);
								}
					break;
			case KEY_L:			strcpy(tmpstr,"HOHOHOHO.ddc");
								if(RequestFilename(display,win,gc,tmpstr,
										"Save File...",0,PaletteOffset,".ddc",1)) { 
                                	LoadSegment(dung,Controls,tmpstr);
								} else {
                                	fprintf(stdout,"Not done\n");
                            	}
					break;
			case KEY_QUOTE: 	Controls->ScaleFactor=MAX(Controls->ScaleFactor-0.1,0.1);
					break;
			case KEY_HASH: 		Controls->ScaleFactor=MIN(Controls->ScaleFactor+0.1,5);
					break;
			case KEY_Z: 		CyclePickMode(Controls);
					break;
        	case KEY_FAL5:      SetStyle(dung,Controls,0);
                	break;
        	case KEY_FAL6:      SetStyle(dung,Controls,1);
                	break;
        	case KEY_FAL7:      SetStyle(dung,Controls,2);
                	break;
			case KEY_NUM_MINUS: if(Controls->Mode==2) {
									switch(dung->PolygonArray[Controls->ActivePoly]->Style){
										case 0:PreviousColour(dung,Controls);break;
										case 1:PreviousTexture(dung,Controls);break;
										case 2:PreviousColourGroup(dung,Controls);break;    
										default:break;
									}
								} else {
									XBell(display,ERROR_VOLUME);
								}
					break;
			case KEY_NUM_PLUS:  if(Controls->Mode==2) {
									switch(dung->PolygonArray[Controls->ActivePoly]->Style){
										case 0:NextColour(dung,Controls);break;
										case 1:NextTexture(dung,Controls);break;
										case 2:NextColourGroup(dung,Controls);break;    
										default:break;
                            		}
								} else {
									XBell(display,ERROR_VOLUME);
								}
					break;
			case KEY_LEFT:
				switch(Controls->ViewWindow) {
				case ELEV_WIN:
				case PLAN_WIN:
					(dung->Points[0])[Controls->ActivePoint]--;
					break;
				case SIDE_WIN:
					(dung->Points[2])[Controls->ActivePoint]--;
					break;
				}
				break;
			case KEY_RIGHT:  /* RIGHT */
				switch(Controls->ViewWindow) {
				case ELEV_WIN:
				case PLAN_WIN:
					(dung->Points[0])[Controls->ActivePoint]++;
					break;
				case SIDE_WIN:
					(dung->Points[2])[Controls->ActivePoint]++;
					break;
				}
				break;
			case KEY_UP:  /* UP */
				switch(Controls->ViewWindow) {
				case ELEV_WIN:
				case SIDE_WIN:
					(dung->Points[1])[Controls->ActivePoint]--;
					break;
				case PLAN_WIN:
					(dung->Points[2])[Controls->ActivePoint]--;
					break;
				}
				break;
			case KEY_DOWN:  /* DOWN */
				switch(Controls->ViewWindow) {
				case ELEV_WIN:
				case SIDE_WIN:
					(dung->Points[1])[Controls->ActivePoint]++;
					break;
				case PLAN_WIN:
					(dung->Points[2])[Controls->ActivePoint]++;
					break;
				}
				break;
			default:		XBell(display,ERROR_VOLUME);
							fprintf(stdout,"%d\n",keycode);
					break;
		}
		return(0);
	}
	return(quiting-1);
}

int
DoKeysMED(Dungeon *dung,Display *display,Window win,GC gc,uchar keycode,
        struct ControlInfo *Controls,Segment *world,int PaletteOffset,
        struct Button ControlButtons[],XImage *MyImage)
{
	int quiting;
	quiting=DoKeysALL(display,win,gc,dung,Controls,world,keycode,PaletteOffset,MyImage,ControlButtons);
	if(!quiting) {
		switch(keycode) {
			case KEY_L:			EdLoadMoves(display,win,gc,PaletteOffset,dung,MyImage);
								DrawMotionPanel(display,win,gc,MyImage,dung,Controls,PaletteOffset,1);
					break;
			case KEY_NUM_MINUS:	PrevMove(dung,Controls);
								DrawMotionPanel(display,win,gc,MyImage,dung,Controls,PaletteOffset,1);
					break;
			case KEY_NUM_PLUS:	NextMove(dung,Controls);
								DrawMotionPanel(display,win,gc,MyImage,dung,Controls,PaletteOffset,1);
					break;
			case KEY_F5:		InitMove(dung);
					break;
			case KEY_F6:		AddPhase(dung,Controls->MoveNum);
					break;
			case KEY_S:			DoMovesSave(display,win,gc,PaletteOffset,dung);
					break;
			case KEY_F8:		Controls->NewMoveTime=-1;
								TestMove((dung->Moves[0])[Controls->MoveNum],0,dung->ObjectArray);
					break;
			case KEY_N:			if(Controls->MoveXCurs) Controls->MoveXCurs--; // MoveXCurs
					break;
			case KEY_M:			Controls->MoveXCurs++; // MoveXCurs
					break;
			case KEY_SLASH:		AlterWaiter(dung,Controls->ActiveObject->ID,Controls->MoveNum,Controls->MoveXCurs,1);
					break;
			case KEY_BSLASH:	AlterWaiter(dung,Controls->ActiveObject->ID,Controls->MoveNum,Controls->MoveXCurs,-1);
					break;
			case KEY_1:         Controls->ViewWindow=THREE_WIN;
					break;
			case KEY_2:         Controls->ViewWindow=PLAN_WIN;
					break;
			case KEY_3:         Controls->ViewWindow=SIDE_WIN;
               		break;
			case KEY_4:         Controls->ViewWindow=ELEV_WIN;
					break;
			case KEY_7:			DeleteMoveBit(display,dung,Controls->MoveNum,Controls->ActiveObject->ID,Controls->MoveXCurs);
								
					break;
			case KEY_8:			DeleteBigmove(display,dung,Controls->MoveNum,Controls->ActiveObject->ID);
					break;
			case KEY_9:			//DeleteFullMove(dung,Controls->MoveNum,Controls->ActiveObject->ID,Controls->MoveXCurs);
					break;
			case KEY_U:			if(Controls->SaveMoveTime) {
									Controls->SaveMoveTime--;
								}
					break;
			case KEY_I:			Controls->SaveMoveTime++;
					break;
			case KEY_O:			Controls->NewMoveTime=Controls->SaveMoveTime;
								ZeroObjectAngles(dung);
								// ClearMove
								TestMove((dung->Moves[0])[Controls->MoveNum],0,dung->ObjectArray);
					break;
			default:			XBell(display,ERROR_VOLUME);
					break;
		}
	       
		return(0);
	}
	return(quiting-1);
}

int
mainloopMED(Display *display,Window win,GC gc,XImage *MyImage,Dungeon *dung,
			struct ControlInfo *Controls,int BasePix,
			struct Button ControlButtons[])
{
	XEvent report;
	int quiting=0;      
	CheckRotations(Controls,Torso);
	DrawFilledBox(MyImage,3,3,(MAX_WINDOW_WIDTH)/2-4,MAX_WINDOW_HEIGHT/2+10,
		      0);

	UpdateObjects(dung,Torso);
	MoveToScreen(dung,Controls);

	DoMotionTimed(dung->ObjectArray[0],1000,Controls);
	DrawMan2(Controls,dung,MyImage,BasePix);

	MakeHighlights(dung,Controls,dots,BasePix);
    //XPutImage(display,win,gc,MyImage,0,0,156,0,MAX_WINDOW_WIDTH/2,
	  				//MAX_WINDOW_HEIGHT/2);
    DisplayStatus(display,ControlButtons[0].ButtonWin,gc,Controls,BasePix,dung);

	if(XCheckMaskEvent(display,ButtonPress|KeyPress|ButtonRelease|LeaveNotify,&report)) {
		Controls->FullRedraw=1;
    	if(report.xany.window!=win) {
        	/* For a control button */
            quiting=DoControls(dung,display,win,gc,&report,ControlButtons,
								   Controls,Torso,BasePix,MyImage);
			TestMoveButtons(display,win,gc,dung,MyImage,BasePix,&report,Controls);
			//DrawMotionPanel(display,win,gc,MyImage,dung,Controls,BasePix,0);
        } else 	{
			switch(report.xany.type) {
				case Expose:
					// Do Othe XPutImage()s HERE 
					// XXXX
					fprintf(stdout,"Putit\n");
					break;
				case KeyPress:
					quiting=DoKeysMED(dung,display,win,gc,report.xkey.keycode,Controls,
									Torso,BasePix,ControlButtons,MyImage);
					AffectButtons(display,ControlButtons,report.xkey.keycode,Controls);
	       			AffectSpecialButtons(display,dung,ControlButtons,Controls,
									 	report.xkey.keycode);
					DrawMotionPanel(display,win,gc,MyImage,dung,Controls,BasePix,0);
					break;
			}
		}
	}
	if(Controls->FullRedraw) {
		Controls->FullRedraw=0;
		XPutImage(display,win,gc,MyImage,0,0,156,0, MAX_WINDOW_WIDTH,
			  	  MAX_WINDOW_HEIGHT);
	} else {
		XPutImage(display,win,gc,MyImage,0,0,156,0, MAX_WINDOW_WIDTH/2,
			  	  MAX_WINDOW_HEIGHT/2+10);
	}
	return(quiting);
}

/*****************************************************************************
 *
 *	PickUpPoint()											PickUpPoint()
 *
 *  Pick up a point to be moved.  Fills details into the MovingPoint struct,
 *	which we will need when the point is dropped.
 *  returns 1 if it picks a point up, and 0 otherwise.
 *
 */

int
PickUpPoint(struct MovingPoint *MovingPt,int x,int y,
			struct ControlInfo *Controls,Dungeon *dung,
			Display *display,struct Button ControlButtons[])
{
    if(SelectPoint(dung,x-156,y,Controls,display,ControlButtons)) {
        fprintf(stdout,"Picked up point: %d\n",Controls->ActivePoint);
        MovingPt->Point=Controls->ActivePoint;
        switch(Controls->ViewWindow) {
            case PLAN_WIN:
                MovingPt->WinX=dung->twoDX[Controls->ActivePoint] + 3*MAX_WINDOW_WIDTH/4;
                MovingPt->WinY=dung->twoDZ[Controls->ActivePoint] + MAX_WINDOW_HEIGHT/4;
                MovingPt->Xchange=&PointsX[Controls->ActivePoint];
                MovingPt->Ychange=&PointsZ[Controls->ActivePoint];
				MovingPt->MouseXMin=MAX_WINDOW_WIDTH/2;
				MovingPt->MouseXMax=MAX_WINDOW_WIDTH;
				MovingPt->MouseYMin=0;
				MovingPt->MouseYMax=MAX_WINDOW_HEIGHT/2;
                break;
            case ELEV_WIN:
                MovingPt->WinX=dung->twoDX[Controls->ActivePoint] + 3*MAX_WINDOW_WIDTH/4;
                MovingPt->WinY=dung->twoDY[Controls->ActivePoint] + 3*MAX_WINDOW_HEIGHT/4;
                MovingPt->Xchange=&PointsX[Controls->ActivePoint];
                MovingPt->Ychange=&PointsY[Controls->ActivePoint];
				MovingPt->MouseXMin=MAX_WINDOW_WIDTH/2;
				MovingPt->MouseXMax=MAX_WINDOW_WIDTH;
				MovingPt->MouseYMin=MAX_WINDOW_HEIGHT/2;
				MovingPt->MouseYMax=MAX_WINDOW_HEIGHT;
                break;
            case SIDE_WIN:
                MovingPt->WinX=dung->twoDZ[Controls->ActivePoint] + MAX_WINDOW_WIDTH/4;
                MovingPt->WinY=dung->twoDY[Controls->ActivePoint] + 3*MAX_WINDOW_HEIGHT/4;
                MovingPt->Xchange=&PointsZ[Controls->ActivePoint];
                MovingPt->Ychange=&PointsY[Controls->ActivePoint];
				MovingPt->MouseXMin=0;
				MovingPt->MouseXMax=MAX_WINDOW_WIDTH/2;
				MovingPt->MouseYMin=MAX_WINDOW_HEIGHT/2;
				MovingPt->MouseYMax=MAX_WINDOW_HEIGHT;
                break;
            default:
                break;
        }
		return(1);
	}
	return(0);
}


int
InRange(struct MovingPoint *MovingPt,int x,int y)
{
	x-=156;
	if( (x>MovingPt->MouseXMin) && (x<MovingPt->MouseXMax) && (y>MovingPt->MouseYMin) && 
		 (y<MovingPt->MouseYMax) ) {
		return(1);
	}
	return(0);
}


/*****************************************************************************
 *
 *	DropPoint()											DropPoint()
 *
 *  Right Mouse Button has been pressed, there is a point picked up, this
 *	function will drop the point if it can.  If it can't nothing is done.
 *
 */

int 
DropPoint(struct MovingPoint *MovingPt,int x,int y)
{
// BUGXX: PUT DOWN OUT OF RANGE BUG
	if(InRange(MovingPt,x,y)) {
		*(MovingPt->Xchange) += x-156 - MovingPt->WinX;
		*(MovingPt->Ychange) += y - MovingPt->WinY;
		MovingPt->Point=-1;
		return(1);
	} 
	return(0);
}

int
mainloopCED(Display *display,Window win,GC gc,XImage *MyImage,Dungeon *dung,
			struct ControlInfo *Controls,int BasePix,
			struct Button ControlButtons[],
			struct MovingPoint *MovingPt,Cursor HoldingCursor,
			Cursor NormalCursor)
{

	XEvent report;
	int quiting=0;

	CheckRotations(Controls,Torso);
	ClearScreen(MyImage);

	UpdateObjects(dung,Torso);
	MoveToScreen(dung,Controls);

	//DoMotion(dung->ObjectArray[0],1000);
	DrawMan2(Controls,dung,MyImage,BasePix);

	MakeHighlights(dung,Controls,dots,BasePix);
    DrawAllViews(dung,MyImage,Controls,dots,BasePix);
    DrawWinBox(Controls,MyImage,BasePix);
    XPutImage(display,win,gc,MyImage,0,0,156,0,MAX_WINDOW_WIDTH,
	  				MAX_WINDOW_HEIGHT);
    DisplayStatus(display,ControlButtons[0].ButtonWin,gc,Controls,BasePix,dung);

	if(XCheckMaskEvent(display,ButtonPress|KeyPress|ButtonRelease|LeaveNotify,&report)) {
    	if(report.xany.window!=win) {
        	/* For a control button */
                quiting=DoControls(dung,display,win,gc,&report,ControlButtons,
								   Controls,Torso,BasePix,MyImage);
        } else {
			switch(report.xany.type) {
				case Expose:
					break;
				case KeyPress:
					quiting=DoKeysCED(dung,display,win,gc,report.xkey.keycode,Controls,
									Torso,BasePix,ControlButtons,MyImage);
					AffectButtons(display,ControlButtons,report.xkey.keycode,Controls);
	       			AffectSpecialButtons(display,dung,ControlButtons,Controls,
									 	report.xkey.keycode);
					break;
				case ButtonPress:
                    switch(report.xbutton.button) {
                        case 1:
                            if(MovingPt->Point==-1) {
                                SelectPoint(dung,report.xbutton.x-156, report.xbutton.y,Controls,display,ControlButtons);
                            } else {
                                MovingPt->Point=-1;
                                XDefineCursor(display,win,NormalCursor);
                            }
                            break;
                        case 2:
                            if(MovingPt->Point==-1) {
								if(PickUpPoint(MovingPt,report.xbutton.x,report.xbutton.y,Controls,dung,display,ControlButtons)) {
                                    XDefineCursor(display,win,HoldingCursor);
                           		}
                           	} else {
								if(DropPoint(MovingPt,report.xbutton.x,report.xbutton.y)) {
                                	XDefineCursor(display,win,NormalCursor);
								}
                            }
                            break;
                        default:
                            fprintf(stdout,"Button: %d\n",report.xbutton.button);
                            break;
                    }
					break;
			}
		}
	}
	return(quiting);
}

int 
mainloop(Display *display,Window win,GC gc,XImage *MyImage,Dungeon *dung,
		 struct ControlInfo *Controls,int BasePix,struct Button ControlButtons[])
{
	int quiting=0;
    Cursor HoldingCursor, NormalCursor;
    HoldingCursor=XCreateFontCursor(display,106);
    NormalCursor=XCreateFontCursor(display,132);
	while(!quiting) {
		switch(Controls->MotionEditor) {
			case 1:
				quiting=mainloopMED(display,win,gc,MyImage,dung,Controls,BasePix,ControlButtons);
				break;
			case 0:
				quiting=mainloopCED(display,win,gc,MyImage,dung,Controls,
								BasePix,ControlButtons,&(Controls->MovingPt),
								HoldingCursor, NormalCursor);
				break;
		}
	}
	return(1);
}

void
FreeControls(struct Button ControlButtons[])
{
	//XFreePixMap();  // In a loop....

}


void main(int argc,char **argv)
{
    long pixels[256];
    Display *display;
    Window win;
    int i,quiting;
    uint Frames=0;
    Colormap OurColours;
    GC gc;
    XFontStruct *font_info;
    XImage *MyImage=NULL;
    char *ddc_name="objects/player4.ddc";
	struct ControlInfo Controls = {
		1.0,
		MAX_WINDOW_WIDTH/4, MAX_WINDOW_HEIGHT/4, 1000,
		0,
		THREE_WIN,
		0,
		0,
		NULL,
		0,
		0,
		{ 0,0,0,0,0 },
		0,
		0,
        0,
		0,
		0,
		lookupCED,
    	{ -1, 0, 0, NULL, NULL },
		0,0
	};
	struct Button ControlButtons[50]; /* XXXX: #define please */
    int Ready=0;
	Dungeon *dung;
	//int ButtonHit;

	//Controls.lookupkeys=lookupCED;

    if(argc==2) ddc_name=argv[1];

    ShowVersion();

    if((dung=SetupStuffed(ddc_name,NUM_TEXTURES,pixels[0]))) {
		SetupWindow(&display,&win,argc,argv,&gc,&font_info,pixels,&OurColours);
		SetupControls(display,win,ControlButtons,pixels[0],gc,Controls);
		XSync(display,False);
		AffectButton(display,&ControlButtons[5]);
		AffectButton(display,&ControlButtons[9]);
		AffectButton(display,&ControlButtons[17]);
		NORMAL_DOT=pixels[0]+DARK_GRAY;
		HIGHLIGHT_DOT=pixels[0]+LITE_GREEN;
		HOT_DOT=pixels[0]+MID_YELLOW;
		Frames=0;
		PointsX=dung->Points[0];
		PointsY=dung->Points[1];
		PointsZ=dung->Points[2];
		newptsX=dung->newpts[0];
		newptsY=dung->newpts[1];
		newptsZ=dung->newpts[2];
    	RemapTextures(dung->Textures,pixels[0],NUM_TEXTURES);

		SetupMoves(dung);

    	i=0;
    	Torso=dung->ObjectArray[0];
		Controls.ActiveObject=Torso;
	
	
    	Ready=1;
    	Frames=0;
	
    	MyImage=XGetImage(display,win,0,0,MAX_WINDOW_WIDTH,
				      	MAX_WINDOW_HEIGHT,0xFF,ZPixmap);
    	if(!MyImage) {
			fprintf(stdout,"no image\n");
			exit(-1);
    	}
	
		quiting=mainloop(display,win,gc,MyImage,dung,&Controls,pixels[0],
						ControlButtons);
		FreeControls(ControlButtons);
		if(MyImage) XDestroyImage(MyImage);
	
		XFreeColors(display,OurColours,pixels,8,4);
		// BUGXX: free XCloseWindows or something like it.
	
		XUnloadFont(display,font_info->fid);
		XFreeGC(display,gc);
		XCloseDisplay(display);
		FreeStuff(dung);
   	}
}

void Draw3DPoints(Dungeon *dung,XImage *vscreen)
{
    int i;
    for(i=0;i<dung->NumPoints;i++) {
		DrawPt(vscreen,(dung->newpts[0])[i],(dung->newpts[1])[i],dots[i]);
    }
}

void 
DrawViewWireFrame(Dungeon *dung,Polygon *ply,uchar *vscreen,
					int Xinc, int Yinc, short int ptsA[], short int ptsB[])
{
    int x0,x1,x2,x3,y0,y1,y2,y3;
 
    x0= ptsA[ply->Points[0]];
    y0= ptsB[ply->Points[0]];
    x1= ptsA[ply->Points[1]];
    y1= ptsB[ply->Points[1]];
    x2= ptsA[ply->Points[2]];
    y2= ptsB[ply->Points[2]];
    x3= ptsA[ply->Points[3]];
    y3= ptsB[ply->Points[3]];

    linedraw(x0+Xinc,y0+Yinc,x1+Xinc,y1+Yinc,NORMAL_DOT,vscreen);
    linedraw(x1+Xinc,y1+Yinc,x2+Xinc,y2+Yinc,NORMAL_DOT,vscreen);
    linedraw(x2+Xinc,y2+Yinc,x3+Xinc,y3+Yinc,NORMAL_DOT,vscreen);
    linedraw(x3+Xinc,y3+Yinc,x0+Xinc,y0+Yinc,NORMAL_DOT,vscreen);
 
}

void DrawWireFrame(Dungeon *dung,Polygon *ply, uchar *vscreen)
{
    int x0,x1,x2,x3,y0,y1,y2,y3;
    x0= (dung->newpts[0])[ply->Points[0]];
    y0= (dung->newpts[1])[ply->Points[0]];
    x1= (dung->newpts[0])[ply->Points[1]];
    y1= (dung->newpts[1])[ply->Points[1]];
    x2= (dung->newpts[0])[ply->Points[2]];
    y2= (dung->newpts[1])[ply->Points[2]];
    x3= (dung->newpts[0])[ply->Points[3]];
    y3= (dung->newpts[1])[ply->Points[3]];

	linedraw(x0,y0,x1,y1,NORMAL_DOT,vscreen);
	linedraw(x1,y1,x2,y2,NORMAL_DOT,vscreen);
	linedraw(x2,y2,x3,y3,NORMAL_DOT,vscreen);
	linedraw(x3,y3,x0,y0,NORMAL_DOT,vscreen);
   
}

int 
GetDistEd(Dungeon *dung,int j)
{ 
    int x=1024,y=1024,z=1024; 
    return ((((dung->newpts[0])[dung->SortingPolygons[j]->CentrePt] - x) * 
	     ((dung->newpts[0])[dung->SortingPolygons[j]->CentrePt] - x)) +
	    (((dung->newpts[1])[dung->SortingPolygons[j]->CentrePt] - y) * 
	     ((dung->newpts[1])[dung->SortingPolygons[j]->CentrePt] - y))+
	    (((dung->newpts[2])[dung->SortingPolygons[j]->CentrePt] - z) * 
	     ((dung->newpts[2])[dung->SortingPolygons[j]->CentrePt] - z)));
}

int
 GetNormal(Dungeon *dung,int j)
{     /* calc the z of the normal */
    return ((((dung->newpts[0])[dung->SortingPolygons[j]->Points[0]] - 
	      (dung->newpts[0])[dung->SortingPolygons[j]->Points[1]]) * 
	     ((dung->newpts[1])[dung->SortingPolygons[j]->Points[0]] - 
	      (dung->newpts[1])[dung->SortingPolygons[j]->Points[2]])) - 
	    (((dung->newpts[1])[dung->SortingPolygons[j]->Points[0]] - 
	      (dung->newpts[1])[dung->SortingPolygons[j]->Points[1]]) * 
	     ((dung->newpts[0])[dung->SortingPolygons[j]->Points[0]] - 
	      (dung->newpts[0])[dung->SortingPolygons[j]->Points[2]])));
}

void DrawPolygons2(Dungeon *dung,struct ControlInfo *Controls,XImage *vscreen, 
					int flag,int ActivePt,int basepix,int xoffset, int yoffset)
{
    int j;
    struct Picture_Type *text;
    int dist=0;
    
	if(Controls->Zoomed) {
		if(Controls->ViewWindow!=THREE_WIN) {
			return;
		}
		for(j=0;j<dung->NumPoints;j++) {
		    (dung->newpts[0])[j]<<=1;
		    (dung->newpts[1])[j]<<=1;
		    //		(dung->newpts[2])[j]<<=1;
		}
    }

	Draw3DPoints(dung,vscreen);
    switch(Controls->ShowMode) {
   		 case 0:
			break;
   		 case 1:	
			for(j=0;j<dung->NumPolygons;j++) {
				DrawWireFrame(dung,dung->SortingPolygons[j],vscreen->data);
			}
			break;
   		 case 2:	
			for(j=0;j<dung->NumPolygons;j++) {
			    if (GetNormal(dung,j)>=0) {
					DrawWireFrame(dung,dung->SortingPolygons[j],vscreen->data);
				}
			}
			break;    
   		 case 3:	
			for(j=0;j<dung->NumPolygons;j++) { 
			    if ((GetNormal(dung,j)) > 0) {
				switch(dung->SortingPolygons[j]->Style) {		  
					case 0:
					    ColourDrawRectangle(dung->SortingPolygons[j]->Points, (uchar *) (vscreen->data), 
							       (dung->newpts[0]), (dung->newpts[1]),
							       dung->SortingPolygons[j]->Color+basepix); 
					    break;
					case 1:
					    text=dung->Textures[dung->SortingPolygons[j]->Texture];
					    NewDrawRectangle(dung->SortingPolygons[j]->Points,vscreen->data,text,(dung->newpts[0]),
							     (dung->newpts[1]));
					    break;
					case 2:
					    dist= GetDistEd(dung,j);
			
					    /* PICK A NUMBER until ColOffset < GROUP_SIZE */		    
			
					    dung->SortingPolygons[j]->ColOffset =GetOffset(dist);	
					    ColourDrawRectangle(dung->SortingPolygons[j]->Points, (uchar *) (vscreen->data), 
							       (dung->newpts[0]), (dung->newpts[1]),
							       dung->SortingPolygons[j]->Color+basepix+dung->SortingPolygons[j]->ColOffset); 		  
					    break;
					}
			    }
			}
			break;
   		 default:
			break;
	 }
}
		
void DrawMan2(struct ControlInfo *Controls,Dungeon *dung,XImage *VScreen,int basepix)
{
    SortPolygons(dung->SortingPolygons);
    DrawPolygons2(dung,Controls, VScreen,Controls->Flags,0,basepix,0,0); 
    /* ActivePt doesn't matter */
}


/************************************************************/

void getGC(Display *display,Window win,GC *gc,XFontStruct *font_info,
	   int screen_num)
{
    unsigned long valuemask = 0;
    XGCValues values;
    *gc = XCreateGC(display,win,valuemask,&values);
    XSetFont(display, *gc, font_info->fid);
    XSetForeground(display,*gc,BlackPixel(display,screen_num));
}

void load_font(Display *display,XFontStruct **font_info)
{
    char *fontname="8x13";
    if((*font_info=XLoadQueryFont(display,fontname)) == NULL) {
	fprintf(stderr,"%s: cannot open %s font.\n",progname,fontname);
	exit(-1);
    }
}
