#ifndef GUI_H
#define GUI_H

#include <X11/Xlib.h>
#include <dirent.h>      // static fuctions need this
						// that is funcs that do, should be static
#include "dirs.h"
#include "poly.h"

struct MovingPoint {
    int Point;
    int WinX,WinY;            /* original co-ords (within window) */
    short *Xchange,*Ychange;  /* What vars to change */
    int MouseXMin,MouseXMax;
    int MouseYMin,MouseYMax;
};
 
struct ControlInfo {
    float ScaleFactor;
    int XTrans,YTrans,ZTrans;
    int Flags; /* Rotations etc. */
    int ViewWindow; /* PLAN/ELEV/SIDE (1 bit for zoom(full window))*/
    int ActivePoint;
    int ActivePoly;
    Segment *ActiveObject;
    int Mode; /* Object/Poly/Point */
    int ShowMode; /* Point/Wire1/Wire2/Poly */
    int newpoly[6];
    int Zoomed;
    int MoveNum;
    int MotionEditor;
    int MoveXCurs;
	int FullRedraw;
    int *lookupkeys;
	struct MovingPoint MovingPt;
	struct Button *MoveButtons;
	int NewMoveTime,SaveMoveTime;
};


struct Button {
    Window ButtonWin;
    int Pressed;
    int Pending; /* I might use this */
    int Flags;
    XImage *UpImg;
    XImage *DownImg;
    Pixmap UpPix;
    Pixmap DownPix;
    struct Button *radio[4];
};

void DrawFilledBox(XImage *vscreen,int x, int y, int x1, int y1, int col);
void AddButton(Display *display,struct Button *ThisButton,int x,int y,
               int w,int h, char *imagename,int udPos,int PaletteOffset,
               Window ParentWin,GC gc,int Flags);
void Radio3(struct Button Controls[],int a,int b,int c);
void Radio4(struct Button Controls[],int a,int b,int c,int d);
char KeyCode2Ascii(Display *display,uchar keycode,uchar state);
void AffectString(char *str,char letter,int *Curs);
void KillWindow(Display *display,Window win);
void DrawTextBox(Display *display,Window win,GC gc,int BaseColour,
                 int x,int y,int w,int h);
void Draw3DBox(Display *d,Window win,GC gc,int BaseColour,int x,int y,int w,int h,int inv);
void Draw3DBox1(Display *,Window,GC,int,int,int,int,int,int,int);
void Draw3DBox2(XImage *vscreen,int x,int y,int w,int h,int Colour1,int Colour2,int inv);
void DisplayMotionEditorStatus(Display *display,Window win, GC gc,
                        struct ControlInfo *control, int BaseColour,
                        Dungeon *dung);
void DisplayEditorStatus(Display *display,Window win,GC gc,
            struct ControlInfo *control, int BaseColour,
            Dungeon *dung );
void DisplayStatus(Display *display,Window win,GC gc,
            struct ControlInfo *control, int BaseColour,
            Dungeon *dung );
void DrawRequesterStuff(Display *display,Window win,GC gc,int BaseColour);
void RefreshText(Display *display,Window win,GC gc,int Colour,
                 int x,int y,char *text,int CursX,int ActiveFlag);
int InBox(int x,int y,int l,int t,int r,int b);
struct DirList *MakeDirList(void);
int IsDir(char *pwd,char *name);
void AddEntry(struct DirList *List,struct dirent *entry,char *pwd,char *filter);
void FreeEntries(struct DListNode *node);
void FreeDirList(struct DirList *List);
struct DListNode * GetPtr(struct DirList *DL,int Pos);
int RefreshList(Display *display,Window win,GC gc,struct DirList *List,
                int ListPos,int Colour,int ListSel);
struct DirList * ReadDir2List(char *dirname,char *filter);
int FindDotDot(char *name);
void ClearDot(char *name);
void FixDirName(char *name);
int RequestFilename(Display *display,Window win,GC gc,char *buff,
                     char *mesg,int Exists,int PaletteOffset,char *filter,char load);
int ButtonReact(Display *,GC,XEvent *,struct Button *);
void MessageBox(Display *display,Window win,GC gc,char *mesg,int BasePix);




#endif


