#include "writeddm.h"
#include <strings.h>
#include "graph.h"
#include "med.h"
#include "ed2.h"
#include "window.h"
#include "palette.h"
#include "gui.h"
#include <stdio.h>
#include <string.h>
#include <dirent.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/X.h>
#include "mymem.h"

#define MOT_TOP	383
#define MOT_LEFT 80


void DoMovesSave(Display *display,Window win,GC gc,int BasePix,Dungeon *dung)
{
	char tmpstr[100];
	if(RequestFilename(display,win,gc,tmpstr,"save ddm",0,BasePix,".ddm",0)) {
		WriteMoves(tmpstr,dung->Moves[0]);
    }
}


/*******
 *
 *
 *
 *  Editors interface to the Motion maker yoke.
 *
 */

 
void
DoMotionTimed(Segment *base,int Player2Obj,struct ControlInfo *Controls)
{
    static int frames=0;
    if(Controls->NewMoveTime) {
        frames=Controls->NewMoveTime;
        Controls->NewMoveTime=0;
    }
    if(frames!=0) {
        DoMotion(base,Player2Obj);
		if(frames>0) {
        	frames--;
		}
    }
}

struct Bigmove *
FFindMove(Dungeon *dung, int MoveNum, int ObjectID)
{
    struct Bigmove *tmp;
    
    if (dung->Moves) {
        if (dung->Moves[0]) {
            if ((tmp=(dung->Moves[0])[MoveNum])) {
                while (tmp) {
                    if (tmp->ObjectID == ObjectID) {
                        return(tmp);
                    }
                    tmp=tmp->Next;
                }
            }
        }
    }
    return(NULL);                         
}
 
void
CreateMoveButtons(Display *display,Window Parent,GC gc,struct ControlInfo *Controls,
                  int BasePix)
{
    int i,j,k=1;
    Controls->MoveButtons=MyMalloc(sizeof(struct Button)*21,"movebuts");
    if(!Controls->MoveButtons) {
        return;
    }
    for(i=0;i<2;i++) {
        for(j=0;j<3;j++) {
            AddButton(display,&(Controls->MoveButtons[k++]),MOT_LEFT+200+126,MOT_TOP+31+j*30+i*120,22,22,
                "data/buttons/minusu.pcx",18,BasePix,Parent,gc,0);
            AddButton(display,&(Controls->MoveButtons[k++]),MOT_LEFT+270+126,MOT_TOP+31+j*30+i*120,22,22,
                "data/buttons/plusu.pcx",17,BasePix,Parent,gc,0);
        }
    }
    AddButton(display,&(Controls->MoveButtons[k++]),MOT_LEFT+200+126,MOT_TOP+271,22,22,
              "data/buttons/minusu.pcx",18,BasePix,Parent,gc,0);
    AddButton(display,&(Controls->MoveButtons[k++]),MOT_LEFT+270+126,MOT_TOP+271,22,22,
              "data/buttons/plusu.pcx",17,BasePix,Parent,gc,0);
	for(i=0;i<3;i++) {
        AddButton(display,&(Controls->MoveButtons[k++]),MOT_LEFT+200,MOT_TOP+i*30+151,22,22,
            "data/buttons/minusu.pcx",18,BasePix,Parent,gc,0);
        AddButton(display,&(Controls->MoveButtons[k++]),MOT_LEFT+270,MOT_TOP+i*30+151,22,22,
            "data/buttons/plusu.pcx",17,BasePix,Parent,gc,0);
	}
}

int
GetThing(char Dest, char source, char delt)
{       
    int t1=0;
    if(!delt) return(0);
    t1 = (source - Dest);
    if (t1 <0) {
        t1+=128;
    }
    if (delt<0){        
        t1 = -t1/delt;
    } else if(delt>0) {
        t1= (128-t1)/delt;
    } else if(delt==0) {
		if(t1) {
			//fprintf(stdout,"can't do\n");
		} else {
			//fprintf(stdout,"no mot -- that's okay\n");
		}
		t1=0;
	}
    return(t1);
}

struct movement *
GetMovement(Dungeon *dung,int ObjID,int MoveNum,int MoveXCurs)
{
	struct Bigmove *bm;
	struct movement *mov;
	if(dung->Moves) {
		if(dung->Moves[0]) {
			bm=(dung->Moves[0])[MoveNum];
			while(bm) {
				if(bm->ObjectID==ObjID) {
					mov=bm->Move;
					while(mov) {
						if(!MoveXCurs) {
							return(mov);
						}
						MoveXCurs--;
						mov=mov->Moves;
					}
				}
				bm=bm->Next;
			}
		}
	}
	return(NULL);
}

void
AlterWaiter(Dungeon *dung,int ObjID,int MoveNum,int MoveXCurs,int Delta)
{
	struct movement *mov;
	mov=GetMovement(dung,ObjID,MoveNum,MoveXCurs);
	if(mov) {
		mov->Waiter+=Delta;
		if(mov->Waiter<0) {
			mov->Waiter=0;
		}
	}
}

void
AlterAngle(Dungeon *dung,int ObjID,int MoveNum,int MoveXCurs,int Delta,int XYZ)
{
	struct movement *mov;
	mov=GetMovement(dung,ObjID,MoveNum,MoveXCurs);
	if(mov) {
		switch(XYZ) {
			case X_ANG: mov->DestXAng+=Delta;
						if(mov->DestXAng<0) {
							mov->DestXAng+=128;
						}
				break;
			case Y_ANG:	mov->DestYAng+=Delta;
						if(mov->DestYAng<0) {
							mov->DestYAng+=128;
						}
				break;
			case Z_ANG:	mov->DestZAng+=Delta;
						if(mov->DestZAng<0) {
							mov->DestZAng+=128;
						}
				break;
		}
	} 
}

void
AlterDist(Dungeon *dung,int ObjID,int MoveNum,int MoveXCurs,int Delta,int XYZ)
{
	struct movement *mov;
	mov=GetMovement(dung,ObjID,MoveNum,MoveXCurs);
	if(mov) {
		switch(XYZ) {
			case X_ANG: mov->MotionX+=Delta;
						if(mov->MotionX<-20) {
							mov->MotionX=-20;
						}
						if(mov->MotionX>20) {
							mov->MotionX=20;
						}
				break;
			case Y_ANG:	mov->MotionY+=Delta;
						if(mov->MotionY<-20) {
							mov->MotionY=-20;
						}
						if(mov->MotionY>20) {
							mov->MotionY=20;
						}
				break;
			case Z_ANG:	mov->MotionZ+=Delta;
						if(mov->MotionZ<-20) {
							mov->MotionZ=-20;
						}
						if(mov->MotionZ>20) {
							mov->MotionZ=20;
						}
				break;
		}
	} 
}

void
AlterSpeed(Dungeon *dung,int ObjID,int MoveNum,int MoveXCurs,int Delta,int XYZ)
{
	struct movement *mov;
	mov=GetMovement(dung,ObjID,MoveNum,MoveXCurs);
	if(mov) {
		switch(XYZ) {
			case X_ANG: mov->DeltXAng+=Delta;
						if(mov->DeltXAng<-8) {
							mov->DeltXAng=-8;
						}
						if(mov->DeltXAng>8) {
							mov->DeltXAng=8;
						}
				break;
			case Y_ANG:	mov->DeltYAng+=Delta;
						if(mov->DeltYAng<-8) {
							mov->DeltYAng=-8;
						}
						if(mov->DeltYAng>8) {
							mov->DeltYAng=8;
						}
				break;
			case Z_ANG:	mov->DeltZAng+=Delta;
						if(mov->DeltZAng<-8) {
							mov->DeltZAng=-8;
						}
						if(mov->DeltZAng>8) {
							mov->DeltZAng=8;
						}
				break;
		}
	} 
}

void 
FreeMovement(struct movement *move)
{
	if(move) {
		if(move->Moves) {
			FreeMovement(move->Moves);
		}
		MyFree(move,"movement");
	}
}

void 
FreeBigmove(struct Bigmove *move)
{
	if(move) {
		if(move->Move) {
			FreeMovement(move->Move);
		}
		MyFree(move,"bigmove");
	}
}

void 
DeleteBigmove(Display *display,Dungeon *dung,int MoveNum,int ObjID)
{
	struct Bigmove *bm;
	struct Bigmove **change_ptr;
	int done=0;
	bm=(dung->Moves[0])[MoveNum];
	change_ptr=&((dung->Moves[0])[MoveNum]);
	while(bm) {
		if(bm->ObjectID==ObjID) {
			done=1;
			*change_ptr=bm->Next;
			FreeBigmove(bm);
			// Delete This one
		}
		change_ptr=&(bm->Next);
		bm=bm->Next;
	}
	if(!done) {
		XBell(display,ERROR_VOLUME);
	}
}

void 
DeleteMoveBit(Display *display,Dungeon *dung,int MoveNum,int ObjID,int MoveXCurs)
{
	struct Bigmove *bm;
	struct movement **prev;
	struct movement *mov;
	int done=0;
	bm=(dung->Moves[0])[MoveNum];
	while(bm) {
		if(bm->ObjectID==ObjID) {
			mov=bm->Move;
			prev=&(bm->Move);
			while(mov) {
				//fprintf(stdout,"%d:%d:%d\n",mov->DestXAng,mov->DestYAng,mov->DestZAng);
				if(!MoveXCurs) {
					//fprintf(stdout,"GONE\n");
					*prev=mov->Moves;
					if(bm->Move==NULL) {
						//DeleteBigmove(display,dung,MoveNum,ObjID);
						// take bigmove from chain. XXXXXXXXXXXXXX
					}
					done=1;
				}
				MoveXCurs--;
				prev=&(mov->Moves);
				mov=mov->Moves;
			}
		}
		bm=bm->Next;
	}
	if(!done) {
		XBell(display,ERROR_VOLUME);
	}
	//fprintf(stdout,"-=-=-=-=-=-=-=-\n");
}
 
void
SetupMoves(Dungeon *dung)
{
    int i=0,j;
    while(dung->ObjectArray[i++]);
    //fprintf(stdout,"SetupMoves...");
    dung->tmpSegments=MyMalloc((i+31)*sizeof(Segment *),"tmpSegs");
    if(dung->tmpSegments) {
        for(j=0;j<i+29;j++) {
            dung->tmpSegments[j]=MyMalloc(sizeof(Segment),"tmp-seg");
        }
    }
    dung->Moves=MyMalloc(sizeof(struct Bigmove **),"bigmove**");
    if(dung->Moves) {
        dung->Moves[1]=NULL;
        *(dung->Moves)=MyMalloc(sizeof(struct BigMove *)*20,"bigmove*");
        if(*(dung->Moves)) {
            for(i=1;i<20;i++) {
                (dung->Moves[0])[i]=NULL; // 2nd->20th mov_ptrs
            }
            *(*(dung->Moves))=NULL; // 1st ptr
        }
    }
    //fprintf(stdout,"...Done\n");
}
 
int
SegsDifferent(Segment *s1,Segment *s2)
{
    if(s1->CurrXAng == s2->CurrXAng) {
        if(s1->CurrYAng == s2->CurrYAng) {
             if(s1->CurrZAng == s2->CurrZAng) {
                return(0);
            }
        }
    }
    return(1);
}
 
struct Bigmove *
FindBigMovePtr(Dungeon *dung,int Id,int MoveNum)
{
    struct Bigmove *bm;
    struct Bigmove **null;
 
    bm=((dung->Moves)[0])[MoveNum];
    null=&((dung->Moves)[0])[MoveNum];
    while(bm) {
        if(bm->ObjectID==Id) {
            return(bm);
        }
        null=&(bm->Next);
        bm=bm->Next;
    }
    // Not found, Lets Alloc ...
    //fprintf(stdout,"Alloc-ing for new move...\n");
    bm=MyMalloc(sizeof(struct Bigmove),"bigmove");
    *null=bm;
    //fprintf(stdout,"dung->Moves    dung->Moves[0]   (dung->Moves[0])[]\n");
    //fprintf(stdout,"%p\t\t%p\t\t%p\n",dung->Moves,dung->Moves[0],
    //        (dung->Moves[0])[MoveNum]);
    //fprintf(stdout,"bm= %p\n",bm);
    bm->ObjectID=Id;
    bm->Next=NULL;
    bm->Move=NULL;
    return(bm);
}
 
 
struct movement *
FindMovePtr(struct Bigmove *bmove)
{
    struct movement *tmp;
    struct movement *mov;
    struct movement **null;
    if(bmove) {
        tmp=bmove->Move;
        null=&(bmove->Move);
        while(tmp) {
            null=&(tmp->Moves);
            tmp=tmp->Moves;
        }
        mov=MyMalloc(sizeof(struct movement),"movem");
        *null=mov;
        mov->Moves=NULL;
        return(mov);
    }
    return(NULL);
}
 
 
void
CreateMovie(Segment *s1,Segment *s2,struct movement *move)
{
    int d1=0;
 
    move->DestXAng=s1->CurrXAng;
    move->DestYAng=s1->CurrYAng;
    move->DestZAng=s1->CurrZAng;
 
    d1=s1->CurrXAng-s2->CurrXAng;
    if (((d1>0)&&(d1<64))||(d1<-63)) {
        move->DeltXAng=1;
    } else {
        move->DeltXAng=-1;
    }
 
    d1=s1->CurrYAng-s2->CurrYAng;
    if (((d1>0)&&(d1<64))||(d1<-63)) {
        move->DeltYAng=1;
    } else {
        move->DeltYAng=-1;
    }
 
    d1=s1->CurrZAng-s2->CurrZAng;
    if (((d1>0)&&(d1<64))||(d1<-63)) {
        move->DeltZAng=1;
    } else {
        move->DeltZAng=-1;
    }
 
    move->Waiter=0;
    move->MotionX=0;
    move->MotionY=0;
    move->MotionZ=0;
    move->Moves=NULL;
}
 
 
void
InitMove(Dungeon *dung)
{
    int i=0,j;
    while(dung->ObjectArray[i++]);
    //fprintf(stdout,"Initing (%d objects)\n",i-1);
    // Copy the current position now.
    for(j=0;j<i-1;j++) {
        bcopy(dung->ObjectArray[j],dung->tmpSegments[j],sizeof(Segment));
    }
    //fprintf(stdout,"Objects copied\n");
}
 
void
AddPhase(Dungeon *dung,int MoveNum)
{
    int i=0,j;
    struct Bigmove *BMovePtr;
    struct movement *MovePtr;
 
    while(dung->ObjectArray[i++]);
    //fprintf(stdout,"Adding changes to a move\n");
    for(j=1;j<i-1;j++) {
        // For each segment
        if(SegsDifferent(dung->ObjectArray[j],dung->tmpSegments[j])) {
            BMovePtr=FindBigMovePtr(dung,dung->ObjectArray[j]->ID,MoveNum);
            MovePtr=FindMovePtr(BMovePtr);
            CreateMovie(dung->ObjectArray[j],dung->tmpSegments[j],MovePtr);
        }
    }
    // Copy the current position now.
    InitMove(dung);
}
 
void
NextMove(Dungeon *d,struct ControlInfo *Cont)
{
    int Num;
    Num=Cont->MoveNum+1;
    if((d->Moves[0])[Num-1]==NULL) {
        Num=0;
    }
	Cont->MoveNum=Num;
}
 
void
PrevMove(Dungeon *d,struct ControlInfo *Cont)
{
    int Num;
    Num=Cont->MoveNum-1;
    if(Num<0) {
		Num=20;
        while(Num && !(d->Moves[0])[Num-1]) {
			Num--;
		}
    }
	Cont->MoveNum=Num;
}
 
int
MoveFrames(struct movement *move,char *cx,char *cy, char *cz)
{
    int t1,t2,t3;
	t1=GetThing(move->DestXAng,*cx,move->DeltXAng);
	t2=GetThing(move->DestYAng,*cy,move->DeltYAng);
	t3=GetThing(move->DestZAng,*cz,move->DeltZAng);
	*cx=move->DestXAng;
	*cy=move->DestYAng;
	*cz=move->DestZAng;
	if(t1>t2) {
		if(t1>t3) {
			return(t1);
		} else {
			return(t3);
		}
	} else {
		if(t2>t3) {
			return(t2);
		} else {
			return(t3);
		}
	}
    return(0);
}

int 
LittleLength(struct movement *move, char cx,char cy, char cz)
{
    int length=0;
    
    if (!move) {
        return(0);
    }
    length+=move->Waiter;
    length+=MoveFrames(move,&cx,&cy,&cz);
    length+=LittleLength(move->Moves,cx,cy,cz);
    return(length);          
}

int
GetLength(struct Bigmove *thismove)
{
    int length=0;
    
    length+= LittleLength(thismove->Move,0,0,0);
    return(length);
}

void
DrawMove(XImage *vscreen,int *x,int y,struct movement *move,char *cx,char *cy,char *cz,
		 int BaseColour,int height,int picked)
{
	int frames;
	if(move->Waiter) {
		//fprintf(stdout,"WAIT: %d\n",move->Waiter);
    	Draw3DBox2(vscreen,*x,y,move->Waiter*2,height,BaseColour+DARK_GREEN+picked,BaseColour+LITE_GREEN+picked,picked);
    	Draw3DBox2(vscreen,*x+1,y+1,move->Waiter*2-2,height-2,BaseColour+DARK_GREEN+picked,BaseColour+LITE_GREEN+picked,!picked);
		DrawFilledBox(vscreen,*x+2,y+2,*x+(move->Waiter*2)-2,y+height-2,BaseColour+MID_GREEN+picked);
		*x=*x+(move->Waiter*2);
	}
	frames=MoveFrames(move,cx,cy,cz);
    Draw3DBox2(vscreen,*x,y,frames*2,height,BaseColour+DARK_YELLOW,BaseColour+LITE_YELLOW,picked);
    Draw3DBox2(vscreen,*x+1,y+1,frames*2-2,height-2,BaseColour+DARK_YELLOW,BaseColour+LITE_YELLOW,!picked);
	DrawFilledBox(vscreen,*x+2,y+2,*x+(frames*2)-3,y+height-3,BaseColour+MID_YELLOW);
	*x=*x+2*frames;
}

void 
DrawMotionBar(XImage *VScreen,int BaseColour,int objectID, Dungeon *dung, int MoveNum,
			  int height,int Curs,int CursX)
{
	int end,gone;
    struct Bigmove *thismove;
    struct movement *tmp;
    int length,x=MAX_WINDOW_WIDTH/2+52;
    char cx=0,cy=0,cz=0;
    thismove=FFindMove(dung,MoveNum,objectID);
    if (thismove){
		//fprintf(stdout,"MOVE:Object %d\n",objectID);
        length = GetLength(thismove);
		//fprintf(stdout,"length=%d\n",length);
        tmp=thismove->Move;
		if(Curs && !CursX) {
			DrawFilledBox(VScreen,x-2,50+(objectID*height),x+2,48+(objectID+1)*height,BaseColour+2);
		}
        while (tmp){
			DrawMove(VScreen,&x,50+objectID*height,tmp,&cx,&cy,&cz,BaseColour,height,Curs);
			if(Curs) {
				CursX--;
				if(!CursX) {
					//DrawFilledBox(VScreen,x-2,50+(objectID*height),x+2,48+(objectID+1)*height,BaseColour+2);
				}	
			}
            tmp = tmp->Moves;
        }
		gone=x-((MAX_WINDOW_WIDTH/2)+49);
		end=((MAX_WINDOW_WIDTH/2)-100)-gone;
		if((end-gone)>0) {
			Draw3DBox2(VScreen,x,50+(objectID*height),end,height,BaseColour+DARK_GRAY,BaseColour+LITE_GRAY,!Curs);
			Draw3DBox2(VScreen,x+1,50+(objectID*height)+1,end,height-2,BaseColour+DARK_GRAY,BaseColour+LITE_GRAY,Curs);
			DrawFilledBox(VScreen,x+2,50+(objectID*height)+2,x+(end)-3,50+(objectID*height)+height-3,BaseColour+MID_GRAY);
		}
    }
}

void
DrawTextToXImage(Display *display,Window win,GC gc,XImage *vscreen,int BasePix,
				 int x,int y,char *string)
{
	Pixmap TmpPix;
	XImage *img;
	int len=strlen(string);
	TmpPix=XCreatePixmap(display,win,12+(8*len),20,8);
	if(TmpPix) {
		XSetForeground(display,gc,BasePix+MID_GRAY);	/// XXXXXXX
		XFillRectangle(display,TmpPix,gc,0,0,12+(8*len),20);
		XSetBackground(display,gc,BasePix+MID_GRAY);
		XSetForeground(display,gc,BasePix);
		XDrawImageString(display,TmpPix,gc,6,15,string,len);
		img=XGetImage(display,TmpPix,0,0,12+(8*len),20,0xFF,ZPixmap);
		if(img) {
			CopyArea(img->data,0,0,12+(8*len),(vscreen->data),x,y,852,12+(8*len),20);
			XDestroyImage(img);
		}
		XFreePixmap(display,TmpPix);
	}
}

void ClearMoveInfo(XImage *vscreen,int BasePix)
{
	// Set colour to Gray (MID_GRAY)
	DrawFilledBox(vscreen,MOT_LEFT+67,MOT_TOP+32,MOT_LEFT+112,MOT_TOP+51,BasePix+MID_GRAY);
	DrawFilledBox(vscreen,MOT_LEFT+67,MOT_TOP+62,MOT_LEFT+112,MOT_TOP+81,BasePix+MID_GRAY);
	DrawFilledBox(vscreen,MOT_LEFT+67,MOT_TOP+92,MOT_LEFT+112,MOT_TOP+111,BasePix+MID_GRAY);
	DrawFilledBox(vscreen,MOT_LEFT+67,MOT_TOP+152,MOT_LEFT+112,MOT_TOP+171,BasePix+MID_GRAY);
	DrawFilledBox(vscreen,MOT_LEFT+67,MOT_TOP+182,MOT_LEFT+112,MOT_TOP+201,BasePix+MID_GRAY);
	DrawFilledBox(vscreen,MOT_LEFT+67,MOT_TOP+212,MOT_LEFT+112,MOT_TOP+231,BasePix+MID_GRAY);

	DrawFilledBox(vscreen,MOT_LEFT+67+126,MOT_TOP+32,MOT_LEFT+112+126,MOT_TOP+51,BasePix+MID_GRAY);
	DrawFilledBox(vscreen,MOT_LEFT+67+126,MOT_TOP+62,MOT_LEFT+112+126,MOT_TOP+81,BasePix+MID_GRAY);
	DrawFilledBox(vscreen,MOT_LEFT+67+126,MOT_TOP+92,MOT_LEFT+112+126,MOT_TOP+111,BasePix+MID_GRAY);
	DrawFilledBox(vscreen,MOT_LEFT+67+126,MOT_TOP+152,MOT_LEFT+112+126,MOT_TOP+171,BasePix+MID_GRAY);
	DrawFilledBox(vscreen,MOT_LEFT+67+126,MOT_TOP+182,MOT_LEFT+112+126,MOT_TOP+201,BasePix+MID_GRAY);
	DrawFilledBox(vscreen,MOT_LEFT+67+126,MOT_TOP+212,MOT_LEFT+112+126,MOT_TOP+231,BasePix+MID_GRAY);
	DrawFilledBox(vscreen,MOT_LEFT+67+126,MOT_TOP+272,MOT_LEFT+112+126,MOT_TOP+291,BasePix+MID_GRAY);
}

void
DumpMoveToBoxes(Display *display,Window win,GC gc,XImage *vscreen,int BasePix,
				struct movement *move,char x,char y,char z)
{
	char tmp[10];
	sprintf(tmp,"%3d",x);
	DrawTextToXImage(display,win,gc,vscreen,BasePix,MOT_LEFT+77,MOT_TOP+32,tmp);
	sprintf(tmp,"%3d",y);
	DrawTextToXImage(display,win,gc,vscreen,BasePix,MOT_LEFT+77,MOT_TOP+62,tmp);
	sprintf(tmp,"%3d",z);
	DrawTextToXImage(display,win,gc,vscreen,BasePix,MOT_LEFT+77,MOT_TOP+92,tmp);
	sprintf(tmp,"%3d",move->MotionX);
	DrawTextToXImage(display,win,gc,vscreen,BasePix,MOT_LEFT+77,MOT_TOP+152,tmp);
	sprintf(tmp,"%3d",move->MotionY);
	DrawTextToXImage(display,win,gc,vscreen,BasePix,MOT_LEFT+77,MOT_TOP+182,tmp);
	sprintf(tmp,"%3d",move->MotionZ);
	DrawTextToXImage(display,win,gc,vscreen,BasePix,MOT_LEFT+77,MOT_TOP+212,tmp);

	sprintf(tmp,"%3d",move->DestXAng);
	DrawTextToXImage(display,win,gc,vscreen,BasePix,MOT_LEFT+77+126,MOT_TOP+32,tmp);
	sprintf(tmp,"%3d",move->DestYAng);
	DrawTextToXImage(display,win,gc,vscreen,BasePix,MOT_LEFT+77+126,MOT_TOP+62,tmp);
	sprintf(tmp,"%3d",move->DestZAng);
	DrawTextToXImage(display,win,gc,vscreen,BasePix,MOT_LEFT+77+126,MOT_TOP+92,tmp);
	sprintf(tmp,"%3d",move->DeltXAng);
	DrawTextToXImage(display,win,gc,vscreen,BasePix,MOT_LEFT+77+126,MOT_TOP+152,tmp);
	sprintf(tmp,"%3d",move->DeltYAng);
	DrawTextToXImage(display,win,gc,vscreen,BasePix,MOT_LEFT+77+126,MOT_TOP+182,tmp);
	sprintf(tmp,"%3d",move->DeltZAng);
	DrawTextToXImage(display,win,gc,vscreen,BasePix,MOT_LEFT+77+126,MOT_TOP+212,tmp);
	sprintf(tmp,"%3d",move->Waiter);
	DrawTextToXImage(display,win,gc,vscreen,BasePix,MOT_LEFT+77+126,MOT_TOP+272,tmp);

}

void
DrawMoveBit(Display *display,Window win,GC gc,XImage *vscreen,int *x,int y,
			struct movement *move,char *cx,char *cy,char *cz,
		 	int BasePix,int height,int State)
{
	int frames;
	int Green,Yellow;
	if(State==3) {
		// Dump Data to boxes
		DumpMoveToBoxes(display,win,gc,vscreen,BasePix,move,*cx,*cy,*cz);
	}
	Green=MID_GREEN+BasePix;
	Yellow=MID_YELLOW+BasePix;
	if(State & 1) {
		Green-=1;
		Yellow-=1;
		State-=1;
	}
	if(State & 2) {
		State=1;
		Green--;
		Yellow--;
	} else {	
		State=0;
	}
	// If Raised is 3 fill in Data ................ XXXXX

	if(move->Waiter) {
		//fprintf(stdout,"WAIT: %d\n",move->Waiter);
    	Draw3DBox2(vscreen,*x,y,move->Waiter*2,height,Green+1,Green-1,State);
    	Draw3DBox2(vscreen,*x+1,y+1,move->Waiter*2-2,height-2,Green+1,Green-1,1);
		DrawFilledBox(vscreen,*x+2,y+2,*x+(move->Waiter*2)-2,y+height-2,Green);
		*x=*x+(move->Waiter*2);
	}
	frames=MoveFrames(move,cx,cy,cz);
	if(frames==0) {
		fprintf(stdout,"Frames is 0\n");
	} else {
    	Draw3DBox2(vscreen,*x,y,frames*2,height,Yellow+1,Yellow-1,State);
    	Draw3DBox2(vscreen,*x+1,y+1,frames*2-2,height-2,Yellow+1,Yellow-1,1);
		DrawFilledBox(vscreen,*x+2,y+2,*x+(frames*2)-3,y+height-3,Yellow);
		*x=*x+2*frames;
	}
}

int
DrawObjectMove(Display *display,Window win,GC gc,Dungeon *dung,XImage *vscreen,int BasePix,
			   int SegId,struct ControlInfo *Controls,int height)
{
	struct Bigmove *thismove;
	struct movement *move;
	int Raised,Gray,ret=0;
	int y=50+(SegId*height);
	int SelectedMove=Controls->MoveXCurs;
	int x=500;
	char cx=0,cy=0,cz=0;
	thismove=FFindMove(dung,Controls->MoveNum,SegId);
	if(thismove) {
		move=thismove->Move;
		while(move) {
			if(SegId==Controls->ActiveObject->ID) {
				if(SelectedMove==0) {
					Raised=3;
					ret=1;
				} else {
					Raised=1;
				}
			} else {
				Raised=0;
			}
			DrawMoveBit(display,win,gc,vscreen,&x,y,move,&cx,&cy,&cz,BasePix,height,Raised);
			SelectedMove--;
			move=move->Moves;
		}
	} else {
		// This segment doesn't move
	}
	if(x<800) {
		Gray=DARK_GRAY+BasePix;
		if(SegId==Controls->ActiveObject->ID) {
			Gray--;
		}
    	Draw3DBox2(vscreen,x,y,(800-x),height,Gray+1,Gray-1,0);
    	Draw3DBox2(vscreen,x+1,y+1,(800-x)-2,height-2,Gray+1,Gray-1,1);
		DrawFilledBox(vscreen,x+2,y+2,797,y+height-3,Gray);
	}
	return(ret);
}

void
TestMoveButtons(Display *display,Window win,GC gc,Dungeon *dung,XImage *Back,int BasePix,
				XEvent *report, struct ControlInfo *Controls)
{
	struct Button *MoveButs=Controls->MoveButtons;
	int ButtonHit,NoRefresh=0;
	ButtonHit=ProcessControlEvent(display,gc,report,MoveButs);
	switch(ButtonHit) {   // 1-> 20
		case 1:		AlterAngle(dung,Controls->ActiveObject->ID,Controls->MoveNum,Controls->MoveXCurs,-1,X_ANG);
			break;
		case 2:		AlterAngle(dung,Controls->ActiveObject->ID,Controls->MoveNum,Controls->MoveXCurs,1,X_ANG);
			break;
		case 3:		AlterAngle(dung,Controls->ActiveObject->ID,Controls->MoveNum,Controls->MoveXCurs,-1,Y_ANG);
			break;
		case 4:		AlterAngle(dung,Controls->ActiveObject->ID,Controls->MoveNum,Controls->MoveXCurs,1,Y_ANG);
			break;
		case 5:		AlterAngle(dung,Controls->ActiveObject->ID,Controls->MoveNum,Controls->MoveXCurs,-1,Z_ANG);
			break;
		case 6:		AlterAngle(dung,Controls->ActiveObject->ID,Controls->MoveNum,Controls->MoveXCurs,1,Z_ANG);
			break;
		case 7:		AlterSpeed(dung,Controls->ActiveObject->ID,Controls->MoveNum,Controls->MoveXCurs,-1,X_ANG);
			break;
		case 8:		AlterSpeed(dung,Controls->ActiveObject->ID,Controls->MoveNum,Controls->MoveXCurs,1,X_ANG);
			break;
		case 9:		AlterSpeed(dung,Controls->ActiveObject->ID,Controls->MoveNum,Controls->MoveXCurs,-1,Y_ANG);
			break;
		case 10:	AlterSpeed(dung,Controls->ActiveObject->ID,Controls->MoveNum,Controls->MoveXCurs,1,Y_ANG);
			break;
		case 11:	AlterSpeed(dung,Controls->ActiveObject->ID,Controls->MoveNum,Controls->MoveXCurs,-1,Z_ANG);
			break;
		case 12:	AlterSpeed(dung,Controls->ActiveObject->ID,Controls->MoveNum,Controls->MoveXCurs,1,Z_ANG);
			break;
		case 13:	AlterWaiter(dung,Controls->ActiveObject->ID,Controls->MoveNum,Controls->MoveXCurs,-1);
			break;
		case 14:	AlterWaiter(dung,Controls->ActiveObject->ID,Controls->MoveNum,Controls->MoveXCurs,1);
			break;
		case 15:	AlterDist(dung,Controls->ActiveObject->ID,Controls->MoveNum,Controls->MoveXCurs,-1,X_ANG);
			break;
		case 16:	AlterDist(dung,Controls->ActiveObject->ID,Controls->MoveNum,Controls->MoveXCurs,1,X_ANG);
			break;
		case 17:	AlterDist(dung,Controls->ActiveObject->ID,Controls->MoveNum,Controls->MoveXCurs,-1,Y_ANG);
			break;
		case 18:	AlterDist(dung,Controls->ActiveObject->ID,Controls->MoveNum,Controls->MoveXCurs,1,Y_ANG);
			break;
		case 19:	AlterDist(dung,Controls->ActiveObject->ID,Controls->MoveNum,Controls->MoveXCurs,-1,Z_ANG);
			break;
		case 20:	AlterDist(dung,Controls->ActiveObject->ID,Controls->MoveNum,Controls->MoveXCurs,1,Z_ANG);
			break;
		default:	NoRefresh=1;
			break;
	}
	if(!NoRefresh) {
		DrawMotionPanel(display,win,gc,Back,dung,Controls,BasePix,0);
	}
}

void
DrawMotionPanel(Display *display,Window win,GC gc,XImage *VScreen,Dungeon *dung,
				struct ControlInfo *control,int BasePix,int flag)
{
    int i,width,height,info;
    height=(MAX_WINDOW_HEIGHT-100)/dung->NumObjects;
    width=(MAX_WINDOW_WIDTH/2)-100;
	if(flag) {
		// RHS of window.
		DrawFilledBox(VScreen,MAX_WINDOW_WIDTH/2,0,MAX_WINDOW_WIDTH-1,MAX_WINDOW_HEIGHT-1,BasePix+MID_GRAY);
		// Bottom Left of window.
		//fprintf(stdout,"ya hoo\n");
		DrawFilledBox(VScreen,0,10*36+4,MAX_WINDOW_WIDTH/2,MAX_WINDOW_HEIGHT-1,BasePix+MID_GRAY);
		// 3D bit around character.
		Draw3DBox2(VScreen,0,0,MAX_WINDOW_WIDTH/2,MAX_WINDOW_HEIGHT/2+14,BasePix+LITE_GRAY,BasePix+DARK_GRAY,0);
		Draw3DBox2(VScreen,1,1,MAX_WINDOW_WIDTH/2-2,MAX_WINDOW_HEIGHT/2-2+14,BasePix+LITE_GRAY,BasePix+DARK_GRAY,0);
		Draw3DBox2(VScreen,2,2,MAX_WINDOW_WIDTH/2-4,MAX_WINDOW_HEIGHT/2-4+14,BasePix+LITE_GRAY,BasePix+DARK_GRAY,0);
		info=0;
    	for (i=0;i<dung->NumObjects;i++) {
			info|=DrawObjectMove(display,win,gc,dung,VScreen,BasePix,i,control,height);
    	}
		if(!info) {
			ClearMoveInfo(VScreen,BasePix);
		}
		// Number boxes

		Draw3DBox2(VScreen,MOT_LEFT+16,MOT_TOP,254,302,BasePix+WHITE,BasePix+DARK_GRAY,1);
		Draw3DBox2(VScreen,MOT_LEFT+17,MOT_TOP+1,126,120,BasePix+WHITE,BasePix+DARK_GRAY,0);
		Draw3DBox2(VScreen,MOT_LEFT+66,MOT_TOP+31,48,22,BasePix+WHITE,BasePix+DARK_GRAY,1);
		Draw3DBox2(VScreen,MOT_LEFT+66,MOT_TOP+61,48,22,BasePix+WHITE,BasePix+DARK_GRAY,1);
		Draw3DBox2(VScreen,MOT_LEFT+66,MOT_TOP+91,48,22,BasePix+WHITE,BasePix+DARK_GRAY,1);

		Draw3DBox2(VScreen,MOT_LEFT+17,MOT_TOP+121,126,120,BasePix+WHITE,BasePix+DARK_GRAY,0);
		Draw3DBox2(VScreen,MOT_LEFT+66,MOT_TOP+151,48,22,BasePix+WHITE,BasePix+DARK_GRAY,1);
		Draw3DBox2(VScreen,MOT_LEFT+66,MOT_TOP+181,48,22,BasePix+WHITE,BasePix+DARK_GRAY,1);
		Draw3DBox2(VScreen,MOT_LEFT+66,MOT_TOP+211,48,22,BasePix+WHITE,BasePix+DARK_GRAY,1);

		Draw3DBox2(VScreen,MOT_LEFT+17+126,MOT_TOP+1,126,120,BasePix+WHITE,BasePix+DARK_GRAY,0);
		Draw3DBox2(VScreen,MOT_LEFT+66+126,MOT_TOP+31,48,22,BasePix+WHITE,BasePix+DARK_GRAY,1);
		Draw3DBox2(VScreen,MOT_LEFT+66+126,MOT_TOP+61,48,22,BasePix+WHITE,BasePix+DARK_GRAY,1);
		Draw3DBox2(VScreen,MOT_LEFT+66+126,MOT_TOP+91,48,22,BasePix+WHITE,BasePix+DARK_GRAY,1);

		Draw3DBox2(VScreen,MOT_LEFT+17+126,MOT_TOP+121,126,120,BasePix+WHITE,BasePix+DARK_GRAY,0);
		Draw3DBox2(VScreen,MOT_LEFT+66+126,MOT_TOP+151,48,22,BasePix+WHITE,BasePix+DARK_GRAY,1);
		Draw3DBox2(VScreen,MOT_LEFT+66+126,MOT_TOP+181,48,22,BasePix+WHITE,BasePix+DARK_GRAY,1);
		Draw3DBox2(VScreen,MOT_LEFT+66+126,MOT_TOP+211,48,22,BasePix+WHITE,BasePix+DARK_GRAY,1);

		Draw3DBox2(VScreen,MOT_LEFT+17+126,MOT_TOP+241,126,60,BasePix+WHITE,BasePix+DARK_GRAY,0);
		Draw3DBox2(VScreen,MOT_LEFT+66+126,MOT_TOP+271,48,22,BasePix+WHITE,BasePix+DARK_GRAY,1);

		DrawTextToXImage(display,win,gc,VScreen,BasePix,MOT_LEFT+20,MOT_TOP+2,"Rotate From");
		DrawTextToXImage(display,win,gc,VScreen,BasePix,MOT_LEFT+20,MOT_TOP+32,"X:");
		DrawTextToXImage(display,win,gc,VScreen,BasePix,MOT_LEFT+20,MOT_TOP+62,"Y:");
		DrawTextToXImage(display,win,gc,VScreen,BasePix,MOT_LEFT+20,MOT_TOP+92,"Z:");
		DrawTextToXImage(display,win,gc,VScreen,BasePix,MOT_LEFT+20,MOT_TOP+122,"Translate");
		DrawTextToXImage(display,win,gc,VScreen,BasePix,MOT_LEFT+20,MOT_TOP+152,"X:");
		DrawTextToXImage(display,win,gc,VScreen,BasePix,MOT_LEFT+20,MOT_TOP+182,"Y:");
		DrawTextToXImage(display,win,gc,VScreen,BasePix,MOT_LEFT+20,MOT_TOP+212,"Z:");
		DrawTextToXImage(display,win,gc,VScreen,BasePix,MOT_LEFT+20,MOT_TOP+242,"Move: X");
		DrawTextToXImage(display,win,gc,VScreen,BasePix,MOT_LEFT+20,MOT_TOP+262,"Segment: Z");
		//DrawTextToXImage(display,win,gc,VScreen,BasePix,20,MOT_TOP+282,"Bollix");
		DrawTextToXImage(display,win,gc,VScreen,BasePix,MOT_LEFT+20+126,MOT_TOP+2,"Rotate To");
		DrawTextToXImage(display,win,gc,VScreen,BasePix,MOT_LEFT+20+126,MOT_TOP+32,"X:");
		DrawTextToXImage(display,win,gc,VScreen,BasePix,MOT_LEFT+20+126,MOT_TOP+62,"Y:");
		DrawTextToXImage(display,win,gc,VScreen,BasePix,MOT_LEFT+20+126,MOT_TOP+92,"Z:");
		DrawTextToXImage(display,win,gc,VScreen,BasePix,MOT_LEFT+20+126,MOT_TOP+122,"Rate");
		DrawTextToXImage(display,win,gc,VScreen,BasePix,MOT_LEFT+20+126,MOT_TOP+152,"X:");
		DrawTextToXImage(display,win,gc,VScreen,BasePix,MOT_LEFT+20+126,MOT_TOP+182,"Y:");
		DrawTextToXImage(display,win,gc,VScreen,BasePix,MOT_LEFT+20+126,MOT_TOP+212,"Z:");
		DrawTextToXImage(display,win,gc,VScreen,BasePix,MOT_LEFT+20+126,MOT_TOP+242,"Delay");
		DrawTextToXImage(display,win,gc,VScreen,BasePix,MOT_LEFT+20+126,MOT_TOP+272,"T:"); // XXXX
	} else {
		int above,below;
		above=control->ActiveObject->ID-1;
		if(above<0)  {
			above=dung->NumObjects-1;
		}
		below=control->ActiveObject->ID+1;
		if(below>dung->NumObjects-1) {
			below=0;
		}
		info=DrawObjectMove(display,win,gc,dung,VScreen,BasePix,above,control,height);
		info|=DrawObjectMove(display,win,gc,dung,VScreen,BasePix,control->ActiveObject->ID,control,height);
		info|=DrawObjectMove(display,win,gc,dung,VScreen,BasePix,below,control,height);
		if(!info) {
			ClearMoveInfo(VScreen,BasePix);
		}
	}
}

