
#include "mymem.h"
#include <malloc.h>
#include <stdio.h>

//#define MEM_DEBUG


/* 
 * Free a block of memory (allocated using malloc()), using
 * the free() funtion.  The string passed in is a debug
 * message, for checking for memory leaks etc.
 *
 */

void 
MyFree (void *ptr, char *str)
{
#ifdef MEM_DEBUG
    fprintf (stdout, "free(sweet): (%s)\n", str);
#else
    str = str;
#endif
    free (ptr);
}


/* 
 * Allocate a block of memory.  The string passed in is a 
 * debug message, for checking for memory leaks etc.
 *
 */

void *
MyMalloc (int Size, char *str)
{
    void *tmp;
    tmp = malloc (Size);
#ifdef MEM_DEBUG
    fprintf (stdout, "malloc(sweet): size=%d for (%s) ..", Size, str);
    if (tmp)
	fprintf (stdout, "Okay\n");
    else {
	fprintf (stdout, "Failed\n");
	fprintf (stderr, "Failure allocating memory\n");
    }
#else
    str = str;
#endif
    return (tmp);
}
