#ifndef POLY_H
#define POLY_H

#include "id.h"

#include "generic.h"
#include <X11/Xlib.h>

#include "ddm.h"

#define MAX_COLLISION_PTS 50
#define COLLISION_RADIUS 2000

#define SQUARE(x) ((x)*(x))

struct bang {
	int Show;
	int X,Y;
	int What;
};

typedef struct polygonXXXX {
//  int NumVerts;
  int Points[4];
  int CentrePt;
  int Style;  // 0 for Colour, 1 for Texture, 2 for Lightsource.
  int Texture;
  int Color;
  int ColOffset;
} Polygon;

typedef struct segment {
  int ID;
  struct movement *Moves;
  int Numpoints;
  int Poffset;
  struct segment *Prev;
  struct segment *Next[5];
  uchar CurrXAng;
  uchar CurrYAng;
  uchar CurrZAng;
  int MotionX;
  int MotionY;
  int MotionZ;
  int   Waiter;
  int Returning;
  struct movement ReturnMove;
  char Name[30];
} Segment;

typedef struct DungeonXXXX {
	Segment **ObjectArray;
	Segment **tmpSegments;
	Polygon **PolygonArray;
	Polygon **SortingPolygons;
	struct Picture_Type **Textures;
	short int *Points[3]; /* X, Y, Z  */
	short int *newpts[3]; /* X, Y, Z  */
	short int *shadowpts[3]; /* X Y=0 Z */	
	short int *newshadowpts[3]; /* X Y Z */	
	short int *twoDX,*twoDY,*twoDZ;
	int *Hits[2], *Colls[2];
	/* Some handy info */
	int NumObjects;
	int NumPolygons;
	int NumPoints;
	int NumColls[2];
	int NumHits[2];
	int feet[2][2];
	struct Bigmove ***Moves;
	int Player2Pts;
} Dungeon;

Segment *GetObj(int,Segment **);
/*
static void ClearMove(Segment **,int);
static void MoveObject(Segment *);
static void UpdateObject2(Segment *,int [3][3]);
static void UpdateObject(Dungeon *,Segment *,int,int);
static void UpdateObjectsHotPts(Segment *,int,int,int);
static void DrawPolygons(int, Dungeon  *,XImage *);
static int GetDistance(int ,int);
*/
void SortPolygons(Polygon **);
Segment *GetObj2(int Num,Segment **objs,int NumObj);
void RotateWorld(Segment *,int,Dungeon *);
void SetMove(int,struct movement *);
void TestMove(struct Bigmove *,int,Segment **);
int MakeMove(struct Bigmove *,int,Segment **);
void DoMotion(Segment *,int);
void MoveToScreenSWEET(Dungeon *,int,int,int,int,int,int*,int*,int*,int*,int);
void UpdateObjects(Dungeon*,Segment *);
void DrawWorld(int, Dungeon *, XImage *,int,int,int,int);
void Init_Mat(int,int,int,int [3][3]);
void UpdateSaveObjects(Segment *);

int DoCollisionPoint(int [],int ,int,int *);
int NewCollision(Dungeon *,XImage *,int [], int [],int,int,int,int[100],
				struct bang *);
void UpdateNextObject(Segment*, int[3][]);
void GetHeights(Dungeon *,int *,int *);
void MakeFloor(Dungeon *);
void DrawFloor(Dungeon *,XImage *,struct Picture_Type *);
int GetOffset(int);
void TwoDSortPolygons(Polygon **s_plys,short int pts[]);


#endif
