
#include <stdio.h>
#include "generic.h"
#include "readddm.h"
#include "mymem.h"

struct movement *
ReadMove(FILE *fp)
{
	struct FileMove FMove;
	struct movement *Move;
	Move=MyMalloc(sizeof(struct movement),"movement");
	if(Move) {
		fread(&FMove,sizeof(struct FileMove),1,fp);

		Move->DestXAng=FMove.DestX;
		Move->DestYAng=FMove.DestY;
		Move->DestZAng=FMove.DestZ;
		Move->DeltXAng=FMove.DeltX;
		Move->DeltYAng=FMove.DeltY;
		Move->DeltZAng=FMove.DeltZ;
		Move->Waiter=FMove.Waiter;
		Move->MotionX=FMove.MotX;
		Move->MotionY=FMove.MotY;
		Move->MotionZ=FMove.MotZ;

		if(FMove.NotLast) {
			Move->Moves=ReadMove(fp);
		} else {
			Move->Moves=NULL;
		}
	} else {
		fprintf(stdout,"Too little RAM\n");
	}
	return(Move);
}

struct Bigmove *
ReadBigMove(FILE *fp)
{
	struct FileBigMove FBMove;
	struct Bigmove *Move;
	Move=MyMalloc(sizeof(struct Bigmove),"bigmove");
	if(Move) {
		fread(&FBMove,sizeof(struct FileBigMove),1,fp);
		Move->ObjectID=FBMove.ObjectId;
		Move->Move=ReadMove(fp);
		if(FBMove.NotLast) {
			Move->Next=ReadBigMove(fp);
		} else {
			Move->Next=NULL;
		}
	} else {
		fprintf(stdout,"Low in RAM\n");
	}
	return(Move);
}

struct Bigmove **
LoadMoves(char *fname)
{
	int i;
	struct Bigmove **Array=NULL;
	struct ddmheader Header;
	FILE *fp;
	fp=fopen(fname,"rb");
	if(fp) {
		fread(&Header,sizeof(struct ddmheader),1,fp);
		//fseek(fp,Header.NumMoves*4,SEEK_CUR); // Skip this bit ...
		/* Check Valid + Version */
		//fprintf(stdout,"Try to alloc %d\n",(Header.NumMoves+1)*4);
		Array=MyMalloc((Header.NumMoves+20)*4,"MovesArray");// Allow 20 new ones
		if(Array) {
			for(i=0;i<Header.NumMoves;i++) {
				Array[i]=ReadBigMove(fp);
			}
			while(i<Header.NumMoves+20) {
				Array[i++]=NULL;
			}
		} else {
			fprintf(stdout,"Short of RAM\n");
		}
		fclose(fp);
	} else {
		fprintf(stdout,"Can't open movement's file\n");
	}
	return(Array);
}

void
FreeMove(struct movement *move)
{
	if(move->Moves) {
		FreeMove(move->Moves);
	}
	MyFree(move,"movement");
}

void 
FreeBigMove(struct Bigmove *move)
{
	if(move->Next) {
		FreeBigMove(move->Next);
	}
	if(move->Move) {
		FreeMove(move->Move);
	}
	MyFree(move,"bigmove");
}


void
FreeMoves(struct Bigmove *Moves[])
{
	int i;
	for(i=0;Moves[i];i++) {
		FreeBigMove(Moves[i]);
	}
	MyFree(Moves,"Moves-array");
}

