#include <sys/types.h>
#include "text.h"
#include "id.h"
#include "poly.h"
#include "window.h"
#include "pcx.h"

/*#define ANY_SIZE_TXTS */

//#ifndef SWEET

// This was used (by game)
/*
 *  static void 
 *  XXXXXColLineSWEET(int minix,int dist,int yc, uchar *dest, uchar color)
 *  {
 *  // this function is NO-MORE .. it's been in-lined 
 *  dest+=minix+(yc<<10);
 *  while ( dist--) {
 *  *(dest++)=color;
 *  }
 *  }
 */

/* This is used (by editor) */
static void 
ColLine(int minix,int dist,int yc, uchar *dest, uchar color)
{
    dest+=minix+(yc*MAX_WINDOW_WIDTH);
    while ( dist--) {
	    *(dest++)=color;
	}
}

static void textline(int x1, int dist, int y, int tx1, int ty1, int tx2, 
					  int ty2, uchar *dest_data, struct Picture_Type *texture)
{
    uchar *src_data;
    char xdiff, ydiff; 
	char x_unit=1;
	char y_unit= texture->Width; 
	short x_term, y_term; 
	short x_err = 0;
	short y_err = 0;
    
#ifdef ANY_SIZE_TXTS
    src_data = (texture->Data) + (ty1 * texture->Width) + tx1;
#else
    src_data = (texture->Data) + (ty1 << (texture->shift)) + tx1;
#endif

    if ((ydiff = ty2 - ty1) < 0) {
	y_unit = -y_unit;
	ydiff = -ydiff;
	
    } 
    
    if ((xdiff = tx2 - tx1) < 0) {
	x_unit = -x_unit;
	xdiff = -xdiff;
    }	
   
    y_term = ((ydiff << 8 ) / dist );
    x_term = (xdiff << 8) / dist;
    
#ifdef SWEET
    dest_data += (y << 10) + x1;
#else
    dest_data += (y * MAX_WINDOW_WIDTH) + x1;
#endif

/*
 *  For optimization, these 8-bit shifts, chould be changed to
 *    stuff like movb %ah,%cl
 *    the &=0xFF could go to xor %al,%al  (maybe).
 */
    
    while (dist--) {
		*(dest_data++) = *src_data;
		x_err += x_term;
		src_data += x_unit * (x_err >> 8);
		x_err &= 0xFF;
		y_err += y_term;
		src_data += y_unit * (y_err >> 8);  
		y_err &= 0xFF;
    }
}

#ifdef SWEET
static void 
textSWEET(int x1, int dist, int y, int tx1, int ty1, int tx2, 
					  int ty2, uchar *dest_data, struct Picture_Type *texture)
{
    uchar *src_data;
    char xdiff, ydiff; 
	char x_unit=1;
	char y_unit= texture->Width; 
	short x_term, y_term; 
	short x_err = 0;
	short y_err = 0;
    src_data = (texture->Data) + (ty1 << (texture->shift)) + tx1;
    if ((ydiff = ty2 - ty1) < 0) {
		y_unit = -y_unit;
		ydiff = -ydiff;
    } 
    if ((xdiff = tx2 - tx1) < 0) {
		x_unit = -x_unit;
		xdiff = -xdiff;
    }	
    y_term = (ydiff << 8) / dist ;
    x_term = (xdiff << 8) / dist;
    dest_data += (y << 10) + x1;
    while (dist--) {
		*(dest_data++) = *src_data;
		x_err += x_term;
		src_data += x_unit * (x_err >> 8);
		x_err &= 0xFF;
		y_err += y_term;
		src_data += y_unit * (y_err >> 8);  
		y_err &= 0xFF;
    }
}
#endif
void NewDrawRectangle (int Points[], uchar * dest,
		       struct Picture_Type *texture,short *newptsX,short *newptsY)
{
	int test5=0,test6=0,test7=0,test8=0;
	/* test5,6,7,8 are used uninitialised ....
		sometimes.. (in the for loop line)
		It doesn't matter */
	
    int mny, mxy, yc, x1, x2, x3, x4, y1, y2, y3, y4, minix, maxix, 
		tex1x = 0, tex1y = 0, tex2x = 0, tex2y = 0, 
		xinc1 = 0, xinc2 = 0, xinc3 = 0, xinc4 = 0,
		xt1 = 0, xt2 = 0, xt3 = 0, xt4 = 0, 
		sx1, sx2, sx3, sx4, 
		xu1 = 1, xu2 = 1, xu3 = 1, xu4 = 1, 
		div1, div2, div3, div4;
    int th, tw,dist;
    int test1,test2,test3,test4;

	x1=sx1=sx2= newptsX[Points[0]];
	x2=sx3= newptsX[Points[1]];
	x3= newptsX[Points[2]];
    x4=sx4= newptsX[Points[3]];

    mxy = mny = y1=newptsY[Points[0]];
    
    if ((y2=newptsY[Points[1]]) < mny)
		mny = y2;
    if ((y3=newptsY[Points[2]]) < mny)
		mny = y3;
    if ((y4=newptsY[Points[3]]) < mny)
		mny = y4;

    if (mny > MAX_WINDOW_HEIGHT - 1) // Should be MAIN_ for game 
									 // and MAX_ for demo
		return;			/* This provides NO clipping 
					   for smaller window sizes */
    if (y2 > mxy)
		mxy = y2;
    if (y3 > mxy)
		mxy = y3;
    if (y4 > mxy)
		mxy = y4;

    if (mxy < 0) 
		return;
		
    if (mny < 0)
		mny = 0;
    if (mxy > MAX_WINDOW_HEIGHT - 1)
		mxy = MAX_WINDOW_HEIGHT - 1;
    
    th = texture->Height-1;
    tw = texture->Width-1;

    test1=((mny - y1) * th);
    test2=((mny - y1) * tw);
    test3=((mny - y2) * th);
    test4=((mny - y4) * tw);

    if ((div1 = y1 - y4)) {
		test5=(th<<6)/div1;
		test1=(test1<<6)/div1;
		if((xinc1 = ((x1-x4)<<6) / div1)<0) {
			xinc1= -xinc1;
			xu1=-1;
		}
		if(div1>0) {
			sx1=x4;
		}
	}
    if ((div2 = y2 - y1)) {
		test6=(th<<6)/div2;
		test2=(test2<<6)/div2;
		if((xinc2 = ((x2-x1)<<6) / div2)<0) {
			xinc2=-xinc2;
			xu2= -1;
		}
		if(div2<0) {
			sx2=x2;
		}
	}
    if ((div3 = y3 - y2)) {
		test7=(th<<6)/div3;
		test3=(test3<<6)/div3;
		if((xinc3 = ((x3-x2)<<6) / div3)<0) {
			xinc3= -xinc3;
			xu3= -1;
		}
		if(div3<0) {
			sx3=x3;
		}
	}
    if ((div4 = y4 - y3)) {
		test8=(th<<6)/div4;
		test4=(test4<<6)/div4;
		if((xinc4 = ((x4-x3)<<6) / div4) < 0) {
			xinc4= -xinc4;
			xu4=-1;
		}
		if(div4 > 0) {
			sx4= x3;
		}
	}
    
#ifdef CLIP_Y_GOOD
    if (y1 < 0) {
		xt1 -= (y1) * xinc1;
		xt2 -= (y1) * xinc2;
    }
    if (y2 < 0) {
		xt2 -= (y2) * xinc2;
		xt3 -= (y2) * xinc3;
    }
    if (y3 < 0) {
		xt3 -= (y3) * xinc3;
		xt4 -= (y3) * xinc4;
    } 
    if (y4 < 0) {
		xt1 -= (y4) * xinc1;
		xt4 -= (y4) * xinc4;
    }
#endif

    
	

    for (yc = mny; yc < mxy; 
				yc++,test3+=test7,test2+=test6,test4+=test8,test1+=test5) {
		minix = MAX_WINDOW_WIDTH;
		maxix = -1;

		/********/
		if ((y4 >= yc || y1 >= yc) && (y4 <= yc || y1 <= yc)) {
			if (y4 != y1) {
			
				sx1 += (xu1 * (xt1 >> 6));
				xt1 &= 63;
			
				minix=maxix=sx1;
				tex1x=tex2x=0;
				tex1y=tex2y=test1>>6; //test1/div1;
				if(tex2y<0) {
					tex1y=tex2y=-tex2y;
				}
				xt1 += xinc1;
			}
		}

		/********/
		if ((y1 >= yc || y2 >= yc) && (y1 <= yc || y2 <= yc)) {
			if (y1 != y2) {
			
				sx2 += (xu2 * (xt2 >> 6));
				xt2 &= 63;
			
				if (sx2 < minix) {
					minix = sx2;
					tex1y = 0;
					tex1x = test2>>6; //test2/div2; //((yc-y1)*tw)/div2;
					if (tex1x < 0)
						tex1x = -tex1x;
				}
				if (sx2 > maxix) {
					maxix = sx2;
					tex2y = 0;
					tex2x = test2>>6; //test2/div2; //((yc-y1)*tw)/div2;
					if (tex2x < 0)
						tex2x = -tex2x;
				}
				xt2 += xinc2;
			}
		}
		/********/
				
		if ((y2 >= yc || y3 >= yc) && (y2 <= yc || y3 <= yc)) {
			if (y3 != y2) {
			
				sx3 += (xu3 * (xt3 >> 6));
				xt3 &= 63;
			
				if (sx3 < minix) {
					minix = sx3;
					tex1x = tw;
					tex1y = test3>>6; //test3/div3; //((yc-y2)*th)/div3;
					if (tex1y < 0)
						tex1y = -tex1y;
				}

				if (sx3 > maxix) {
					maxix = sx3;
					tex2x = tw;
					tex2y = test3>>6; //test3/div3; //((yc-y2)*th)/div3;
					if (tex2y < 0)
						tex2y = -tex2y;
				}
				xt3 += xinc3;
			}
		}
		/********/
			
		if ((y3 >= yc || y4 >= yc) && (y3 <= yc || y4 <= yc)){
			if (y3 != y4) {

				sx4 += (xu4 * (xt4 >> 6));
				xt4 &= 63;
			
				if (sx4 < minix) {
					minix = sx4;
					tex1y = th;
					tex1x = test4>>6; //test4 / div4;
					if (tex1x < 0)
						tex1x = -tex1x;
				}
				if (sx4 > maxix) {
					maxix = sx4;
					tex2y = th;
					tex2x = test4>>6; //test4 / div4; //((yc-y4)*tw)/div4;
					if (tex2x < 0)
					tex2x = -tex2x;
				}
				xt4 += xinc4;
			}
		}
		/********/
	
		if (minix < 0)
		    minix = 0;
	
		if (maxix > MAX_WINDOW_WIDTH - 1)
	 		maxix = MAX_WINDOW_WIDTH - 1;
	
		if ( (dist=maxix-minix) > 0 ) {
			#ifndef SWEET
	    	textline (minix,dist,yc,tex1x,tex1y,tex2x,tex2y,dest,texture);
			#else
	    	textSWEET (minix,dist,yc,tex1x,tex1y,tex2x,tex2y,dest,texture);
			#endif
		}
    }
}

void ColourDrawRectangle(int Points[], uchar *dest,short *newptsX,
						short *newptsY,int color)
{
    int mny, mxy, yc, x1, x2, x3, x4, y1, y2, y3, y4, minix, maxix, 
	xinc1 = 0, xinc2 = 0, xinc3 = 0, xinc4 = 0,
	xt1 = 0, xt2 = 0, xt3 = 0, xt4 = 0, 
	sx1, sx2, sx3, sx4, 
	xu1 = 1, xu2 = 1, xu3 = 1, xu4 = 1, 
	div1, div2, div3, div4;
    int dist;
    
    x1 = sx1 =sx2= newptsX[Points[0]];
    x2 = sx3 =newptsX[Points[1]];
    x3 = newptsX[Points[2]];
    x4 = sx4 = newptsX[Points[3]];

    //y1 = newptsY[Points[0]];
    y2 = newptsY[Points[1]];
    y3 = newptsY[Points[2]];
    y4 = newptsY[Points[3]];

    mxy = mny = y1=newptsY[Points[0]];
    
    if (y2 < mny)
		mny = y2;
    if (y3 < mny)
		mny = y3;
    if (y4 < mny)
		mny = y4;

    if (mny > MAX_WINDOW_HEIGHT - 1)
		return;			/* This provides NO clipping 
					   for smaller window sizes */
    if (y2 > mxy)
		mxy = y2;
    if (y3 > mxy)
		mxy = y3;
    if (y4 > mxy)
		mxy = y4;

    if (mxy < 0) 
                return;
		
    if (mny < 0)
	        mny = 0;
    if (mxy > MAX_WINDOW_HEIGHT - 1)
		mxy = MAX_WINDOW_HEIGHT - 1;

    if ((div1 = y1 - y4)) {
		if((xinc1 = ((x1-x4)<<6) / div1)<0) {
			xinc1= -xinc1;
			xu1=-1;
		}
		if(div1>0) {
			sx1=x4;
		}
	}
    if ((div2 = y2 - y1)) {
		if((xinc2 = ((x2-x1)<<6) / div2)<0) {
			xinc2=-xinc2;
			xu2= -1;
		}
		if(div2<0) {
			sx2=x2;
		}
	}
    if ((div3 = y3 - y2)) {
		if((xinc3 = ((x3-x2)<<6) / div3)<0) {
			xinc3= -xinc3;
			xu3= -1;
		}
		if(div3<0) {
			sx3=x3;
		}
	}
    if ((div4 = y4 - y3)) {
		if((xinc4 = ((x4-x3)<<6) / div4) < 0) {
			xinc4= -xinc4;
			xu4=-1;
		}
		if(div4 > 0) {
			sx4= x3;
		}
	}
    
#ifdef CLIP_Y_GOOD
    if (y1 < 0) {
		xt1 -= (y1) * xinc1;
		xt2 -= (y1) * xinc2;
    }
    if (y2 < 0) {
		xt2 -= (y2) * xinc2;
		xt3 -= (y2) * xinc3;
    }
    if (y3 < 0) {
		xt3 -= (y3) * xinc3;
		xt4 -= (y3) * xinc4;
    } 
    if (y4 < 0) {
		xt1 -= (y4) * xinc1;
		xt4 -= (y4) * xinc4;
    }
#endif

    for (yc = mny; yc < mxy; yc++) {
		minix = MAX_WINDOW_WIDTH;
		maxix = -1;

		/********/
		if ((y4 >= yc || y1 >= yc) && (y4 <= yc || y1 <= yc)) {
			if (y4 != y1) {
				sx1 += (xu1 * (xt1 >> 6));
				xt1 &= 63;
				if (sx1 < minix) minix = sx1;
				if (sx1 > maxix) maxix = sx1;		
				xt1 += xinc1;
			}
		}

		/********/
		if ((y1 >= yc || y2 >= yc) && (y1 <= yc || y2 <= yc)) {
			if (y1 != y2) {
				sx2 += (xu2 * (xt2 >> 6));
				xt2 &= 63;
				if (sx2 < minix) minix = sx2;
				if (sx2 > maxix) maxix = sx2;
				xt2 += xinc2;
			}
		}
		/********/
		
		if ((y2 >= yc || y3 >= yc) && (y2 <= yc || y3 <= yc)) {
			if (y3 != y2) {
				sx3 += (xu3 * (xt3 >> 6));
				xt3 &= 63;
				if (sx3 < minix) minix = sx3;
				if (sx3 > maxix) maxix = sx3;
				xt3 += xinc3;
			}
		}
		/********/
		
		if ((y3 >= yc || y4 >= yc) && (y3 <= yc || y4 <= yc)){
			if (y3 != y4) {
				sx4 += (xu4 * (xt4 >> 6));
				xt4 &= 63;
				if (sx4 < minix) minix = sx4;
				if (sx4 > maxix) maxix = sx4;
				xt4 += xinc4;
			}
		}
		/********/
	
		if (minix < 0)
		    minix = 0;
	
		if (maxix > MAX_WINDOW_WIDTH - 1)
	 		maxix = MAX_WINDOW_WIDTH - 1;
	
		if ( (dist=maxix-minix) > 0 ) {
	/*
	 *  The compiler makes a balls of this....
	 *    I can get an extra 1200 micros off
     *    by changing the inner loop a bit.
	 */ 
			#ifdef SWEET
			uchar *tmpdest;
			tmpdest=dest+minix+(yc<<10);
			while ( dist--) {
				*(tmpdest++)=color;
			}
			#else
			ColLine(minix,dist,yc,dest,color);
			#endif
		}
    }

}

