

/************************************************************************
 *
 *	DEMO.C													DEMO.C
 *
 *	This module contains the functions required to twist and bulge a 
 *	picture on the screen.
 *	Only one function may be called from outside this file:
 *		DoDemo()
 *
 ***********************************************************************/


#include "window.h"
#include "generic.h"
#include "demo.h"
#include "text.h"
#include "graph.h"
#include <math.h>
#include "poly.h"
#include "mymem.h"
#include "games.h"
#include "polyinit.h"

#include <X11/Xutil.h>
#include <X11/Xlib.h>
#include <stdio.h>

#include <sys/shm.h>
#include <X11/extensions/XShm.h>


#define Pixel(a,b,c) ((uchar)(*((c->data)+a+((b)*c->width))))

static const double pi = 3.1415926535;
static const double epsilon = 0.000001 ;
static const int size = 384;

static int intX[70][70];
static int intY[70][70];
static short arr1[4],arr2[4];

void
DoWater(Display *display,Window win,GC gc,XImage *vscreen,int basepix,
		char costbl[],int j,struct Picture_Type *mantis,int size,
		uchar *new_water, int width, int height)
{
	int x,y ;
	int tmp=0,tmp1=basepix+160,tmp2,tmp3;

	for (x=0;x<width;x++) {
		tmp2=j+x;
		tmp3=j;
		for (y=0;y<height;y++) {
			tmp=y*width;//(y<<6)+(y<<8);
			
			new_water[x+tmp]= tmp1+(costbl[tmp2%size]
								+costbl[(tmp2/2)%size]
								+costbl[(tmp3)%size]
								+costbl[(tmp3++/2)%size])%32;
			if (new_water[x+tmp]<basepix+96) {
				new_water[x+tmp]=192-new_water[x+tmp];//basepix;
			}
		} // Y
	} // X
			
	CopyArea(new_water,0,0,width,vscreen->data,150,100,vscreen->width,width,height);	
	CopyArea(new_water,0,0,width,vscreen->data,150+180,100,vscreen->width,width,height);	
	CopyArea(new_water,0,0,width,vscreen->data,150+360,100,vscreen->width,width,height);	
	CopyArea(new_water,0,0,width,vscreen->data,150+540,100,vscreen->width,width,height);	
		
	CopyArea(new_water,0,0,width,vscreen->data,150,280,vscreen->width,width,height);	
	CopyArea(new_water,0,0,width,vscreen->data,150+540,280,vscreen->width,width,height);	
	
	CopyArea(new_water,0,0,width,vscreen->data,150,460,vscreen->width,width,height);	
	CopyArea(new_water,0,0,width,vscreen->data,150+180,460,vscreen->width,width,height);	
	CopyArea(new_water,0,0,width,vscreen->data,150+360,460,vscreen->width,width,height);	
	CopyArea(new_water,0,0,width,vscreen->data,150+540,460,vscreen->width,width,height);	
 		 		
	CopyArea(mantis->Data,0,0,mantis->Width,
             vscreen->data,330,230,vscreen->width,
             mantis->Width,mantis->Height);
	return;
}

void
DoCosines(char costbl[],char val)
{
	int i;
	for (i=0;i< 360;i++) {
			costbl[i]=(cos(i*6.28/val)*32);
	}	
}

void
CyclePalette(Display *display,Colormap OurColours,int basepix, uchar pal[])
{
	int i,tmpR=0,tmpG=0,tmpB=0;
		
	tmpR=pal[128*3];
	tmpG=pal[(128*3)+1];
	tmpB=pal[(128*3)+2];
	
	for (i=128*3;i<192*3;i++)
	{
		pal[i]=pal[i+3];	
	}
			
	pal[191*3]=tmpR;
	pal[(191*3)+1]=tmpG;
	pal[(191*3)+2]=tmpB;

	SetPalette3(display,OurColours,pal,basepix,192);
}

void 
GoMad(Display *display,Window win,GC gc,XImage *vscreen,int basepix,Colormap OurColours,
	  Segment **object_array,struct Sound *titlesamp)
{
	int width=180,height=180,j=0;	
	int i=0,dummy=0,dummy1=0;
  	Segment world = {
    0, NULL, 10, 0,
    NULL, {
        NULL, NULL, NULL, NULL, NULL
    },
    0, 0, 0,
    0
    };
	
	Dungeon *dung;
	int RefreshReady=1;
	XShmSegmentInfo shminfo;
	XImage *SHMvscreen;
	int size=360;
	char costbl[size];
	struct Picture_Type *of;
	struct Picture_Type *the;
	struct Picture_Type *death;
	struct Picture_Type *mantis;
	uchar *new_water;
  	int xtrans =20+ MAIN_WINDOW_WIDTH / 2,
        ytrans =50+ (MAIN_WINDOW_HEIGHT / 2)-100,
        ztrans =  -1000;
	int x=100;
 	int minx = 0, maxx = MAIN_WINDOW_WIDTH - 1;
    int miny = 0, maxy = MAIN_WINDOW_HEIGHT - 1;
	uchar pal[768];

    int RefreshComplete=XShmGetEventBase(display) + ShmCompletion;
	XEvent report;

	DoCosines(costbl,90);

	the=Load_PCX("textures/the.pcx",0);
	if(the) {
					RemapPicture(the,basepix,-1);
		of=Load_PCX("textures/of.pcx",0);
		if (of) {
					RemapPicture(of,basepix,-1);
			death=Load_PCX("textures/death.pcx",0);		
			if (death) {
					RemapPicture(death,basepix,-1);
			new_water=(uchar *)MyMalloc(sizeof(uchar)*width*height,"New Water");
			if (new_water) {
				mantis=Load_PCX("textures/us.pcx",0);
				if (mantis) {
					RemapPicture(mantis,basepix,-1);
					GetPaletteFromFile("textures/us.pcx",pal);
					SetPaletteFromFile(display,OurColours,basepix,"textures/us.pcx");
					dung=SetupStuff("objects/dungeon.ddc","objects/player4.ddc",&world,
									NUM_TEXTURES,basepix,&dummy,&dummy1);
					if(dung) {
						SetGlobals(dung);
						world.CurrXAng=32;
				world.CurrZAng=0;
				world.CurrYAng=64;

   			 	SHMvscreen=GetSHMImage(display,&shminfo);
   			 	if(SHMvscreen) {
					while(i<200) {
   			          	if(XCheckMaskEvent(display, 0xFFFFFF, &report)) {
						   	if(report.type==RefreshComplete) {
   			                     fprintf(stdout,"Main Event bit: ready for refresh\n");
   	   			                 RefreshReady=1;
   	   		              	}
						}
   			            while(!RefreshReady) {
   			                 if(XCheckTypedEvent(display,RefreshComplete,&report)) {
   			                     RefreshReady=1;
   			                 }
   			            }
						DoWater(display,win,gc,SHMvscreen,basepix,costbl,j,mantis,size,new_water,width,height);
						ScaleBitmap(SHMvscreen,the,200+i,100,256,basepix);

						RefreshReady=0;
   			 			XShmPutImage(display,win,gc,SHMvscreen,0,0,0,0,1024,768,True);
						i+=15;
					}
						i=0;
					while(i<136) {
   			          	if(XCheckMaskEvent(display, 0xFFFFFF, &report)) {
						   	if(report.type==RefreshComplete) {
   			                     fprintf(stdout,"Main Event bit: ready for refresh\n");
   	   			                 RefreshReady=1;
   	   		              	}
						}
						i++;
   			 			UpdateObjects(dung,world.Next[0]);
   			 			UpdateObjects(dung,world.Next[1]);
   			 			RotateWorld(&world,dung->NumPoints,dung);
 						
						if (i<19) {
							ztrans+=(i<<3);
						}
						MoveToScreenSWEET(dung,xtrans, ytrans, ztrans, 
										10,dung->Player2Pts+22,
                       		            &minx, &miny, &maxx, &maxy,600);

						while(!RefreshReady) {
   			                 if(XCheckTypedEvent(display,RefreshComplete,&report)) {
   			                     RefreshReady=1;
   			                 }
   			            }

						RefreshReady=0;
						CyclePalette(display,OurColours,basepix,pal);
						
						DoWater(display,win,gc,SHMvscreen,basepix,costbl,j,mantis,size,new_water,width,height);
						ScaleBitmap(SHMvscreen,the,400,100,256,basepix);
						j+=4;
						DrawWorld(basepix,dung,SHMvscreen,400,-1,-1,0);
   			           	if (i>50) {
							if (x<500) {
								ScaleBitmap(SHMvscreen,of,(MAX_WINDOW_WIDTH)-300-x,450,256,basepix);
								x+=20;
							}
							else {
								ScaleBitmap(SHMvscreen,of,(MAX_WINDOW_WIDTH)-800,450,256,basepix);
							}
							if (x<400) {
								ScaleBitmap(SHMvscreen,death,MAIN_WINDOW_WIDTH/2,450,x,basepix);
							}else {
								ScaleBitmap(SHMvscreen,death,MAIN_WINDOW_WIDTH/2,450,400,basepix);
							}
						}	
 						MakeMove((dung->Moves[0])[0], 0,dung->ObjectArray);
						DoMotion(world.Next[0],100000); // Big number (only one object)
   			 			XShmPutImage(display,win,gc,SHMvscreen,0,0,0,0,1024,768,True);
					}
   			     	XShmDetach(display,&shminfo);
   			     	XDestroyImage(SHMvscreen);
   			     	shmdt(shminfo.shmaddr);
   			     	shmctl(shminfo.shmid,IPC_RMID,0);
				}
			FreeStuff(dung);
			}
		FreePic(mantis);	
		}
	MyFree(new_water,"new_water");
	}
	FreePic(death);
	}
	FreePic(of);
	}	
	FreePic(the);
	}
}
/********************************************************************
 *
 *	angle()												angle()
 *
 *	returns the arctan of y/x
 *  This function is faster than the system "atan2()", which is why
 *	we don't use the system function.
 *
 */

static float 
angle(float x, float y)
{
    
    if (fabs(x) < epsilon) {
	    if (fabs(y) < epsilon) {
	        return(0.0);
        }
	    else if (y > 0.0) {
	        return(1.570796327);  /*(pi*0.5);*/
        }
    	else {
	        return(4.712388980);          /*(pi*1.5);*/
        }
    } else if (x<0.0) {
	    return(atan(y/x)+pi);
    } else {
        return(atan(y/x)); 
    }
}

/*************************************************************************
 *
 *	TwistyBulge()										TwistyBulge()
 *
 *	twists the picture in the vscreen. This effect is known as the
 *	vasarly square.
 *
 */

static void 
TwistyBulge(XImage *vscreen,float p,float rotation,
		 float radii[34][34],struct Picture_Type kkp[],int numfd)
{
    int iy, ix;
    int hvar;
    int i=0,j=0;
    float r,theta,x=-1, y;
    Polygon dummypoly= { { 0,1,2,3 }, 0,0};
    
    for (ix = 0; ix <28 ; ix++) {    /* controls the number of lines drawn */
	    y=-1;
	    for (iy =0; iy<20 ; iy++) { 
	        r=sqrt(x*x+y*y);//radii[1][1] ;
	        theta = angle(x,y);   
            //theta=atan2(y,x);
	        if (r < 1.0) { 			    
				if(p!=1.0) {
		        	//r=exp(log(r)*p); // p=1 // r=exp(log(r));
				}
		        theta+=(1.0-r)*rotation ;			    
            }
		    intX[i][j]= (((size * r * cos(theta))+512)); 
		    intY[i][j]= (size * r * sin(theta))+size;
	        j++;
	        y += 0.1;
	    }
	    x+=0.075;
	    j=0;
	    i++;
    }
    hvar=0;
    for (j=1;j<19;j++){    
	    for (i=1;i<28;i++) {
	        arr1[0]=intX[i-1][j];
	        arr1[1]=intX[i][j];
	        arr1[2]=intX[i][j+1];
	        arr1[3]=intX[i-1][j+1];
	    
	        arr2[0]=intY[i-1][j];
	        arr2[1]=intY[i][j];
	        arr2[2]=intY[i][j+1];
	        arr2[3]=intY[i-1][j+1];
	    
	        NewDrawRectangle (dummypoly.Points, (uchar *) (vscreen->data), 
			      &kkp[hvar++],arr1, arr2);
	    
	        /*linedraw(intX[i-1][j],intY[i-1][j],intX[i][j],intY[i][j],1,
						vscreen);    */
	        /*linedraw(intX[i-1][j],intY[i-1][j],intX[i-1][j+1],
						intY[i-1][j+1],1,vscreen); */
	    }
    } 
}

/************************************************************************
 *
 *	MaketexData()									MakeTexData()
 *
 *	copy a small square out od the buffer src, to be used as a 
 *	texture to be mapped onto the vasarly square.
 * 
 */

static char *
MakeTexData(char *src)
{
    int i,j;
    char *tmp,*tmp2;
    tmp2=tmp=MyMalloc(32*32,"Title-texture");

    if(tmp2) {
    	for(i=0;i<32;i++) {            /* Width of texture square */
			for(j=0;j<32;j++) {
	    		*(tmp++)=*(src++);
			}
			src+=(1024-32);
    	}
	}
    return(tmp2);
}

/************************************************************************
 *
 *	FreeTexts()												FreeTexts()
 *
 *	Frees Previously allocated textures.
 *
 */
    
static void
FreeTexts(struct Picture_Type p[768])
{
	int i;
	for(i=0;i<(27*18);i++) {
		MyFree(p[i].Data,"title-text");
	}
}

/*************************************************************************
 *
 *	SetupTexts()											SetupTexts()
 *
 *	Sets up the texture structures, to be used in the vasarly square.
 *
 */

static void 
SetupTexts(struct Picture_Type p[768],char *data1)
{
    uchar *thedata;
    int i,j,a=0;

    thedata=data1+80+1024*85;

    for(j=0;j<18;j++) {     /* num of polys heightwise */    
		for(i=0;i<27;i++) {  /* the number of polygons widthtwise */
	    	p[a].Data=MakeTexData(thedata);
	   
	    	p[a].shift=5;       /* 2 to the 5 = 32 */
	    	p[a].Width=32;
	    	p[a++].Height=32;
	    	thedata+=32;
		}
		thedata+=(1024*32);
		thedata+=160;
    }    
}

/**********************************************************************
 *
 *	SetupRadii()										SetupRadii()
 *
 *	used to optimize the calculations of the vasarly square, by 
 * 	precalculating the various radii.
 *
 */

static void 
SetupRadii(float radii[34][34])
{
    float i,j;
    int x=0,y=0;

    for(i=0;i<=24;i+=0.75)
	{
	    for (j=0;j<=32;j++)
		{
		    radii[x][y]=sqrt(i*i+j*j);
		    y++;
		}
	y=0;
	x++;
	}
}

/************************************************************************* 
 *
 * DoDemo()													DoDemo()
 *
 * Does a Vasarly square thingy, Leaves the screen Black, with an All-
 * black palette. Makes NO asumptions about palette, sets it itself.
 *
 */

int 
DoDemo(Display *display, Window win, GC gc, XImage *vscreen,int basepix,
		Colormap ColMap,struct Sound *mantisnd)
{
    XEvent report;
    int finished=0;
    int twistbulge=1;
    float twist=0.0,bulge=1,off=0.1;
    float radii[34][34]={{0}};
    struct Picture_Type Texts[768];
    struct Picture_Type *tmppcx;
	char pal[768]={0};

	//return(0);
	SetPalette3(display,ColMap,pal,basepix,192);
	ClearScreen(vscreen);
	//XPutImage(display,win,gc,vscreen,0,0,0,0,MAX_WINDOW_WIDTH,
		  	  //MAX_WINDOW_HEIGHT);
	LoadImageCentre(vscreen,basepix,"textures/vasar.pcx",MAX_WINDOW_WIDTH,
				MAX_WINDOW_HEIGHT);

	tmppcx=Load_PCX("textures/vasar.pcx",1);
	if(tmppcx) {
		memcpy(pal,tmppcx->Palette,768);
		FreePic(tmppcx);
	}


    SetupTexts(Texts,vscreen->data);
    SetupRadii(radii);
	PlaySound(mantisnd);
	ClearScreen(vscreen);
    while(!finished) {
		if(XCheckMaskEvent(display,ButtonPressMask|KeyPressMask,&report)) {
	    	switch(report.type) {
	    	case KeyPress:
				switch(report.xkey.keycode) {
				case 24:
                    fprintf(stdout,"Babe, I'm gonna leave you\n");
				    finished=2;
				    break;
				case 25:
				    break;
				case 26:
				    twistbulge^=1;
				    break;
				case 27:
				    off=0;
				    break;
				case 28:
				    off=0.05;
				    break;
				case 29:
				    twist+=0.02;
				    break;
				case 30:
				    twist-=0.02;
				    break;
				case 31:
				    bulge+=0.02;
				    break;
				case 32:
				    bulge-=0.02;
				    break;
				default:
				    finished=1;
				    break;
				}
				break;
			case ButtonPress:
				finished=1;
				break;
	    	}
		}
		TwistyBulge(vscreen,bulge,twist,radii,Texts,3);
		if (twistbulge) {
			twist+=off;
			if (twist<=-1.2) off=0.05;
			if (twist>=1.2) off=-0.05;
		} else {
			bulge+=off;
			if (bulge<=0.8) off=0.05;
			if (bulge>=1.8) off=-0.05;
		}
		XPutImage(display,win,gc,vscreen,0,0,0,0,MAX_WINDOW_WIDTH,
			  	  MAX_WINDOW_HEIGHT);
		SetPalette3(display,ColMap,pal,basepix,192);
		ClearScreen(vscreen);
    }
	WaitForSilence();
	FreeTexts(Texts);
	FadeToBlack(display,ColMap,pal,basepix,10);
	ClearScreen(vscreen);
	XPutImage(display,win,gc,vscreen,0,0,0,0,MAX_WINDOW_WIDTH,
		  	  MAX_WINDOW_HEIGHT);
	return(finished-1);
}


