#include "mymem.h"
#include "games.h"
#include "poly.h"
#include "net.h"
#include "polyinit.h"
#include "graph.h"
#include "xstuff.h"
#include "window.h"
#include "selectp.h"
#include "sound.h"
#include "winlose.h"
#include "misc.h"
#include "main.h"
#include "ai.h"

#include <X11/Xutil.h>

#include <X11/Xlib.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <X11/extensions/XShm.h>

#include <stdlib.h>

struct Picture_Type **Textures;
Segment **object_array;
Polygon **polygon_array;


short int *PointsX, *PointsY, *PointsZ;
short int *newptsX, *newptsY, *newptsZ;

int Player2Objs;
#define Player1 0


int XShmQueryExtension(Display*);
int XShmGetEventBase(Display*);


void 
SetGlobals(Dungeon *dung)
{
	object_array=dung->ObjectArray;
	Textures=dung->Textures;
	polygon_array=dung->PolygonArray;
	PointsX=dung->Points[0];
	PointsY=dung->Points[1];
	PointsZ=dung->Points[2];
	newptsX=dung->newpts[0];
	newptsY=dung->newpts[1];
	newptsZ=dung->newpts[2];
}


void 
PlayNetGame(Display * display, Window win, GC gc, XImage * MyImage,
     int base_pixel, char *dso_names[],struct Sound **sounds,Colormap ColMap,int Detail,
	 int sha)
{
	Dungeon *dung;
    Segment World = {
	0, NULL, 10, 0, 
	NULL, {
	    NULL, NULL, NULL, NULL, NULL
	},
	0, 0, 0,
	0
    };
    int shmid;
    int ReadSocket, WriteSocket;
    int me, enemy, Frames=0;
    int Number_Of_Points;
    int matchresult;
    int Player2;
	char host[100];

    me = SelectPlayer(display, win, gc, MyImage, dso_names, base_pixel,
						sounds,0,ColMap);
    /* SelectEnemy() should be written so it can't return -1 */

	if(GetOtherHost(display,win,gc,MyImage,base_pixel,host,ColMap)) {
		fprintf(stdout,"So you want to play against %s\n",host);
    	shmid = SetupConnection (host,&ReadSocket, &WriteSocket);
		if(shmid!=-1) {
			WriteMyPlayer (WriteSocket, me);
			enemy = GetEnemyPlayer ();
	
			if ((dung=SetupStuff (dso_names[me], dso_names[enemy], &World,
					  	NUM_TEXTURES, base_pixel,
					  	&Player2, 
					  	&Number_Of_Points))) {
				object_array=dung->ObjectArray;
				Textures=dung->Textures;
				polygon_array=dung->PolygonArray;
				PointsX=dung->Points[0];
				PointsY=dung->Points[1];
				PointsZ=dung->Points[2];
				newptsX=dung->newpts[0];
				newptsY=dung->newpts[1];
				newptsZ=dung->newpts[2];
				Frames = PlayGame (display, win, gc, MyImage, 
					   	Number_Of_Points, Player2,
			   	&World, WriteSocket, NET_GAME,
			   	dung,base_pixel,sounds,&matchresult,Detail,sha);
				FreeStuff (dung);
				if(matchresult==1) {
					ShowWinnerScreen(display,win,gc,NET_GAME,base_pixel);
				} else {
					ShowLoserScreen(display,win,gc,NET_GAME,base_pixel);
				}
    		}
			CloseConnection (ReadSocket, WriteSocket, shmid);
			shmid = 0;
    	}
	}
}

void 
PlayDemoGame(Display * display, Window win, GC gc, XImage * MyImage,
	 int base_pixel, char *dso_names[],struct Sound **sounds,Colormap ColMap,int Detail,
	 int sha)
{
	Dungeon *dung;
    Segment World = {
	0, NULL, 10, 0,
	NULL, {
	    NULL, NULL, NULL, NULL, NULL
	},
	0, 0, 0,
	0
    };
    int me, enemy, Frames=0;
    int Number_Of_Points;
    int matchresult;
    int Player2;
    me = SelectPlayer(display,win,gc,MyImage,dso_names,base_pixel,sounds,0,ColMap);
    enemy = SelectPlayer(display,win,gc,MyImage,dso_names,base_pixel,
						 sounds,0,ColMap); //me+1);

    if ((dung=SetupStuff (dso_names[me], dso_names[enemy], &World,
		      NUM_TEXTURES, base_pixel,
		      &Player2, 
		      &Number_Of_Points))) {
		object_array=dung->ObjectArray;
		polygon_array=dung->PolygonArray;
		Textures=dung->Textures;
		PointsX=dung->Points[0];
		PointsY=dung->Points[1];
		PointsZ=dung->Points[2];
		newptsX=dung->newpts[0];
		newptsY=dung->newpts[1];
		newptsZ=dung->newpts[2];
		Frames = PlayGame (display, win, gc, MyImage, 
				   Number_Of_Points, Player2,
				   &World, 0, DEMO_GAME,
				   dung,base_pixel,sounds,&matchresult,Detail,sha);
		FreeStuff (dung);
		if(matchresult==1) {
			ShowWinnerScreen(display,win,gc,AI_GAME,base_pixel);
		} else {
			ShowLoserScreen(display,win,gc,AI_GAME,base_pixel);
		}
    }
}

void 
PlayAIGame(Display * display, Window win, GC gc, XImage * MyImage,
	 int base_pixel, char *dso_names[],struct Sound **sounds,Colormap ColMap,int Detail,
	 int sha)
{
	Dungeon *dung;
    Segment World = {
	0, NULL, 10, 0,
	NULL, {
	    NULL, NULL, NULL, NULL, NULL
	},
	0, 0, 0,
	0
    };
    int me, enemy, Frames=0;
    int Number_Of_Points;
    int matchresult;
    int Player2;
    me = SelectPlayer(display,win,gc,MyImage,dso_names,base_pixel,sounds,0,ColMap);
    enemy = SelectPlayer(display,win,gc,MyImage,dso_names,base_pixel,
						 sounds,0,ColMap); //me+1);

    if ((dung=SetupStuff (dso_names[me], dso_names[enemy], &World,
		      NUM_TEXTURES, base_pixel,
		      &Player2, 
		      &Number_Of_Points))) {
		object_array=dung->ObjectArray;
		polygon_array=dung->PolygonArray;
		Textures=dung->Textures;
		PointsX=dung->Points[0];
		PointsY=dung->Points[1];
		PointsZ=dung->Points[2];
		newptsX=dung->newpts[0];
		newptsY=dung->newpts[1];
		newptsZ=dung->newpts[2];
		Frames = PlayGame (display, win, gc, MyImage, 
				   Number_Of_Points, Player2,
				   &World, 0, AI_GAME,
				   dung,base_pixel,sounds,&matchresult,Detail,sha);
		FreeStuff (dung);
		if(matchresult==1) {
			ShowWinnerScreen(display,win,gc,AI_GAME,base_pixel);
		} else {
			ShowLoserScreen(display,win,gc,AI_GAME,base_pixel);
		}
    }
}

void 
PlayDumbGame(Display * display, Window win, GC gc, XImage * MyImage,
		   int base_pixel, char *dso_names[],struct Sound **sounds,Colormap ColMap,int Detail,
			int sha)
{
	Dungeon *dung;
    Segment World = {
	0, NULL, 10, 0,
	NULL, {
	    NULL, NULL, NULL, NULL, NULL
	},
	0, 0, 0,
	0
    };
    int me, enemy, Frames=0;
    int Number_Of_Points; 
    int matchresult;
    int Player2;
    me = SelectPlayer(display,win,gc,MyImage,dso_names,base_pixel,sounds,0,ColMap);
    enemy = 4;
    
    if ((dung=SetupStuff (dso_names[me], dso_names[enemy], &World,
		      NUM_TEXTURES, base_pixel,
		      &Player2, 
		      &Number_Of_Points))) {
		object_array=dung->ObjectArray;
		polygon_array=dung->PolygonArray;
		Textures=dung->Textures;
		PointsX=dung->Points[0];
		PointsY=dung->Points[1];
		PointsZ=dung->Points[2];
		newptsX=dung->newpts[0];
		newptsY=dung->newpts[1];
		newptsZ=dung->newpts[2];
		Frames = PlayGame (display, win, gc, MyImage, 
				   Number_Of_Points, Player2,
				   &World, 0, DUMB_GAME,
				   dung,base_pixel,sounds,&matchresult,Detail,sha);
		FreeStuff (dung);
    }
}

void 
PlayGameType(int Type, Display * display, Window win, GC gc, 
		   XImage * MyImage, int base_pixel,struct Sound **sounds,Colormap ColMap,int Detail,
			int sha)
{
    char *dso_names[5] = {
		"objects/player0.ddc", "objects/player1.ddc", 
		"objects/player2.ddc", "objects/player3.ddc",
		"objects/player4.ddc"
    };
    switch(Type) {
    case NET_GAME:
	PlayNetGame(display, win, gc, MyImage, base_pixel, dso_names,sounds,ColMap,Detail,sha);
	break;
    case AI_GAME:
	PlayAIGame(display, win, gc, MyImage, base_pixel, dso_names,sounds,ColMap,Detail,sha);
	break;
    case DUMB_GAME:
	PlayDumbGame(display, win, gc, MyImage, base_pixel, dso_names,sounds,ColMap,Detail,sha);
	break;
    case DEMO_GAME:
	PlayDemoGame(display, win, gc, MyImage, base_pixel, dso_names,sounds,ColMap,Detail,sha);
	break;
    default:
	fprintf(stdout, "I can't play that game\n");
	break;
    }
}

#ifdef DebugDumpData
void 
DumpObjDatas(Segment *obj)
{
	int i;
	fprintf(stderr,"\nObject: %d @(%08X)\n",obj->ID,obj);
	fprintf(stderr,"Next: %08X, %08X, %08X, %08X, %08X\n",obj->Next[0],
				obj->Next[1],obj->Next[2],obj->Next[3],obj->Next[4]);
	fprintf(stderr,"Points: (%d->%d) (%d)\n",obj->Poffset,
					obj->Numpoints+obj->Poffset,obj->Numpoints);
	for(i=0;i<5;i++) {
		if(obj->Next[i]) {
			DumpObjDatas(obj->Next[i]);
		}
	}
}

void 
DumpData(Segment *w)
{
	int i;
	fprintf(stderr,"Dungeon of death data\n\n");
	fprintf(stderr,"Objects (in structure)\n");
	DumpObjDatas(w);
	fprintf(stderr,"\n--- Points ---\n");
	for(i=0;i<585;i++) {
		fprintf(stderr,"%4d: %5d %5d %5d\n",i,PointsX[i],PointsY[i],
				PointsZ[i]);
	}
	fprintf(stderr,"end\n");
}

#else

#define DumpData(a) fprintf(stdout,"DumpData() is #defined out...\n");	

#endif	

void 
Bar(XImage *img,int x,int y,int x2,int y2,char col)
{
	int i,j,temp=0;
	char *data=img->data;
	data+=(y*1024)+x;
	for(j=y;j<y2;j++) {
		for(i=x;i<=x2;i++) {
			*(data++)=col;
			temp++;
		}
		data+=(1024-(x2-x));
		temp+=(1024-(x2-x));
	}
}

void
DrawHealth(XImage *img,int player,int level,int bp)
{
	Bar(img,40+(672*player),50,39+(672*player)+(level*4),90,152+bp);
	Bar(img,40+(672*player)+(level*4),50,39+(672*player)+(61*4),90,59+bp);
}


XImage *
GetSHMImage(Display *display,XShmSegmentInfo *shminfo)
{
	XImage *SImage;
	int shmstat;
	shmstat=XShmQueryExtension(display);
	if(shmstat) {
		SImage=XShmCreateImage(display,
							XDefaultVisual(display,DefaultScreen(display)), 
							8, ZPixmap, NULL, shminfo, MAX_WINDOW_WIDTH, 
							MAX_WINDOW_HEIGHT);
		if(SImage) {
			shminfo->shmid= shmget(IPC_PRIVATE, SImage->bytes_per_line * 
										SImage->height, IPC_CREAT|0777);
			if(shminfo->shmid!=-1) {
				shminfo->shmaddr=SImage->data= shmat(shminfo->shmid,0,0);
				if(shminfo->shmaddr) {
					shminfo->readOnly = False;
					shmstat= XShmAttach(display,shminfo);
					if(shmstat) {
						return(SImage);
					}
				}
			}
		}
	}
	fprintf(stdout,"Error geting SHM\n");
	return(NULL);
}

void
Hurt(int *Health)
{
	if(*Health) {
		(*Health)--;
	}
}

void
RefillKeybits(Display *display,char *buff)
{
	int new[8];
	int i;
	int *old=(int *)buff;
	XQueryKeymap(display,(char *)new);
	for(i=0;i<8;i++) {
		old[i]|=new[i];
	}
}

void
AdjustCam(Segment *World,int *xtrans,int *ytrans,int *ztrans) 
{
/*
	*ztrans=270+abs(PointsZ[11]+PointsZ[17])/2;
	if (*ztrans<400) {
		*ztrans=400;
	}
*/
	//fprintf(stdout," Z11 : %d, Z17: %d ztrans %d\n",
	//			PointsZ[11],PointsZ[17],*ztrans);

	if ((260+PointsZ[17]+PointsZ[11])<-500) {
		if (PointsZ[11]<PointsZ[17]) {
			fprintf(stdout,"AAAAA\n");
			PointsZ[11]+=5;
		}
		else if (PointsZ[11]>PointsZ[17]) {
			fprintf(stdout,"BBBB\n");
			PointsZ[17]+=5;
		}
		else if (PointsZ[11]==PointsZ[17]) {
			fprintf(stdout,"CCCC\n");
			PointsZ[17]+=5;
			PointsZ[11]+=5;
		}
            World->CurrZAng = (World->CurrZAng + 2) & 0x7F;
	}
 
*ztrans+=10;
*ztrans-=10;
/*
		if (PointsZ[17]>-130) {
			PointsZ[17]-=5;
			PointsZ[11]+=5; 
		}

		if (PointsZ[11]>-130) {
			PointsZ[11]-=5;
			PointsZ[17]+=5;	
		}
*/
//			*xtrans=(MAIN_WINDOW_WIDTH/2)+((PointsZ[11]-PointsZ[17])/2);
			
}

int
DoKeys(Display *display,char keybits[32],Segment *World,int Health[2],
	   XImage *StatsImage,int game_type,
	   int *StatChange,int *roteflag, int *ztrans,int *persp,int BasePix)
{
	int quiting=0;
	RefillKeybits(display,keybits);
    if(KeyDown(KEY__Q)) {
        quiting=1;
    }
    if(game_type!=DEMO_GAME) {
        if(KeyDown(KEY__W)) {
            PointsZ[11] -= 5;
        }
        if(KeyDown(KEY__E)) {
            PointsZ[11] += 5;
        }
		if(KeyDown(KEY__K)) {
			PointsZ[17]+=5;
			//*ztrans+=10;
		}
		if(KeyDown(KEY__L)) {
			PointsZ[17]-=5;
			//*ztrans-=10;
		}
        if(KeyDown(KEY__R)) {
            World->CurrZAng = (World->CurrZAng + 2) & 0x7F;
        }
        if(KeyDown(KEY__U)) {
            World->CurrXAng = (World->CurrXAng + 2) & 0x7F;
        }
        if(KeyDown(KEY__I)) {
			fprintf(stdout,"Health: %d : %d\n",Health[0],Health[1]);
        }
        if(KeyDown(KEY__O)) {
            Hurt(&Health[0]);
            *StatChange=1;
            DrawHealth(StatsImage,0,Health[0],BasePix);
        }
        if(KeyDown(KEY__P)) {
            Hurt(&Health[1]);
            *StatChange=1;
            DrawHealth(StatsImage,1,Health[1],BasePix);
        }
/*
        if(KeyDown(KEY__J)) {
            *roteflag ^= 1;
        }
		if(KeyDown(KEY__B)) {
			*persp+=20;
		}
		if(KeyDown(KEY__N)) {
			*persp-=20;
		}
*/

    }
	return(quiting);
}

struct Picture_Type **
LoadBangs(int basepix)
{
	struct Picture_Type **bs;
	bs=MyMalloc(16,"bangptrs");
	if(bs) {
		bs[0]=Load_PCX("textures/bang1.pcx",0);
		if(bs[0]) {
			RemapPicture(bs[0],basepix,-1);
			bs[1]=Load_PCX("textures/bang2.pcx",0);
			if(bs[1]) {
				RemapPicture(bs[1],basepix,-1);
				bs[2]=Load_PCX("textures/bang3.pcx",0);
				if(bs[2]) {
					RemapPicture(bs[2],basepix,-1);
					bs[3]=Load_PCX("textures/bang4.pcx",0);
					if(bs[3]) {
						RemapPicture(bs[3],basepix,-1);
						return(bs);
					}
				}
			}
		}
	}
	DEBUG;
	return(NULL);
}


int
CameraZoom(int minx,int miny,int maxx,int maxy,int zt)
{
	int old=zt;
	if(minx<100 || maxx>924 || miny<20 || maxy>500) {
		zt-=5;
	}
	if(minx>120 && maxx<904 && miny>40 && maxy<480) {
		zt+=5;
	}
	return(zt);
}

int 
PlayGame(Display *display, Window win, GC gc, XImage * MyImage,
	      int Number_Of_Points,
	      int Player2, Segment *World,
	      int WriteSocket, int game_type,
		  Dungeon *dung,int basepix,struct Sound **sounds,
		  int *end_return,int BackGrounds,int Shadows)
{
	struct bang Bangs[2]= { { 0,0,0,0 }, { 0,0,0,0 } };
	struct Picture_Type **bangpics;
	int OldNetHealth=-1;
	int OldAng=1000, PerspFactor= 600;
	char keybits[32]={0};
	int Clock,Time;
    int quiting = 0, Frames = 0, slomo = 0;
    XEvent report;
    int xtrans = MAIN_WINDOW_WIDTH / 2, 
		ytrans = (MAIN_WINDOW_HEIGHT / 2)-100, 
		ztrans = 0;
    int minx = 0, maxx = MAIN_WINDOW_WIDTH - 1;
    int miny = 0, maxy = MAIN_WINDOW_HEIGHT - 1;
    int oldmaxx, oldminx, oldmaxy, oldminy;
    int t_mxx, t_mxy, t_mnx, t_mny;
    int dest_x, dest_y;
    int roteflag = 0;
	int floor_error1,floor_error2;
    int FullRedraw = 1;		/* First time */
	Window statswin;
	XImage *StatsImage;
	int StatChange=1;
	int Health[2]= { 60,60 };
	int RefreshReady=1;
	int RefreshComplete=XShmGetEventBase(display) + ShmCompletion;
	int wt1,wt2,wt3,wt4;
	int fightsize=4;	
	int Dists[2][100];

/** Shared Mem X Stuff **/
	XImage *SHMMyImage;
	XShmSegmentInfo shminfo;
	struct Picture_Type *backdrop;
	//struct Picture_Type *wall;
	//struct Picture_Type *test;
	struct Picture_Type *skyline;
	struct Picture_Type *fight;
	
	//SetupWalls(vals);
		
	
	bangpics=LoadBangs(basepix);
	if(bangpics) {	
	fight=Load_PCX("textures/fight.pcx",0);
	if (fight) {
		RemapPicture(fight,basepix,-1);
		skyline=Load_PCX("textures/skyline.pcx",0);
	if (skyline) {
		RemapPicture(skyline,basepix,-1);
		backdrop=Load_PCX("textures/gameback.pcx",0);
		if(backdrop) {	
		  	RemapPicture(backdrop,basepix,-1);
		  	SHMMyImage=GetSHMImage(display,&shminfo);
  			if(SHMMyImage) {
				statswin=SetupStatsWindow(display,gc,win,&StatsImage,basepix);
				if(statswin) {
					PlaySound(sounds[0]);
					DrawHealth(StatsImage,0,Health[0],basepix);
					DrawHealth(StatsImage,1,Health[1],basepix);
					Time=time(NULL);
					Clock=clock();
				
					while(!quiting) {
						quiting=DoKeys(display,keybits,World,Health,StatsImage,
									   game_type,
									   &StatChange,&roteflag,&ztrans,&PerspFactor,basepix);
						if(XCheckMaskEvent(display, 0xFFFFFFFF, &report)) {
							switch(report.type) {
								case Expose:
									FullRedraw = 1;
									break;
								case KeyPress:
									switch(report.xkey.keycode) {
									case 117:
										quiting = 1;
										break;
									case 23:	/* tab */
										slomo ^= 1;
										break;
									case 112:
										DumpData(World);
										break;
									case 45:	/* k */
										//ztrans += 10;
										//fprintf(stdout, "zt=%d\n", ztrans);
										break;
									case 46:	/* l */
										//ztrans -= 10;
										//fprintf(stdout, "zt=%d\n", ztrans);
										break;
									case 47:
										PlaySound(sounds[0]);
										break;
									}
									CheckKeyMoves(dung,report.xkey.keycode);
									break;
								default:
									if(report.type==RefreshComplete) {
										fprintf(stdout,"Main Event bit: ready for refresh\n");
										RefreshReady=1;
									}
									break;
							}
						}
			//fprintf(stdout,"Health: %d : %d\n",Health[0],Health[1]);
						if(!quiting) {
							XQueryKeymap(display,keybits);
							if(roteflag) {
								World->CurrZAng = (World->CurrZAng + 2) & 0x7F;
							}
							if(slomo) {
								WaitAWhile(500);
							}
							Frames++;
							if(game_type == NET_GAME) {
								WriteMyData2(dung,WriteSocket, Player2Objs,
											  object_array,Health[1]);
								if(ReadNetworkPlayer2(dung,Player2Objs, object_array,&Health[0])) {
									quiting = 10;
								}
								if(Health[0]!=OldNetHealth) {
									StatChange=1;
            						DrawHealth(StatsImage,0,Health[0],basepix);
									OldNetHealth=Health[0];
									//fprintf(stdout,"%d %d %d\n",Health[0],StatChange,OldNetHealth);
								}	
								object_array[1]->CurrZAng = 0;
								object_array[1]->CurrYAng = 0;
								object_array[1]->CurrXAng = -32;
							}
							UpdateObjects(dung,World->Next[0]);
							UpdateObjects(dung,World->Next[1]);
							GetHeights(dung,&floor_error1,&floor_error2);
							RotateWorld(World,Number_Of_Points,dung);
							if(game_type != DUMB_GAME) {
								if(NewCollision(dung,SHMMyImage,dung->Colls[0],dung->Hits[1],dung->NumColls[0],dung->NumHits[1],1,Dists[0],&Bangs[0])) {
									Hurt(&Health[1]);
									StatChange=1;
									DrawHealth(StatsImage,1,Health[1],basepix);
								}
								if(game_type == AI_GAME) {
									/* for AI man */
									if(NewCollision(dung,SHMMyImage,dung->Colls[1],dung->Hits[0],dung->NumColls[1],dung->NumHits[0],0,Dists[1],&Bangs[1])) {
										Hurt(&Health[0]);
										StatChange=1;
										DrawHealth(StatsImage,0,Health[0],basepix);
									}
									DoThought2(dung,Player2,Dists[1]);
								}
							}
							oldmaxx = maxx;
							oldminx = minx;
							oldmaxy = maxy;
							oldminy = miny;
							
							//AdjustCam(World,&xtrans,&ytrans,&ztrans);
							/*if (first) {
								fprintf(stdout,"Heello\n");
								InitShadows(dung);
								first=0;
							}*/

							MoveToScreenSWEET(dung,xtrans, ytrans, ztrans, 6,10,
											   &minx, &miny, &maxx, &maxy,PerspFactor);
	
							minx = MAX_WINDOW_WIDTH - 1;
							maxx = 0;
							miny = MAIN_WINDOW_HEIGHT - 1;
							maxy = 0;
							MoveToScreenSWEET(dung,xtrans,ytrans+floor_error1,ztrans,10,
											  dung->Player2Pts+22,&minx,&miny,&maxx, 
											  &maxy,PerspFactor);
							if(game_type!=DUMB_GAME) {
								MoveToScreenSWEET(dung,xtrans, ytrans+floor_error2, ztrans, 
											  dung->Player2Pts+22, Number_Of_Points, 
											  &minx, &miny, &maxx, &maxy,PerspFactor);
							}
							ztrans=CameraZoom(minx,miny,maxx,maxy,ztrans);
							while(!RefreshReady) {
								if(XCheckTypedEvent(display,RefreshComplete,&report)) {
									RefreshReady=1;
								}
							}
							/*ClearScreenSWEET(SHMMyImage, MAX(0, oldminx), MAX(0, oldminy),
											  MIN(oldmaxx, MAIN_WINDOW_WIDTH),
											MIN(oldmaxy, MAIN_WINDOW_HEIGHT));*/
							
							if (fightsize<=545) {
								FullRedraw=1;
								fightsize+=16;
							}	
							if(BackGrounds) {
								if(World->CurrZAng!=OldAng) {
									OldAng=World->CurrZAng;
									//DoWalls(backdrop->Data,wall,World->CurrZAng,World->CurrXAng,ztrans,vals,basepix);
									// Copy the Skyline to the backdrop
						/*			CopyArea(skyline->Data,skyline->Width-(World->CurrZAng*16),0,skyline->Width,
												backdrop->Data,0,100,backdrop->Width,
												skyline->Width-(World->CurrZAng*8),skyline->Height-1);	      */
									wt2=MAX(0,oldminy);
									wt4=MIN(oldmaxy, MAIN_WINDOW_HEIGHT)-wt2;
									// Copy the backdrop to the shared memory
									CopyArea(backdrop->Data,0,wt2,1024,
											SHMMyImage->data,0,wt2,1024,
											1024,wt4);
									CopyArea(skyline->Data,skyline->Width-(World->CurrZAng*16),0,skyline->Width,
												SHMMyImage->data,0,100,SHMMyImage->width,
												skyline->Width-(World->CurrZAng*8),skyline->Height-1);
									if(fightsize<545) {
								//		DoFight(SHMMyImage,fight,MAX_WINDOW_WIDTH/2,100,fightsize,basepix);
									}
									FullRedraw=1;
								} else {
									wt1=MAX(0,oldminx);
									wt2=MAX(0,oldminy);
									wt3=MIN(oldmaxx, MAIN_WINDOW_WIDTH)-wt1;
									wt4=MIN(oldmaxy, MAIN_WINDOW_HEIGHT)-wt2;
									CopyArea(backdrop->Data,wt1,wt2,1024,
										 SHMMyImage->data,wt1,wt2,1024,
									   wt3+1,wt4+1);
									CopyArea(skyline->Data,skyline->Width-(World->CurrZAng*16),0,skyline->Width,
												SHMMyImage->data,0,100,SHMMyImage->width,
												skyline->Width-(World->CurrZAng*8),skyline->Height-1);
								}
							} else {
								ClearScreen(SHMMyImage);
							}
							DrawWorld(basepix,dung, SHMMyImage,PerspFactor,World->CurrZAng,
									maxy,Shadows);
								DrawBangs(SHMMyImage,&Bangs[0],&Bangs[1],bangpics);

							// This bit calls the function to display PREPARE TO FIGHT !!!
							if (fightsize <=544) {
								DoFight(SHMMyImage,fight,MAX_WINDOW_WIDTH/2,100,fightsize,basepix);
								FullRedraw=1;
								World->CurrZAng+=2;
							} 
							if(game_type == DEMO_GAME) {
								//DoThought(dung,Player1);
								//DoThought(dung,Player2);
							}
							if(game_type == AI_GAME) {
								DoMotion(World,Player2Objs);
							} else {
								DoMotion(World->Next[0],Player2Objs);
							}
							//FullRedraw=1;
		
							if(FullRedraw) {
								t_mnx = 0;
								t_mxx = 1024;
								t_mny = 0; 
								t_mxy = 576; 
								dest_x = 0;
								dest_y = STATS_WINDOW_HEIGHT;
							} else {
								t_mxx = MIN(MAX(maxx, oldmaxx)+1, MAIN_WINDOW_WIDTH);
								t_mnx = MAX(0, MIN(minx, oldminx));
								t_mxy = MIN(MAX(maxy, oldmaxy)+1, MAIN_WINDOW_HEIGHT);
								//fprintf(stdout,"%d %d\n",miny,oldminy);
								t_mny = MAX(0,(MIN(miny, oldminy)));
								dest_x = t_mnx;
								dest_y = STATS_WINDOW_HEIGHT +t_mny;
							}
							XShmPutImage(display, win, gc, SHMMyImage, t_mnx, t_mny, dest_x, 
									  dest_y,(t_mxx - t_mnx),(t_mxy - t_mny)+1,True);
							//fprintf(stdout,"mny: %d\n",t_mny);
							RefreshReady=0;
							if(StatChange) {
								XPutImage(display,statswin,gc,StatsImage,0,0,0,0,
										STATS_WINDOW_WIDTH,STATS_WINDOW_HEIGHT);
								if(Health[0]==0) {
									quiting=10;  // Local Player wins
								}
								if(Health[1]==0) {
									quiting=1;  // Network/AI player wins
								}
							}
							StatChange=0;
							FullRedraw = 0;
						}
					}
					Time=time(NULL)-Time;
					Clock=clock()-Clock;
					if(Time>0) {
						fprintf(stdout,"************************************\n");
						fprintf(stdout,"* %5d f   %3d s   %3d.%04d f/s   *\n",Frames,
								Time, Frames/Time,((Frames*10000)/Time)%10000);
						fprintf(stdout,"************************************\n");
						fprintf(stdout,"* %5d us/f   %3d.%04d f/ms	   *\n",
								Clock/Frames, Frames/(Clock/1000),
								Frames*10000/(Clock/1000)%10000);
						fprintf(stdout,"************************************\n");
					}
					XDestroyImage(StatsImage);
					KillStatsWindow(display,statswin);
				}
				XShmDetach(display,&shminfo);
				XDestroyImage(SHMMyImage);
				shmdt(shminfo.shmaddr);
				shmctl(shminfo.shmid,IPC_RMID,0);
			  }
			  FreePic(backdrop);
			}
		FreePic(skyline);
		}
		FreePic(fight);
		}
		//FreePic(bang);

	}	
		if(quiting != 10 && game_type == NET_GAME) {
			/* 10 is the code for being told to quit !!! */
			/* ie, If I was told to quit, then the other player must
			 * know to quit too,
			 * no point in me telling them again is there ???
			 */
		SendQuit(WriteSocket);
		fprintf(stdout,"Sent quit\n");
		}

	if(quiting==1) {
		*end_return=LOST_FIGHT;
	} else if(quiting==10) {
		*end_return=WON_FIGHT;
	}
   return(Frames);
}

void 
CheckKeyMoves(Dungeon *dung,char key)
{
	switch(key) {
	case 38:			/*a */
		MakeMove((dung->Moves[0])[0], Player1,object_array);
		break;
	case 39:			/* s */
		MakeMove((dung->Moves[0])[1], Player1,object_array);
		break;
	case 40:			/* d */
		MakeMove((dung->Moves[0])[2], Player1,object_array);
		break;
	case 53:			/*z */
		MakeMove((dung->Moves[0])[3], Player1,object_array);
		break;
	case 54:			/*x */
		MakeMove((dung->Moves[0])[4], Player1,object_array);
		break;
	case 55:			/* c */
		MakeMove((dung->Moves[0])[5], Player1,object_array);
		break;

	case 44:			/* j */
		MakeMove((dung->Moves[0])[6], Player1,object_array);
		break;
	case 58:			/* n */
		MakeMove((dung->Moves[0])[7], Player1,object_array);
		break;
	case 45:			/* k */
		MakeMove((dung->Moves[0])[8], Player1,object_array);
		break;
	case 59:			/* m */
		MakeMove((dung->Moves[0])[9], Player1,object_array);
		break;
	case 46:			/* l */
		MakeMove((dung->Moves[0])[10], Player1,object_array);
		break;
	case 60:			/* , */
		MakeMove((dung->Moves[0])[11], Player1,object_array);
		break;
	case 61:			/* . */
		MakeMove((dung->Moves[0])[12], Player1,object_array);
		break;
	}
}

void 
React(int what)
{
    fprintf(stdout, "Reacting\n");
    //MakeMove(reactions[what - 1].SoftHit, Player2Objs,object_array);

}

void 
RandomMoves(Dungeon *dung,int Player2)
{
	int i;
	int MoveSet=0;
	if(Player2) {
		MoveSet=1;
	}
	i = rand() & 63;
	if(i>3) {
		i=0;
	} 
	switch(i) {
	case 1:
		MakeMove((dung->Moves[MoveSet])[0], Player2,object_array);
		break;
	case 2:
		MakeMove((dung->Moves[MoveSet])[1], Player2,object_array);
		break;
	case 3:
		MakeMove((dung->Moves[MoveSet])[2], Player2,object_array);
		break;
	case 4:
		MakeMove((dung->Moves[MoveSet])[3], Player2,object_array);
		break;
	case 5:
		MakeMove((dung->Moves[MoveSet])[4], Player2,object_array);
		break;

	}
}

