#ifndef GAMES_H
#define GAMES_H

#include "generic.h"
#include <X11/Xlib.h>
#include <X11/X.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <X11/extensions/XShm.h>
#include "sound.h"
#include "poly.h"

/*     GAME TYPES   */
 
#define AI_GAME 1
#define NET_GAME 2
#define DUMB_GAME 3
#define DEMO_GAME 5

#define BREAK_POINT 200

#define WON_FIGHT 1
#define LOST_FIGHT 2

#define KeyDown(x) (keybits[x>>8] & (x&0xFF))



#define KEY__Q				0x301
#define KEY__W				0x302
#define KEY__E				0x304
#define KEY__R				0x308
#define KEY__T				0x310
#define KEY__Y				0x320
#define KEY__U				0x340
#define KEY__I				0x380
#define KEY__O				0x401
#define KEY__P				0x402
#define KEY__LSB			0x404
#define KEY__RSB			0x408
#define KEY__A				0x440
#define KEY__S				0x480
#define KEY__D				0x501
#define KEY__F				0x502
#define KEY__G				0x504
#define KEY__H				0x508
#define KEY__J				0x510
#define KEY__K				0x520
#define KEY__L				0x540
#define KEY__SEMI			0x580
#define KEY__QUOTE			0x601
#define KEY__HASH			0x410
#define KEY__RETURN			0x604
#define KEY__BSLASH			0x610
#define KEY__Z				0x620
#define KEY__X				0x640
#define KEY__C				0x680
#define KEY__V				0x701
#define KEY__B				0x702
#define KEY__N				0x704
#define KEY__M				0x708
#define KEY__COMMA			0x710
#define KEY__DOT			0x720
#define KEY__SLASH			0x740
#define KEY__ARROW_DOWN		0xB08
#define KEY__ARROW_UP		0xB04

 
void PlayNetGame(Display *,Window ,GC, XImage *, int ,char *[],
				struct Sound **,Colormap,int,int);
void PlayAIGame(Display *,Window ,GC, XImage *, int ,char *[],
				struct Sound **,Colormap,int,int);
void PlayDumbGame(Display *,Window ,GC, XImage *, int ,char *[],
				struct Sound **,Colormap,int,int);
void PlayGameType(int ,Display *,Window ,GC ,XImage *, int,struct Sound **,Colormap,int,int);
int PlayGame(Display *,Window ,GC ,XImage *,int ,int ,Segment *,
             int ,int,Dungeon *,int,struct Sound **,int *,int,int);
void CheckKeyMoves(Dungeon *,char);
void React(int);
void RandomMoves(Dungeon *,int);
void SetGlobals(Dungeon *);
XImage *GetSHMImage(Display *,XShmSegmentInfo *);
int XShmGetEventBase(Display*);


#endif
