#include "intro.h"
#include "pcx.h"
#include "graph.h"
#include <unistd.h>
#include "games.h"
#include "selectp.h"
#include "mymem.h"
#include "sound.h"
#include <X11/Xlib.h>
#include <stdio.h>

/*************************************************************************
 *
 *  DoMantis()												DoMantis()	
 *
 *	Loads the Mantisoft logo, displays it while the Mantisoft jingle
 *  is playing, and then fades the picture out.
 *
 *  When Optimizations are on, something awful happens in here, well,
 *  down in WLoad_PCX(), but, changing stuff changes where the bug
 *  appears. XXXX
 *
 */

void 
DoMantis(Display *display,Window win,GC gc,XImage *Back,int BasePix,
		Colormap ColMap,struct Sound *MantisSnd)
{
	struct Picture_Type *mantis;
	uchar *pal;
	pal=MyMalloc(768,"palette");
	if(pal) {
		ClearScreen(Back);
		mantis=Load_PCX("mantis.pcx",0);
		if(mantis) {
			RemapPicture(mantis,BasePix,-1);
			CopyArea(mantis->Data,0,0,mantis->Width,
					 Back->data,433,284,Back->width,
					 mantis->Width,mantis->Height);
			FreePic(mantis);
		}
		GetPaletteFromFile("mantis.pcx",pal);
		SetPalette3(display,ColMap,pal,BasePix,192);
		XPutImage(display,win,gc,Back,0,0,0,0,1024,768);
		PlaySound(MantisSnd);
		WaitForSilence();  // Play full sound before we fade...
		FadeToBlack(display,ColMap,pal,BasePix,10);
		ClearScreen(Back);
		XPutImage(display,win,gc,Back,0,0,0,0,1024,768);
		SetPaletteFromFile(display,ColMap,BasePix,"palette.pcx");
		MyFree(pal,"palette");
	} else {
		fprintf(stdout,"No Mem\n");
	}
}

