#include <sys/types.h>
#include <unistd.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>
#include <X11/cursorfont.h>


#include <stdio.h>
#include <time.h>

#include "main.h"
#include "intro.h"
#include "poly.h"
#include "polyinit.h"
#include "pcx.h"
#include "mymem.h"
#include "sound.h"
#include "net.h"
#include "games.h"
#include "graph.h"
#include "xstuff.h"
#include "window.h"
#include "version.h"
#include "demo.h"
#include "selectp.h"
#include "misc.h"

#define PICK_PLAYER

#define Player1 0

#define progname "DUNGeon of DEATH"
#define SWEET


XImage *
AllocBigImage(Display *display)
{
	char *mydata;
	XImage *MyImage;
    mydata = MyMalloc (MAX_WINDOW_WIDTH * MAX_WINDOW_HEIGHT,
                 "image-data (XDestroyImage should free)");
    if (mydata) {
        MyImage =XCreateImage(display,
                      XDefaultVisual(display, DefaultScreen(display)),
                      8, ZPixmap, 0, mydata, MAX_WINDOW_WIDTH,
                      MAX_WINDOW_HEIGHT, 32, MAX_WINDOW_WIDTH);
        if (MyImage) {
			return(MyImage);
		} else {
			fprintf(stdout,"Can't CreateImage()\n");
		}
        MyFree (mydata, "image-data");
    } else {
		fprintf(stdout,"Can't alloc image buffer\n");
	}
	return(NULL);
}

int 
main(int argc, char *argv[])
{
    Display *display;
    int Ready = 0;
	int GotColours=0;
    unsigned int pixels[20];
    int quiting = 0;
    Window win;
    GC gc;
    XFontStruct *font_info;
    struct Picture_Type *PalettePic = NULL;
    Colormap OurColours;
    XImage *MyImage = NULL;
    int game_type;
	int backs=1,shad=1;
    char *soundnames[6] = {
		"sounds/mantis.au\0",
		"sounds/thin.au\0",
		"sounds/rosh.au\0",
		"sounds/nina.au\0",
		"sounds/thin.au\0"
		"sounds/birds.au\0"
    };
    struct Sound **Sounds;

    ShowVersion();
    SetupWindow (&display, &win, argc, argv, &gc, &font_info, pixels, 
		 &OurColours,&GotColours);
	fprintf(stdout,"Colours: %d to %d\n",pixels[0],pixels[0]+191);
	fprintf(stdout,"Colours remaining: %d\n",64-pixels[0]);

	HideCursor(display,win);

	MyImage=AllocBigImage(display);
    XMapWindow (display, win);
    XSync (display, False);
	WaitAWhile(100);
    Ready = 1;
    Sounds = SoundManager(soundnames, 5);
	while(quiting!=1) {
		quiting=DoDemo(display,win,gc,MyImage,pixels[0],OurColours,Sounds[0]);
		//DoMantis(display,win,gc,MyImage,pixels[0],OurColours,Sounds[0]);
		GoMad(display,win,gc,MyImage,pixels[0],OurColours,Sounds[1]);
		quiting=0;
    	while (!quiting) {
			if(argc==1) {	
	    		//LoadImageCentre(MyImage,pixels[0],"textures/title2.pcx",
			//			MAX_WINDOW_WIDTH,MAX_WINDOW_HEIGHT);
		
			//	quiting=DoDemo(display,win,gc,MyImage,pixels[0],OurColours);
			}  
			if(!quiting) {
				if(argc!=1) quiting=1;
	
				SetPaletteFromFile(display,OurColours,pixels[0],"textures/player1.pcx");
				game_type= SelectGameType(display,win,gc,OurColours,MyImage,pixels[0],
										  &backs,&shad);
	
				if(game_type==4) {
					quiting=2;
				} else if (game_type==5) {
					quiting=1;
				} else {
					PlayGameType(game_type,display,win,gc,MyImage,
							 	pixels[0],Sounds,OurColours,backs,shad);
				}
	    	}
		}
	}
	if (MyImage)
	    XDestroyImage(MyImage);
	
	CloseSoundManager(Sounds,5);
	if(GotColours==2) {
		pixels[0]-=48;
	}
    if(GotColours) {
		XFreeColors(display, OurColours, (long*)pixels, 12, 4);
	}
    XUnloadFont(display, font_info->fid);
    XFreeGC(display, gc);
    XUnmapWindow(display, win);
    XDestroyWindow(display, win);
    XSync(display, False);
    XCloseDisplay(display);

    if (PalettePic)
		FreePic (PalettePic);
    return (0);
}


