#include <stdlib.h>

#include <stdio.h>
#include "misc.h"
#include "net.h"

struct OurShmem *ShmBuff;


void 
ReadDaemon(int ReadSock)
{
    int rc;
	int exitit=0;
    fd_set MySet;
    
    fprintf(stdout, "ReadDaemon() active\n");
    while(!exitit) {
		FD_ZERO(&MySet);
		FD_SET(ReadSock, &MySet);
		select(ReadSock + 1, &MySet, NULL, NULL, NULL);
		if(ShmBuff->DataThere == 2) {
			fprintf(stdout, "Told to die ...\n");
			exitit=1;
		} else if((rc = read(ReadSock, ShmBuff->NetBuff, 1500)) > 0) {
			ShmBuff->DataThere = 1;
		}
    }
    fprintf(stdout, "Read Daemon exiting....\n");
}

void 
Error(int i, char *msg)
{
    char *types[] = {
	"Network"
    };
    fprintf(stdout, "%s Error\n%s\n", types[i], msg);
    exit(1);
}

void 
ReadConfig(char *filename, int *a, int *b)
{
    FILE *fp;
    fp = fopen(filename, "rt");
    if(fp) {
		fscanf(fp, "%d", a);
		*b=*a;
		fclose(fp);
    } else {
		fprintf(stdout, "Error: missing config file: %s\n", filename);
		exit(0);
    }
}

void 
GetNetConfig(int *S, int *D, char *otherhost)
{
    int a, smaller;
    char thishost[20];
    gethostname(thishost, 20);
    ReadConfig("config.1", S, D);
	smaller=strcmp(otherhost,thishost);
	if(smaller<0) {
		a=*S;
		*S=*D;
		*D=a;
	}
	fprintf(stdout,"Net config\n--------------\n");
	fprintf(stdout,"Localhost: %s\n",thishost);
	fprintf(stdout,"Remotehost: %s\n",otherhost);
	fprintf(stdout,"Sockets: %d,%d\n",*S,*D);
}

/***********************************************************
 *
 *	ReConnect()								ReConnect()
 *
 *	We still have a bound socket, so we don't need to do
 *	all of the work this time.
 *
 */

int
ReConnect(char *otherhost,int *Read,int *Write,int sockFD,int Dest,int Serv)
{
	//int Num;
    int shmid = 0;
    struct in_addr *addPtr;
    fd_set MySet;
    struct sockaddr_in dest;
    struct hostent *hostPtr;
    int clientLen;
    struct sockaddr_in clientAddr;
	int time_cnt;

	listen(sockFD, 5);

    shmid = shmget(IPC_PRIVATE, 10000, IPC_CREAT | 0600);
    if(shmid != -1) {
    	fprintf(stderr, "\nshmid = %d\n\n", shmid);
		ShmBuff = shmat(shmid, 0, 0);
		if(ShmBuff !=(void *) -1) {

			*Write=socket(AF_INET,SOCK_STREAM,0);
			if(*Write != -1) {
				if((hostPtr=gethostbyname(otherhost))!=NULL) {

					memset((char *) &dest,(int) 0, sizeof(dest));
					dest.sin_family = AF_INET;
		 
					addPtr =(struct in_addr *) *hostPtr->h_addr_list;
					dest.sin_addr =(struct in_addr) *addPtr;
					dest.sin_port = htons(Dest);
					FD_ZERO(&MySet);
					FD_SET(*Write, &MySet);
					fprintf(stderr, "Select()\n");
					select(*Write + 1, NULL, &MySet, NULL, NULL);
					fprintf(stderr, "Done...\n");
                    time_cnt=15;
					while(time_cnt) {

						if(connect(*Write,(struct sockaddr *) &dest, 
										sizeof(dest)) != -1) {
			 
							clientLen = sizeof(clientAddr);
							if((*Read = accept(sockFD,(struct sockaddr *) &clientAddr, &clientLen)) !=-1) {
			 
								fprintf(stdout, "Connected to:%s ports(%d,%d) socks(%d,%d)\n", otherhost,
										 Dest, Serv, *Read, *Write);
			 
								if(!fork()) {
									 ShmBuff = shmat(shmid, 0, 0);
									 if(ShmBuff ==(struct OurShmem *) -1) {
										  fprintf(stderr, "Bollix na hEirinn( shmat 2)\n");
									 }
									 ReadDaemon(*Read);
									 /* Child process goes here, parent doesn 't */
									 shmdt((void *) ShmBuff);
									 exit(0);
								 } else {
									 return(shmid);
								 }
								 // Un accept();
							 } else fprintf(stdout,"Recon: ERROR: accept()\n");
							 // Un connect();
						} else {
							fprintf(stdout,"Recon: ERROR: connect()\n");
                        	sleep(1);
                        	fprintf(stdout,"Slept,(%d tries left)\n",time_cnt--);
                        	close(*Write);
                        	*Write = socket(AF_INET, SOCK_STREAM, 0);
                        	if(*Write!=-1) {
                            	fprintf(stdout,"Opened New socket\n");
                        	} else {
                            	fprintf(stdout,"Failed to get a new socket\n");
                            	time_cnt=0;
                        	}
						}
					}
				} else fprintf(stdout,"Failed Rcon:gethostbyname\n");
			} else fprintf(stdout,"Failed Rcon:writesocket\n");
		} else fprintf(stdout,"Failed recon: shmat()\n");
	} else fprintf(stdout,"failed recon: shmget\n");
	return(-1);
}

int 
SetupConnection(char *otherhost,int *Read, int *Write)
{
	int time_cnt;
    int Serv, Dest, i;
	static int sockFD;
    struct in_addr *addPtr;
    struct sockaddr_in dest;
    struct hostent *hostPtr;
    int clientLen;
    struct sockaddr_in servAddr;
    struct sockaddr_in clientAddr;
    int shmid = 0;
    fd_set MySet;
    
    shmid = shmget(IPC_PRIVATE, 10000, IPC_CREAT | 0600);
    if(shmid != -1) {
    	fprintf(stderr, "\nshmid = %d\n\n", shmid);
		ShmBuff = shmat(shmid, 0, 0);
		if(ShmBuff !=(void *) -1) {
			GetNetConfig(&Serv, &Dest, otherhost);
	
			/* Set up this server */
	
			if((sockFD = socket(AF_INET, SOCK_STREAM, 0)) != -1) {
	
				memset((char *) &servAddr,(int) 0, sizeof(servAddr));
				servAddr.sin_family = AF_INET;
				servAddr.sin_addr.s_addr = htonl(INADDR_ANY);
				servAddr.sin_port = htons(Serv);
						
				/* We should unlink() here, incase some bastard left it linked ??? 
			   	and later on, so we're not bastards !! */
						
				if(bind(sockFD,(struct sockaddr *) &servAddr, sizeof(servAddr)) != -1) {
					listen(sockFD, 5);
	
					/* Connect to other server..... */
	
					*Write = socket(AF_INET, SOCK_STREAM, 0);
					if(*Write != -1) {
	
						memset((char *) &dest,(int) 0, sizeof(dest));
						dest.sin_family = AF_INET;
						if((hostPtr = gethostbyname(otherhost)) != NULL) {
	
							addPtr =(struct in_addr *) *hostPtr->h_addr_list;
							dest.sin_addr =(struct in_addr) *addPtr;
							dest.sin_port = htons(Dest);
							FD_ZERO(&MySet);
							FD_SET(*Write, &MySet);
							fprintf(stderr, "Select()\n");
							select(*Write + 1, NULL, &MySet, NULL, NULL);
							fprintf(stderr, "Done...\n");

							time_cnt=15;
							while(time_cnt) {
									if(connect(*Write,(struct sockaddr *) &dest, sizeof(dest)) != -1) {

										/* and make the actual connection ..(In response to the connect call
										above ??? */
			
										clientLen = sizeof(clientAddr);
										if((*Read = accept(sockFD,(struct sockaddr *) &clientAddr, &clientLen)) !=-1) {
			
											fprintf(stdout, "Connected to:%s ports(%d,%d) socks(%d,%d)\n", otherhost,
													Dest, Serv, *Read, *Write);
			
											if(!fork()) {
												ShmBuff = shmat(shmid, 0, 0);
												if(ShmBuff ==(struct OurShmem *) -1) {
													fprintf(stderr, "Bollix na hEirinn( shmat 2)\n");
												}
												ReadDaemon(*Read);
												/* Child process goes here, parent doesn't */
												shmdt((void *) ShmBuff);
												exit(0);
											} else {
												return(shmid);
											}
											// Un accept();
										} else fprintf(stdout,"net.c: ERROR: accept()\n");
										// Un connect();
									} else {
										fprintf(stdout,"Connect failed\n");
										sleep(1);
										fprintf(stdout,"Slept,(%d tries left)\n",time_cnt--);
										close(*Write);
										*Write = socket(AF_INET, SOCK_STREAM, 0);
										if(*Write!=-1) {
											fprintf(stdout,"Opened New socket\n");
										} else {
											fprintf(stdout,"Failed to get a new socket\n");
											time_cnt=0;
										}
									}

							} 
							fprintf(stdout,"net.c: ERROR: connect()\n");
							free(hostPtr);
						} else fprintf(stdout,"net.c: ERROR: gethostbyname()\n");
						close(*Write);
					} else fprintf(stdout,"net.c: ERROR: write=socket()\n");
					
				} else fprintf(stdout,"net.c: ERROR: bind()\n");
				close(sockFD);
			} else fprintf(stdout,"net.c: ERROR: sockFD=socket()\n");
			i = shmdt((void *) ShmBuff);
			fprintf(stdout, "shmdt(): %d\n", i);
		} else fprintf(stdout,"net.c: ERROR: shmat()\n");
		i = shmctl(shmid, IPC_RMID, 0);
		fprintf(stdout, "IPC_RMID: %d\n", i);
    } else fprintf(stdout,"net.c: ERROR: shmget()\n");
    return(-1);
}

int 
GetEnemyPlayer(void)
{
    int i;
    struct timeval tv = { 0, 50 };
    while(ShmBuff->DataThere == 0) {
		select(0, NULL, NULL, NULL, &tv);
    }
    i = ShmBuff->NetBuff[1];
    ShmBuff->DataThere = 0;
    return(i);
}

void 
WriteMyPlayer(int WriteSock, int Playernum)
{
    int i;
    short int buff[500];
    struct timeval tv = { 0, 100 };
    fd_set MySet;
    
    buff[0] = -2;
    buff[1] = Playernum;
	buff[2] = 60; // This is health
    
    FD_ZERO(&MySet);
    FD_SET(WriteSock, &MySet);
    if(select(WriteSock + 1, NULL, &MySet, NULL, &tv)) {
		i = write(WriteSock, &buff[0], 4);
    }
    else
		fprintf(stdout, "Failed to write() playernum info\n");
}

int 
ReadNetworkPlayer2(Dungeon *dung,int First, Segment *objs[],int *Health)
{
    int i, j = 0;
    if(ShmBuff->NetBuff[0] == -1) {
		ShmBuff->DataThere = 2;
		return(1);
    } else {
		(dung->Points[2])[17]=ShmBuff->NetBuff[1];
		if(ShmBuff->NetBuff[2]) {
			*Health=ShmBuff->NetBuff[2];
		} else {
			*Health=40;
		}
	    objs[1]->CurrXAng = ShmBuff->MoreNetBuff[j++];
	    objs[1]->CurrYAng = ShmBuff->MoreNetBuff[j++];
	    objs[1]->CurrZAng = ShmBuff->MoreNetBuff[j++];
		for(i = 0; i < ShmBuff->NetBuff[0]; i++) {
	    	objs[First + i]->CurrXAng = ShmBuff->MoreNetBuff[j++];
	    	objs[First + i]->CurrYAng = ShmBuff->MoreNetBuff[j++];
	    	objs[First + i]->CurrZAng = ShmBuff->MoreNetBuff[j++];
		}
		if(ShmBuff->DataThere != 2) {
	   	 	ShmBuff->DataThere = 0;
		}
    }
    return(0);
}

void 
WriteMyData2(Dungeon *dung,int WriteSock, int OtherP,
		   Segment *objs[],int Health)
{
    int i, Number = OtherP-2;
    int j = 0;
    char buff[1504];
    short int *NetBuff;
    uchar *MoreNetBuff;
    struct timeval tv;
    fd_set MySet;
    
    NetBuff =(short int *) &buff[0];
    MoreNetBuff = &buff[6];
    tv.tv_sec = 0;
    tv.tv_usec = 0;
    NetBuff[0] = Number;
	NetBuff[1] = (dung->Points[2])[11];
	NetBuff[2] = Health;
	MoreNetBuff[j++] = objs[0]->CurrXAng;
	MoreNetBuff[j++] = objs[0]->CurrYAng;
	MoreNetBuff[j++] = objs[0]->CurrZAng;
    for(i = 0; i < Number; i++) {
		MoreNetBuff[j++] = objs[i+2]->CurrXAng;
		MoreNetBuff[j++] = objs[i+2]->CurrYAng;
		MoreNetBuff[j++] = objs[i+2]->CurrZAng;
    }
    FD_ZERO(&MySet);
    FD_SET(WriteSock, &MySet);
    if(select(WriteSock + 1, NULL, &MySet, NULL, &tv)) {
	/*      fprintf(stdout,"Writting object data\n"); */
		i = write(WriteSock, &buff[0], j + 4);
    }
}

void 
CloseConnection(int s1, int s2, int shmid)
{
    int i;
    close(s1);
    close(s2);
    i = shmdt((void *) ShmBuff);
    //fprintf(stdout, "dt: %d\n", i);
    i = shmctl(shmid, IPC_RMID, 0);
    //fprintf(stdout, "rm: %d\n", i);
	close(s1);
	close(s2);
	Bump();
}

void 
SendQuit(int WriteSock)
{
    fd_set MySet;
    short int buff = -1;
	int i;
    FD_ZERO(&MySet);
    FD_SET(WriteSock, &MySet);
    if(select(WriteSock + 1, NULL, &MySet, NULL, NULL)) {
		write(WriteSock, &buff, 2);
    }
    /* That'll stop THEIR daemon */
	for(i=0;i<5;i++) {
    	ShmBuff->DataThere = 2;
    	WaitAWhile(100);
	}
    /* That'll(well it should) stop our dameon */
}
