#include "outtext.h"
#include "pcx.h"
#include "graph.h"
#include "mymem.h"


AFont *
LoadFont(char *fname,int BasePix)
{
	AFont *tmpFont;
	char *now;
	int i,curr,width;
	tmpFont=MyMalloc(sizeof(AFont),"font type");
	if(tmpFont) {
		tmpFont->Data=Load_PCX(fname,0);
		if(tmpFont->Data) {
			RemapPicture(tmpFont->Data,BasePix,-1);
			tmpFont->Height=60;
			tmpFont->Col1=BasePix+5;
			tmpFont->Col2=BasePix+191;
			now=(tmpFont->Data->Data)+1;
			curr=0;
			width=1;
			tmpFont->Left[curr]=0;
			for(i=0;i<tmpFont->Data->Width;i++) {
				if((*(now++)-BasePix)!=0) {
					//fprintf(stdout,"Found marker. (%d)  ",*(now-1)-BasePix);
					tmpFont->Width[curr]=width;
					tmpFont->Left[curr+1]=tmpFont->Left[curr]+tmpFont->Width[curr];
					width=1;
					curr++;
				} else {
					width++;
				}
			}	
			return(tmpFont);
		}
		MyFree(tmpFont,"font-type");
	}
	return(NULL);
}

void
FreeFont(AFont *font)
{
	FreePic(font->Data);
	MyFree(font,"font-type");
}

char
LookUp(uchar Letter)
{
	static char Table[128]= { 
		 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		40, 0, 0, 0, 0,38, 0, 0, 0, 0, 0, 0, 0,36, 0, 0,
		26,35,34,33,32,31,30,29,28,27, 0, 0, 0, 0,39, 0,
		 0, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,
		15,16,17,18,19,20,21,22,23,24,25, 0, 0, 0, 0,37,
		 0, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,
		15,16,17,18,19,20,21,22,23,24,25, 0, 0, 0, 0, 0
	};
	return(Table[Letter]);
}

 
void
CopyAreaFont(uchar *src,int srcx,int srcy,int srcw,
         uchar *dest,int destx,int desty,int destw,
         int width,int height,int Col1,int Col2)
{
    int i,j;
	uchar tmp;
    //fprintf(stdout,"dest: %d\n",(int)dest);
    src+=(srcx+(srcy*srcw));
    dest+=(destx+(desty*destw));
    //fprintf(stdout,"Copy %d*%d\n",width,height);
    for(i=0;i<height;i++) {
        //fprintf(stdout,"Line: %d\n",i);
        for(j=0;j<width;j++) {
            //fprintf(stdout,"Col %d\n",j);
            //fprintf(stdout,"src: %08X, DST: %08X\n",src,dest);
			tmp=*(src++);
			//fprintf(stdout,"%d\n",tmp);
			if(tmp==Col1 || tmp==Col2) {
				*dest=tmp;
			}
            dest++;
        }
        dest+=(destw-width);
        src+=(srcw-width);
    }
}
 
void
DrawLetter(XImage *page,AFont *font,uchar Letter,int *CursX,int CursY)
{
	int TopX,TopY;
	Letter=LookUp(Letter);
	//fprintf(stdout,"Lookup is %d\n",Letter);
	// Lets get X,Y co-ords..
	TopX=font->Left[Letter];
	TopY=0;
	//fprintf(stdout,"(%d,%d),(%d,%d)\n",TopX,TopY,font->Width[Letter],font->Height);
	CopyAreaFont(font->Data->Data,TopX,TopY,font->Data->Width,
			 page->data,*CursX,CursY,page->width,
			 font->Width[Letter],font->Height,font->Col1,font->Col2);
	(*CursX)+=font->Width[Letter];
}

void
DrawText(XImage *page,AFont *font,char *text,int CursX,int CursY)
{
	int i=0;
	while(text[i]) {
		//fprintf(stdout,"Letter: %c %d\n",text[i],text[i]);
		DrawLetter(page,font,text[i],&CursX,CursY);
		i++;
	}
}
