#include "poly.h"
#include "text.h"
#include <math.h>
#include "id.h"
#ifdef SWEET
#include "games.h"
#endif

#include "window.h"

#define PERSPECTIVE 

/* sinvalues & cosvalues are only uesd in initmat !! */
const char sinvalues[128] = {
    0, 3, 6, 9, 12, 16, 19, 22,
    24, 27, 30, 33, 36, 38, 41, 43,
    45, 47, 49, 51, 53, 55, 56, 58,
    59, 60, 61, 62, 63, 63, 64, 64,
    64, 64, 64, 63, 63, 62, 61, 60,
    59, 58, 56, 55, 53, 51, 49, 47,
    45, 43, 41, 38, 36, 33, 30, 27,
    24, 22, 19, 16, 12, 9, 6, 3,
    -0, -3, -6, -9, -12, -16, -19, -22,
    -24, -27, -30, -33, -36, -38, -41, -43,
    -45, -47, -49, -51, -53, -55, -56, -58,
    -59, -60, -61, -62, -63, -63, -64, -64,
    -64, -64, -64, -63, -63, -62, -61, -60,
    -59, -58, -56, -55, -53, -51, -49, -47,
    -45, -43, -41, -38, -36, -33, -30, -27,
    -24, -22, -19, -16, -12, -9, -6, -3
};

const char cosvalues[128] = {
    64, 64, 64, 63, 63, 62, 61, 60,
    59, 58, 56, 55, 53, 51, 49, 47,
    45, 43, 41, 38, 36, 33, 30, 27,
    24, 22, 19, 16, 12, 9, 6, 3,
    -0, -3, -6, -9, -12, -16, -19, -22,
    -24, -27, -30, -33, -36, -38, -41, -43,
    -45, -47, -49, -51, -53, -55, -56, -58,
    -59, -60, -61, -62, -63, -63, -64, -64,
    -64, -64, -64, -63, -63, -62, -61, -60,
    -59, -58, -56, -55, -53, -51, -49, -47,
    -45, -43, -41, -38, -36, -33, -30, -27,
    -24, -22, -19, -16, -12, -9, -6, -3,
    0, 3, 6, 9, 12, 16, 19, 22,
    24, 27, 30, 33, 36, 38, 41, 43,
    45, 47, 49, 51, 53, 55, 56, 58,
    59, 60, 61, 62, 63, 63, 64, 64
};

extern short *PointsX, *PointsY, *PointsZ;
extern short *newptsX, *newptsY, *newptsZ;


#ifndef SWEET
//extern short *twoDX, *twoDY, *twoDZ;
#endif


/************************************************************
 *
 *	GetObj()									GetObj()
 *
 *  return a pointer to a Segment, given an "ID".  Returns
 *	NULL if the object is not found. 
 *
 */

Segment *
GetObj(int Num, Segment **objs)
{
    int i=0;
    while(objs[i]) { 
		if(Num == i)
	    	return(objs[i]);
		i++;
    }
    return(NULL);
}

void
TestMove(struct Bigmove *Moves, int ObjOffset,Segment **objs)
{
	if(Moves){
		MakeMove(Moves,ObjOffset-2,objs);
	}
}

int 
MakeMove(struct Bigmove *Moves, int ObjOffset,Segment **objs)
{
    Segment *TheObj;
	if(!Moves) {
		//fprintf(stdout,"Passed a bad pointer for a move\n");
		return(0);
	}
    TheObj = GetObj((Moves->ObjectID) + ObjOffset+2, objs);
    if(!(TheObj->Moves)) {
      	if(!(Moves->Next)) {
	  		/* This is last move to set, set it and return 1 */
	  		TheObj->Moves = Moves->Move;
	  		TheObj->Waiter = Moves->Move->Waiter;
			TheObj->MotionX = Moves->Move->MotionX;
			TheObj->MotionY = Moves->Move->MotionY ;
			TheObj->MotionZ = Moves->Move->MotionZ ;
			return(1);
      	}
      	if(MakeMove(Moves->Next, ObjOffset,objs)) {
	  		/* Child(and it's child....) have set their moves,
	     	set mine, and return 1 */
	  		TheObj->Moves = Moves->Move;
	  		TheObj->Waiter = Moves->Move->Waiter;
	  		TheObj->MotionX = Moves->Move->MotionX ;
	  		TheObj->MotionY = Moves->Move->MotionY ;
	  		TheObj->MotionZ = Moves->Move->MotionZ ;
	  		return(1);
      	} else {
	  		return(0);
      		/* All child moves are posible !! */
		}
   	} else {
		//fprintf(stdout,"Non NULL ptr\n");
	}
    //fprintf(stdout, "Obj %d moving\n", TheObj->ID);
    return(0);			/* Already moving */
}

// This isn't used(23/April), but it will be when reactions go
// all the way in.
void 
ClearMove(Segment **objs, int killid)
{
    Segment *Theobj;
    Theobj = GetObj(killid, objs);
    if(Theobj) {
	if(Theobj->Moves) {
	    Theobj->Moves = &(Theobj->ReturnMove);
	    Theobj->ReturnMove.DestXAng = 0;
	    Theobj->ReturnMove.DestYAng = 0;
	    Theobj->ReturnMove.DestZAng = 0;
	    if(Theobj->CurrXAng < 64) {
		Theobj->ReturnMove.DeltXAng = -1;
	    } else {
		Theobj->ReturnMove.DeltXAng = 1;
	    }
	    if(Theobj->CurrYAng < 64) {
		Theobj->ReturnMove.DeltYAng = -1;
	    } else {
		Theobj->ReturnMove.DeltYAng = 1;
	    }
	    if(Theobj->CurrZAng < 64) {
		Theobj->ReturnMove.DeltZAng = -1;
	    } else {
		Theobj->ReturnMove.DeltZAng = 1;
	    }
	 //   fprintf(stdout, "%s: ", Theobj->Name);
	 //   fprintf(stdout, "%d,%d,%d\n", Theobj->CurrXAng,
		     // Theobj->CurrYAng, Theobj->CurrZAng);
	}
    }
}


/* There is a potential bug here, if the < should be a <= or something */
#define GetBasePt(ObjID,Ply2) ObjID<=Ply2 ? 11 : 17

static void 
MoveObject(Segment *obj,int Ply2O)
{
    int i,basept;
    if(obj->Moves) {
      	if(obj->Waiter) {
	  		(obj->Waiter)--;
      	} else {
			basept=GetBasePt(obj->ID,Ply2O);
	 		PointsX[basept]+=obj->MotionX; 
	 		PointsY[basept]+=obj->MotionY; 
	 		PointsZ[basept]+=obj->MotionZ; 
	  		if(obj->CurrXAng != obj->Moves->DestXAng)
	      		obj->CurrXAng =(obj->CurrXAng + obj->Moves->DeltXAng) & 0x7F;
	  		if(obj->CurrYAng != obj->Moves->DestYAng)
	      		obj->CurrYAng =(obj->CurrYAng + obj->Moves->DeltYAng) & 0x7F;
	  		if(obj->CurrZAng != obj->Moves->DestZAng)
	      		obj->CurrZAng =(obj->CurrZAng + obj->Moves->DeltZAng) & 0x7F;
      	}
      	if((obj->Moves->DestXAng == obj->CurrXAng) &&
	  	 (obj->Moves->DestYAng == obj->CurrYAng) &&
	  	 (obj->Moves->DestZAng == obj->CurrZAng) &&
	 	 (obj->Waiter == 0)) {
	  		obj->Moves = obj->Moves->Moves;
	  			if(obj->Moves) {
	      			obj->Waiter = obj->Moves->Waiter;
		  			obj->MotionX=obj->Moves->MotionX;
		  			obj->MotionY=obj->Moves->MotionY;
		  			obj->MotionZ=obj->Moves->MotionZ;
	  			}
      	}
    }
    for(i = 0; i < 5; i++) {
		if(obj->Next[i]) {
	    	MoveObject(obj->Next[i],Ply2O);
		}
    }
}

void 
DoMotion(Segment *base,int Player2Obj)
{
    MoveObject(base,Player2Obj);
}

void 
DrawFloor(Dungeon *d,XImage *vscreen,struct Picture_Type *mat)
{
	static int k=1;
	Polygon poly;
	poly.Points[0]=6;
	poly.Points[1]=7;
	poly.Points[2]=8;
	poly.Points[3]=9;
	//k=(k+1)& 0xFF;
	ColourDrawRectangle(poly.Points,vscreen->data,d->newpts[0],d->newpts[1],k);
}

/*************************************************************
 *
 *	GetHeights()								GetHeights()
 *
 *	Figure out where each player should be positioned.  It
 *  uses two points(one in each foot), the lower of which
 *  should be at ground level 
 *
 */

void 
GetHeights(Dungeon *dung,int *p1,int *p2)
{
	int a,b=20,c,d=20;
	a=(dung->newpts[2])[dung->feet[0][0]]+220;
	b=(dung->newpts[2])[dung->feet[0][1]]+220;
	c=(dung->newpts[2])[dung->feet[1][0]]+220;
	d=(dung->newpts[2])[dung->feet[1][1]]+220;
	*p1=MIN(a,b);
	*p2=MIN(c,d);
}

/**************************************************************
 *
 *	MakeFloor()									MakeFloor()
 *
 *	Sets up the points used to draw a small floor area under the
 *	characters on the player-slect screen.
 *
 */

void 
MakeFloor(Dungeon *d)
{
	int i;
	(d->Points[0])[6]=-150;
	(d->Points[0])[7]=150;
	(d->Points[0])[8]=150;
	(d->Points[0])[9]=-150;

	(d->Points[1])[6]=-250;
	(d->Points[1])[7]=-250;
	(d->Points[1])[8]=250;
	(d->Points[1])[9]=250;

	(d->Points[2])[6]=-220;
	(d->Points[2])[7]=-220;
	(d->Points[2])[8]=-220;
	(d->Points[2])[9]=-220;
	for(i=6;i<10;i++) {
		newptsX[i]=PointsX[i];
		newptsY[i]=PointsY[i];
		newptsZ[i]=PointsZ[i];
	}
}

void 
MoveToScreenSWEET(Dungeon *dung,int xt, int yt, int zt, int First,int NumP,
			int *minx, int *miny, int *maxx, int *maxy,int fac)
{
    int i;
	//zt=1000;
    for(i = First; i < NumP; i++) {
#ifdef PERSPECTIVE
		if ((fac-newptsZ[i]-zt)!=0){
			newptsX[i] =((newptsX[i] * fac) /(fac- zt-newptsZ[i])) + xt;
			newptsY[i] =((newptsY[i] * fac) /(fac - zt-newptsZ[i])) + yt;
			// Shadows must be done too !
			// Fran: Divide by Zero here ....
			(dung->newshadowpts[0])[i] =(((dung->newshadowpts[0])[i] * fac) /
									(fac - zt-(dung->newshadowpts[2])[i])) + xt;
			(dung->newshadowpts[1])[i] =(((dung->newshadowpts[1])[i] * fac) /
									(fac - zt-(dung->newshadowpts[2])[i])) + yt;
		} 
		else {
			newptsX[i] =((newptsX[i] * fac) /(fac+1 - zt-newptsZ[i])) + xt;
			newptsY[i] =((newptsY[i] * fac) /(fac+1 - zt-newptsZ[i])) + yt;
			
			(dung->newshadowpts[0])[i] =(((dung->newshadowpts[0])[i] * fac) /
									(fac - zt-(dung->newshadowpts[2])[i])) + xt;
			(dung->newshadowpts[1])[i] =(((dung->newshadowpts[1])[i] * fac) /
									(fac - zt-(dung->newshadowpts[2])[i])) + yt;
		}
#else
		newptsX[i] += xt;
		newptsY[i] += yt;
		
		(dung->newshadowpts[0])[i] += xt;
		(dung->newshadowpts[1])[i] += yt;
		
#endif
		if((dung->newshadowpts[0])[i] < *minx) {
            *minx = (dung->newshadowpts[0])[i];
        }
        if(dung->newshadowpts[0][i] > *maxx) {
            *maxx = (dung->newshadowpts[0])[i];
        }
        if(dung->newshadowpts[1][i] < *miny) {
            *miny = (dung->newshadowpts[1])[i];
        }
        if(dung->newshadowpts[1][i] > *maxy) {
            *maxy = (dung->newshadowpts[1])[i];
        }
		if(newptsX[i] < *minx) {
			*minx = newptsX[i];
		}
		if(newptsX[i] > *maxx) {
			*maxx = newptsX[i];
		}
		if(newptsY[i] < *miny) {
			*miny = newptsY[i];
		}
		if(newptsY[i] > *maxy) {
		    *maxy = newptsY[i];
		}
    }
}

static void 
UpdateObject2(Segment *obj, int mat[3][3])
{
    int i;
    long tmpX, tmpY;
    for(i = obj->Poffset; i < obj->Poffset + obj->Numpoints; i++) {
		tmpX =((newptsX[i] * mat[0][0]) +(newptsY[i] * mat[1][0]) +
				(newptsZ[i] * mat[2][0])) >> 6;
		tmpY =((newptsX[i] * mat[0][1]) +(newptsY[i] * mat[1][1]) +
				(newptsZ[i] * mat[2][1])) >> 6;
		newptsZ[i] =((newptsX[i] * mat[0][2]) +(newptsY[i] * mat[1][2]) +
				(newptsZ[i] * mat[2][2])) >> 6;

		newptsX[i] = tmpX;
		newptsY[i] = tmpY;
    }

    for(i = 0; i < 5; i++) {
		if(obj->Next[i]) {
	    	UpdateObject2(obj->Next[i], mat);
		}
    }
}

static void 
UpdateObject(Dungeon *dung,Segment *obj, int what, int WorldFlag)
{
    int i;
	static int realism=0;
    uchar xa, ya, za;
    int mat[3][3];
#ifndef SWEET
    int px, py, pz;
#else
    what = what;
#endif
    if(!WorldFlag) {
		for(i = 0; i < 5; i++) {
			if(obj->Next[i]) {
				UpdateObject(dung,obj->Next[i], i, 0);
			}
		}
    }
    xa =((realism>>3)+ obj->CurrXAng) & 0x7F;
    ya =(obj->CurrYAng) & 0x7F;
    za =(obj->CurrZAng) & 0x7F;
#ifdef SWEET
    //realism =(realism+1) & 0xF;
#endif
    Init_Mat(xa, ya, za, mat);
#ifndef SWEET
    if(obj->Prev) {
		px = dung->twoDX[obj->Prev->Poffset + what + 1];
		py = dung->twoDY[obj->Prev->Poffset + what + 1];
		pz = dung->twoDZ[obj->Prev->Poffset + what + 1];
    } else {
		px = py = pz = 0;
    }
#endif
    /* Rotate this objects points including the cog and the hotpoints  */
    for(i = obj->Poffset; i < obj->Poffset + obj->Numpoints; i++) {
		newptsX[i] =((PointsX[i] * mat[0][0]) +(PointsY[i] * mat[1][0]) +
				(PointsZ[i] * mat[2][0])) >> 6;
		newptsY[i] =((PointsX[i] * mat[0][1]) +(PointsY[i] * mat[1][1]) +
				(PointsZ[i] * mat[2][1])) >> 6;
		newptsZ[i] =((PointsX[i] * mat[0][2]) +(PointsY[i] * mat[1][2]) +
				(PointsZ[i] * mat[2][2])) >> 6;
#ifndef SWEET
		/* This is for the editor */
		dung->twoDX[i] = PointsX[i] + px;
		dung->twoDY[i] = PointsY[i] + py;
		dung->twoDZ[i] = PointsZ[i] + pz;
#endif
	}
    /* Rotate all this objects connecting objects */
    for(i = 0; i < 5; i++) {
		if(obj->Next[i]) {
	    	UpdateObject2(obj->Next[i], mat);
		}
    }
}

static void 
UpdateObjectsHotPts(Segment *obj, int Xt, int Yt, int Zt)
{
    int i;

    for(i = obj->Poffset; i < obj->Poffset + obj->Numpoints; i++) {
		newptsX[i] += Xt;
		newptsY[i] += Yt;
		newptsZ[i] += Zt;
    }
	for(i = 0; i < 5; i++) {
		if(obj->Next[i]) {
			UpdateObjectsHotPts(obj->Next[i], newptsX[obj->Poffset + 1 + i],
								 newptsY[obj->Poffset + 1 + i],
								 newptsZ[obj->Poffset + 1 + i]);
		}
	}
}

void InitShadows(Dungeon *dung)
{
	int i;
	for (i=0;i<dung->NumPoints;i++) {
		dung->newshadowpts[0][i]=dung->newpts[0][i]+(((150-dung->newpts[1][i]))/6);
		dung->newshadowpts[1][i]=150;
		dung->newshadowpts[2][i]=dung->newpts[2][i]+(((150-dung->newpts[1][i]))/6);
	}

}

void 
RotateWorld(Segment *obj,int NumPoints,Dungeon *dung)
{
	int mat[3][3];
    Init_Mat(obj->CurrXAng, obj->CurrYAng, obj->CurrZAng, mat);
	UpdateObject2(obj,mat);
	InitShadows(dung);
}

void 
UpdateObjects(Dungeon *dung,Segment *obj)
{
	#ifdef SPEED_TEST__2
	int i,j;
	j=clock();
	for(i=0;i<10000;i++) {
	#endif
    UpdateObject(dung,obj, 0, 0);
    UpdateObjectsHotPts(obj, 0, 0, 0);
	#ifdef SPEED_TEST__2
	}
	j=clock()-j;
	fprintf(stdout,"UpdateObjects() = %d\n",j/10000);
	#endif
}

void 
UpdateNextObject(Segment *obj, int mat[3][3])
{
    int i, tmpX, tmpY, tmpZ;

    for(i = obj->Poffset; i < obj->Poffset + obj->Numpoints; i++) {

		tmpX =((PointsX[i] * mat[0][0]) +(PointsY[i] * mat[1][0]) +
				(PointsZ[i] * mat[2][0])) >> 6;
		tmpY =((PointsX[i] * mat[0][1]) +(PointsY[i] * mat[1][1]) +
				(PointsZ[i] * mat[2][1])) >> 6;
		tmpZ =((PointsX[i] * mat[0][2]) +(PointsY[i] * mat[1][2]) +
				(PointsZ[i] * mat[2][2])) >> 6;
			
		PointsX[i] = tmpX;
		PointsY[i] = tmpY;
		PointsZ[i] = tmpZ;
    }
    for(i = 0; i < 5; i++) {
		if(obj->Next[i]) {
			UpdateNextObject(obj->Next[i], mat);
		}
    }
}

void 
UpdateSaveObjects(Segment *obj)
{
    int xa, ya, za;
    int mat[3][3];
    int tmpX, tmpY, tmpZ, i;
    
    for(i = 0; i < 5; i++) {
		if(obj->Next[i]) {
			UpdateSaveObjects(obj->Next[i]);
		}
    }
    xa = obj->CurrXAng;
    ya = obj->CurrYAng;
    za = obj->CurrZAng;
    Init_Mat(xa, ya, za, mat);
    for(i = obj->Poffset; i < obj->Poffset + obj->Numpoints; i++) {

		tmpX =((PointsX[i] * mat[0][0]) +(PointsY[i] * mat[1][0]) +
				(PointsZ[i] * mat[2][0])) >> 6;
		tmpY =((PointsX[i] * mat[0][1]) +(PointsY[i] * mat[1][1]) +
				(PointsZ[i] * mat[2][1])) >> 6;
		tmpZ =((PointsX[i] * mat[0][2]) +(PointsY[i] * mat[1][2]) +
				(PointsZ[i] * mat[2][2])) >> 6;
			
		PointsX[i] = tmpX;
		PointsY[i] = tmpY;
		PointsZ[i] = tmpZ;
    }
    for(i = 0; i < 5; i++) {
		if(obj->Next[i]) {
			UpdateNextObject(obj->Next[i], mat);
		}
    }
}

/***************************************************************
 * GetNormalCoord()
 * returns whatever coord you want of the normal to tmpPoly
 * Give it X and Y to get Z coord
 * Give it z and X to get -Y coord 
 * Give it Y and Z to get X coord
 * N.B. Must be passed in the correct order stated above
*/

int 
GetNormalCoord(short int *NewPtsA,short int *NewPtsB,Polygon *tmpPoly)
{
 return ((NewPtsA[tmpPoly->Points[0]]- NewPtsA[tmpPoly->Points[1]]) *
            (NewPtsB[tmpPoly->Points[0]]- NewPtsB[tmpPoly->Points[2]])) -
            ((NewPtsB[tmpPoly->Points[0]] -NewPtsB[tmpPoly->Points[1]]) *
            (NewPtsA[tmpPoly->Points[0]] - NewPtsA[tmpPoly->Points[2]]));
}

int 
GetDist (Polygon *tmpPoly,short int *NewPtsX,short int *NewPtsY, short int *NewPtsZ)
{
  int x=1024,y=1024,z=1024;
	
	return ( (((NewPtsX[tmpPoly->CentrePt] - x) *
                 (NewPtsX[tmpPoly->CentrePt] - x)) +
             ((NewPtsY[tmpPoly->CentrePt] - y) *
                 (NewPtsY[tmpPoly->CentrePt] - y))+
             ((NewPtsZ[tmpPoly->CentrePt] - z) *
                 (NewPtsZ[tmpPoly->CentrePt] - z))));
}

/* PICK A NUMBER until ColOffset < GROUP_SIZE */

int
GetOffset(int dist)
{
    if (dist<1340000) {
    return(0);
    }
    if (dist<1470000) {
    return(1);
    }
    if (dist<1600000) {
    return(2);
    }
    if (dist<1730000) {
    return(3);
    }
    if (dist<1860000) {
    return(4);
    }
    if (dist<1990000) {
    return(5);
    }
    if (dist<2120000) {
    return(6);
    }
    return(7);
}

/****************************************************************
 *
 *	DrawPolygons()								DrawPolygons()
 *
 *	Draws the whole world.  Each polygon is one of 
 *    Coloured.
 *	  Texture-Mapped.
 *	  LightSource Coloured.
 *  If the polygon is facing the observer(normalZ >0), it is drawn.
 *
 */

static void 
DrawShadows(int basepix,Dungeon *dung, XImage * vscreen,int persp,
			int zang, int maxy )
{
    int j=0;
    Polygon *tmpPoly;

    while((tmpPoly=dung->PolygonArray[j++])) {
		int array[5]={ 0,1,2,3,4 };
		int i;
		short int NPtsX[5],NPtsY[5];
		for(i=0;i<5;i++) {
			NPtsX[i]=dung->newshadowpts[0][tmpPoly->Points[i]];
			NPtsY[i]=dung->newshadowpts[1][tmpPoly->Points[i]];

				//	360+NewPtsY[tmpPoly->Points[i]]/10;// +360+NewPtsZ[tmpPoly->Points[i]]/2;
		}
		ColourDrawRectangle(array,(uchar *)(vscreen->data), 
						NPtsX, NPtsY, basepix); 
    }
}

static void 
DrawPolygons(int basepix,Dungeon *dung, XImage * vscreen )
{
    int j=0;
    int normalZ; 
    int dist = 0;               
    Polygon *tmpPoly;
    short *NewPtsX=dung->newpts[0];
    short *NewPtsY=dung->newpts[1];
    short *NewPtsZ=dung->newpts[2];
    
    while((tmpPoly=dung->PolygonArray[j++])) {
		/* Get the Z of the Normal */	
		if((normalZ=GetNormalCoord(NewPtsX,NewPtsY,tmpPoly))>0) {  
			switch(tmpPoly->Style) {
				case 0: // Colour
					ColourDrawRectangle(tmpPoly->Points,(uchar *)(vscreen->data), 
									NewPtsX, NewPtsY, tmpPoly->Color+basepix);
					break;
				case 1:
		    		NewDrawRectangle(tmpPoly->Points,(uchar *)(vscreen->data), 
				      		dung->Textures[tmpPoly->Texture],NewPtsX,NewPtsY);
					break;
				case 2: // LightSource.
					dist= GetDist(tmpPoly,NewPtsX,NewPtsY,NewPtsZ);
					tmpPoly->ColOffset = GetOffset(dist);
					ColourDrawRectangle(tmpPoly->Points,(uchar *)(vscreen->data), 
								NewPtsX, NewPtsY, tmpPoly->Color+basepix+tmpPoly->ColOffset); 
					break;
			}
		}
    }
}

/**************************************************************
 * SortPolys() 
 *  - Algorithm used is crap, quicksort would be quicker... 
 *  - A quick test proves that this took 23 microsecond for some
 * 	  number of polygons(DrawPolygons() took ~16800(700 times)
 *    so optimizing this wont speed it up much.
 *
 * + On the contrary, it takes 4200 microseconds to do now(more than clearscreen)
 *  (10% of our time is spent here).
 */

void 
SortPolygons(Polygon **s_plys)
{
    int flag = 1, i;

    Polygon *tmp;
    while(flag) {
		flag = 0;
		i=0;
		while(s_plys[i+1]) {
			if(newptsZ[s_plys[i]->CentrePt] > newptsZ[s_plys[i+1]->CentrePt]) {
				tmp = s_plys[i];
				s_plys[i] = s_plys[i + 1];
				s_plys[i + 1] = tmp;
				flag = 1;
			}
			i++;
		}
    }
}

void 
TwoDSortPolygons(Polygon **s_plys,short int pts[])
{
    int flag = 1, i;
    
    Polygon *tmp;
    while(flag) {
	flag = 0;
	i=0;
	while(s_plys[i+1]) {
	    if(pts[s_plys[i]->CentrePt] > pts[s_plys[i+1]->CentrePt]) {
			tmp = s_plys[i];
			s_plys[i] = s_plys[i + 1];
			s_plys[i + 1] = tmp;
			flag = 1;
	    	}
	    i++;
		}
    }
}

void DrawWorld(int basepix,Dungeon *dungeon, XImage *VScreen,
				int persp,int zang,int maxy,int Shadows) 
{
	SortPolygons(dungeon->PolygonArray);
   	if (Shadows) {
		DrawShadows(basepix,dungeon, VScreen,persp,zang,maxy);
	}
   	DrawPolygons(basepix,dungeon, VScreen);
}

void Init_Mat(int xangle, int yangle, int zangle, int mat[3][3])
{
    long sx, sy, sz, cx, cy, cz;
    long sxsz, sycz, cycz;

    //sx = sinvalues[xangle];
    //sy = sinvalues[yangle];
    //sz = sinvalues[zangle];
    cx = cosvalues[xangle];
    //cy = cosvalues[yangle];
    //cz = cosvalues[zangle];

    sxsz =(sx=sinvalues[xangle]) *(sz=sinvalues[zangle]);
    sycz =(sy=sinvalues[yangle]) *(cz=cosvalues[zangle]);
    cycz =(cy=cosvalues[yangle]) * cz;

    mat[0][0] =(cycz >> 6) -((sxsz * sy) >> 12);
    mat[0][1] =(sz * cx) >> 6;
    mat[0][2] =(sycz >> 6) +((sxsz * cy) >> 12);
    mat[1][0] = -(((sz * cy) >> 6) +((sx * sycz) >> 12));
    mat[1][1] =(cx * cz) >> 6;
    mat[1][2] =((sy * -sz) >> 6) +((sx * cycz) >> 12);
    mat[2][0] = -(sy * cx) >> 6;
    mat[2][1] = -sx;
    mat[2][2] =(cx * cy) >> 6;
}

#ifdef SWEET

static int 
GetDistance(int PointId, int OtherPt)
{
    return(SQUARE(newptsX[PointId] - newptsX[OtherPt]) +
	    SQUARE(newptsY[PointId] - newptsY[OtherPt]) +
	    SQUARE(newptsZ[PointId] - newptsZ[OtherPt]));
}

int DoCollisionPoint(int Hits[MAX_COLLISION_PTS],int NumHits, int PointID, int *which)
{
    int best = 999999, i, thisdist;
    for(i = 0; i < NumHits; i++) {
		thisdist = GetDistance(Hits[i], PointID);
		if(thisdist < best) {
	    	best = thisdist;
	    	*which = i;
		}
    }
    return(best);
}

void
Dum(void)
{
	int i;
	i=0;
}

int
NewCollision(Dungeon *dung,XImage *vscreen,int CollPts[MAX_COLLISION_PTS],
		   int HitPts[MAX_COLLISION_PTS],int NumColls,int NumHits, int against,
			int DistArray[100],struct bang *Bang)
{
    int i, dist, ThisPoint, which=-1,ret=0,Change=0;
	if(Bang->Show) {
		Bang->Show=0;
		Change=0;
	} else {
		Change=1;
	}
    //fprintf(stdout,"Num Points could be hurt: %d\n",NumColls);
    for(i = 0; i < NumColls; i++) {
		ThisPoint = CollPts[i];
		DistArray[i]=dist = DoCollisionPoint(HitPts, NumHits,ThisPoint, &which);
		if(which!=-1) { // && dist<20000) {
			/*linedraw((dung->newpts[0])[HitPts[which]],
				(dung->newpts[1])[HitPts[which]],
				(dung->newpts[0])[ThisPoint],
				(dung->newpts[1])[ThisPoint],80+(dist>>10),vscreen->data);*/
		}
		if(dist < COLLISION_RADIUS) {
#ifdef DEBUG_COLLISION
	    	fprintf(stderr, "(against=%d) MyPoint: %d HisPoint: %d dist= %d\n",
		     		against,ThisPoint, HitPts[which], dist);
#endif
			if(Change) {
				Bang->What=(Bang->What+1)&3;
			}
			Bang->Show=1;
			Bang->X=(dung->newpts[0])[ThisPoint];
			Bang->Y=(dung->newpts[1])[ThisPoint];
			if(against==1) {
				(dung->Points[2])[11]-=5;
			} else {
				(dung->Points[2])[17]-=5;
			}
			ret=1;
	    	//React(which);
		}
    }	
	return(ret);
}

#endif


