#ifndef POLYINIT_H
#define POLYINIT_H

#include "poly.h"
#include "id.h"
#include <stdio.h>

#define NUM_TEXTURES 38
#define HIGHEST_COL 192
#define GROUP_SIZE 8
#define DDC_VERSION 4

#ifdef SWEET
#define OBJ_MARG 30
#define PTS_MARG 820
#define PLY_MARG 0
#else
#define OBJ_MARG 30
#define PTS_MARG 820
#define PLY_MARG 380
#endif

struct FILEobject {
	short int Numpoints;
	short int Poff;
	short int FirstPoly;
	short int NumPolys;
	short int PrevObj;
	short int Next[5];
	char Name[20];
};

struct FILEpolygon {
	short int NumVert;
	short int Points[4];
	short int Colour;
	short int Texture;
	short int CentrePt;
	char Style;
	char reserved;
};

void LoadNewBit(Dungeon *dung,Segment *towhat,char *fname);
void ShowVersion(void);
void FreeTextures(struct Picture_Type **);
void FreeAllPoints(Dungeon *);
void FreePolygons(Dungeon *);
void FreeObjects(Segment **);
void FreeStuff(Dungeon *);
struct Picture_Type **LoadTextures(int);
void ReadInSegmants(FILE *,int,Segment **,int,int,int);
Segment **LoadObjects(FILE *,FILE *,int,int,int,int,int,int);
void LoadPolys(FILE *,int,Polygon **,int,int);
Polygon **LoadPolygons(FILE *,FILE *,int,int,int,int);
int MallocNewPoints(Dungeon *,int);
int LoadPoints(Dungeon *,FILE *,FILE *,int,int);
int IsDDC(FILE *);
Dungeon *SetupStuff(char *,char *,Segment *,int,int,int *,int *);
void LoadColls(int,int [],FILE *,int);
FILE *fopenDDC(char*,char*);

Dungeon *SetupStuffed(char *fname,int NumText,int PaletteOffset);
Segment **LoadObjectsed(FILE *fp,int Number);
int LoadPointsed(Dungeon *dung,FILE *fp,int Number);


#endif
