#include <stdlib.h>
#include "keys.h"
#include "outtext.h"
#include "selectp.h"
#include "graph.h"
#include "games.h"
#include "polyinit.h"
#include "sound.h"
#include "mymem.h"

void 
MoveToScreenAGAIN(Dungeon *dung,int a,int b,int error, int cx, int cy)
{
	int i;
	for(i=a;i<b;i++) {
		(dung->newpts[0])[i]+=cx;
		(dung->newpts[1])[i]+=(cy+error);
	}

}

void 
CopyImageArea(XImage *src,XImage *dest,int x,int y)
{
	int width,height;
	int i,j;
	char *d_data,*s_data;
	width=src->width;
	height=src->height;
	d_data=dest->data;
	s_data=src->data;
	d_data+=(y*dest->width)+x;
	for(i=0;i<height;i++) {
		for(j=0;j<width;j++) {
			*(d_data++)=*(s_data++);
		}
		d_data+=(dest->width-width);
	}
}

void 
LoadPictures(Display *display,int basepix,XImage *Back)
{
	XImage *people;
	int i;
	char tmp[100];
	for(i=0;i<2;i++) {
		sprintf(tmp,"textures/player%d.pcx",i+1);
		people=WLoad_PCX(tmp,0,display,basepix);
		CopyArea(people->data,0,0,people->width,Back->data,128+i*512,
					512,1024,256,256);
		WFreePic(people);
	}
}

void 
DrawRectangle(char *raster,int x,int y,int w,int h,int colour)
{
	w--;
	HLine(raster,x,y,w,colour);
	HLine(raster,x,y+h-1,w,colour);
	VLine(raster,x,y,h,colour);
	VLine(raster,x+w,y,h,colour);
}

void 
DrawBoxes(char *raster,int colour,int number)
{
	int i;
	for(i=0;i<10;i++) {
		DrawRectangle(raster,128+i+(512*number),i+512,256-(2*i),256-(2*i),colour);
	}
}

void 
DrawSelectCrap(XImage *back,int num,int base)
{
	char *data;
	data=back->data;
	DrawBoxes(data,base+(num==0),0);
	DrawBoxes(data,base+(num==1),1);
}

void 
SetInfo(Display *display,int base_pixel,int PlayerNum,XImage *MyImage)
{
	static struct info infos[4] = {
		{ "John\0", "Howlett\0","Howler\0" },
		{ "John\0", "Looney\0","Looner\0" },
	};
	AFont *fnt;
	ClearScreenSWEET(MyImage,640,0,1024,513);
	fnt=LoadFont("textures/font.pcx",base_pixel);
	if(fnt) {
		DrawText(MyImage,fnt,infos[PlayerNum].first,660,50);
		DrawText(MyImage,fnt,infos[PlayerNum].second,660,100);
		DrawText(MyImage,fnt,infos[PlayerNum].aka,660,150);
		FreeFont(fnt);
	}
}

int 
SelectPlayer(Display *display,Window win,GC gc,XImage *MyImage,
			char *dso_names[],int base_pixel,struct Sound **sounds,int Random,
			Colormap ColMap)
{
	Dungeon *dung;
	int done=0;
	int PlayerNum=1;
	int player2;
	int NumPoints;
	int change=0;
	int CountDown=0x7F;
    int floor_error,dummy;
	XEvent report;
    Segment World = {
    0, NULL, 10, 0,
    NULL, {
        NULL, NULL, NULL, NULL, NULL
    },
    0, 0, 0,
    0
    };
	ClearScreen(MyImage);
	SetPaletteFromFile(display,ColMap,base_pixel,"textures/player1.pcx");
	LoadPictures(display,base_pixel,MyImage);
	DrawSelectCrap(MyImage,PlayerNum-1,base_pixel);
	dung=SetupStuff(dso_names[PlayerNum],dso_names[4],&World,NUM_TEXTURES,
					base_pixel, &player2,&NumPoints);
	PlaySound(sounds[PlayerNum]);
	SetInfo(display,base_pixel,PlayerNum-1,MyImage);
	(dung->Points[0])[11]=-50;
	if(dung) {
		SetGlobals(dung);
		while(dung && !done) {
			ClearScreenSWEET(MyImage,0,0,634,513);
			UpdateObjects(dung,World.Next[0]);
			UpdateObjects(dung,World.Next[1]);
            GetHeights(dung,&floor_error,&dummy);
            MakeFloor(dung);
			RotateWorld(&World,NumPoints,dung);
			MoveToScreenAGAIN(dung,6,10,0,340,200);
			MoveToScreenAGAIN(dung,10,dung->NumPoints,floor_error,340,200);

	        DrawFloor(dung,MyImage,dung->Textures[0]);
			DrawWorld(base_pixel,dung,MyImage,400,-1,-1,0);
            DoMotion(World.Next[0],100000); // Big number (only one object)
			XPutImage(display,win,gc,MyImage,0,0,0,0,1024,768);
			if(!Random) {
				if(XCheckMaskEvent (display, KeyPressMask, &report)) {
					switch (report.type) {
						case KeyPress:
							switch (report.xkey.keycode) {
								case KEY_Q:
								case KEY_ESC:
								case KEY_RETURN:
									done = 1;
									break;
								case KEY_LEFT:
									if(PlayerNum>1) {
										PlayerNum--;
										change=1;
									}
									break;
								case KEY_RIGHT:
									if(PlayerNum<2) {
										PlayerNum++;
										change=1;
									}
									break;
							}
					}
					if(change) {
						FreeStuff(dung);
						DrawSelectCrap(MyImage,PlayerNum-1,base_pixel);
						dung=SetupStuff(dso_names[PlayerNum],dso_names[4],
									&World, NUM_TEXTURES, base_pixel, &player2,
									&NumPoints);
						PlaySound(sounds[PlayerNum+1]);
						(dung->Points[0])[11]=-50;
						SetInfo(display,base_pixel,PlayerNum-1,MyImage);
						SetGlobals(dung);
						change=0;
					}
				}
			} else {
				if(CountDown) {
					CountDown--;
				} else {
					done=1;
				}
				if((CountDown&0x7) == 0) {
					int tmp;
					tmp=rand()%3;
					if(tmp>=(Random-1)) {
						tmp++;
					}
					if(tmp!=PlayerNum) {
						PlayerNum=tmp;
						FreeStuff(dung);
						DrawSelectCrap(MyImage,PlayerNum,base_pixel);
						dung=SetupStuff(dso_names[PlayerNum],dso_names[4],
									&World, NUM_TEXTURES, base_pixel, &player2,
									&NumPoints);
						SetInfo(display,base_pixel,PlayerNum,MyImage);
						SetGlobals(dung);
					}
				}
			}
           	RandomMoves(dung,0);
		}
	}
	return(PlayerNum);
}

void
ReDrawSelectScreen(XImage *Back,struct Picture_Type *pic,AFont *font,int HiLight)
{
	ClearScreen(Back);
	CopyArea(pic->Data,0,0,1024,Back->data,0,0,1024,1024,768);
	DrawText(Back,font,"Vs Computer",370,170);
	DrawText(Back,font,"Vs Network",370,235);
	DrawText(Back,font,"Practice",370,300);
	DrawText(Back,font,"Game Options",370,365);
	DrawText(Back,font,"View Intro",370,430);
	DrawText(Back,font,"Exit",370,495);
	DrawText(Back,font,">",300,170+(65*HiLight));

}

struct Picture_Type *
LoadBackDrop(int BasePix)
{
	struct Picture_Type *pic;
	pic=Load_PCX("textures/optback.pcx",0);
	if(pic) {
		RemapPicture(pic,BasePix,-1);
	}
	return(pic);
}

void
FreeBackDrop(struct Picture_Type *pic)
{
	FreePic(pic);
}

void
DrawOptionScreen(XImage *Back,struct Picture_Type *pic,AFont *font,
				 int HiLight,int vol,int *det,int *sha)
{
	char tmp[40];
	ClearScreen(Back);
	CopyArea(pic->Data,0,0,1024,Back->data,0,0,1024,1024,768);
	sprintf(tmp,"Sound Volume");
	DrawText(Back,font,tmp,170,200);
	sprintf(tmp,"%d%%",vol);
	DrawText(Back,font,tmp,670,200);
	sprintf(tmp,"backgrounds");
	DrawText(Back,font,tmp,170,265);
	sprintf(tmp,"%s",*det?"on":"off");
	DrawText(Back,font,tmp,670,265);
	sprintf(tmp,"shadows");
	DrawText(Back,font,tmp,170,330);
	sprintf(tmp,"%s",*sha?"on":"off");
	DrawText(Back,font,tmp,670,330);
	DrawText(Back,font,"Okay",170,395);
	DrawText(Back,font,">",100,200+(65*HiLight));

}

void 
DoOptions(Display *display,Window win,GC gc,XImage *Back,
		  struct Picture_Type *BackDrop,AFont *MyFont,int *det,int *sha)
{
	int Volume;
	XEvent report;
	int HiLight=0;
	int Done=0;
	Volume=(QueryVolume()/5)*5;
	DrawOptionScreen(Back,BackDrop,MyFont,0,Volume,det,sha);
	XPutImage(display,win,gc,Back,0,0,0,0,1024,768);
	XSync(display,False);
	while(!Done) {
       	if(XCheckMaskEvent(display,KeyPressMask,&report)) {
			switch(report.xkey.keycode) {
				case KEY_UP:
					if(HiLight) {
						HiLight--;
						DrawOptionScreen(Back,BackDrop,MyFont,HiLight,Volume,det,sha);
					}
					break;
				case KEY_DOWN:
					if(HiLight<3) {
						HiLight++;
						DrawOptionScreen(Back,BackDrop,MyFont,HiLight,Volume,det,sha);
					}
					break;
				case KEY_RETURN:
					switch(HiLight) {
						case 3:
							Done=1;
							break;
					}
					break;
				case KEY_LEFT:
					if(HiLight==0) {
						if(Volume>4) {
							Volume-=5;	
						} else {
							Volume=0;
						}
						SetVolume(Volume);
						DrawOptionScreen(Back,BackDrop,MyFont,HiLight,Volume,det,sha);
					}
					if(HiLight==1) {
						*det^=1;
						DrawOptionScreen(Back,BackDrop,MyFont,HiLight,Volume,det,sha);
					}
					if(HiLight==2) {
						*sha^=1;
						DrawOptionScreen(Back,BackDrop,MyFont,HiLight,Volume,det,sha);
					}
					break;
				case KEY_RIGHT:
					if(HiLight==0) {
						if(Volume<96) {
							Volume+=5;	
						} else {
							Volume=100;
						}
						SetVolume(Volume);
						DrawOptionScreen(Back,BackDrop,MyFont,HiLight,Volume,det,sha);
					}
					if(HiLight==1) {
						*det^=1;
						DrawOptionScreen(Back,BackDrop,MyFont,HiLight,Volume,det,sha);
					}
					if(HiLight==2) {
						*sha^=1;
						DrawOptionScreen(Back,BackDrop,MyFont,HiLight,Volume,det,sha);
					}
					break;
				default:
					break;
			}
		}
		XPutImage(display,win,gc,Back,0,0,0,0,1024,768);
		XSync(display,False);
	}
}

/***********************************************************************
 *
 * SelectGameType()								SelectGameType()
 *
 * Provide the user with a menu from which they may:
 * - Select which type of game to play (Vs Computer/Vs Network/Practice).
 * - Go to the options menu.
 * - Exit the game.
 *
 */

int
SelectGameType(Display *display,Window win,GC gc,Colormap ColMap,XImage *Back,int BasePix,
				int *backs,int *shad)
{
	AFont *MyFont;
	int pressed;
	int HiLight=3;
	XEvent report;
	struct Picture_Type *BackDrop;
	SetPaletteFromFile(display,ColMap,BasePix,"textures/optback.pcx");
	MyFont=LoadFont("textures/font.pcx",BasePix);
	if(MyFont) {
	  BackDrop=LoadBackDrop(BasePix);
	  if(BackDrop) {
		SetPaletteFromFile(display,ColMap,BasePix,"textures/optback.pcx");
		ReDrawSelectScreen(Back,BackDrop,MyFont,0);
		XPutImage(display,win,gc,Back,0,0,0,0,1024,768);
		XSync(display,False);
		
		while(HiLight==3) {
			HiLight=0;
			pressed=0;
			while(!pressed) {
        		if(XCheckMaskEvent(display,KeyPressMask,&report)) {
					switch(report.xkey.keycode) {
						case KEY_UP:
							if(HiLight) {
								HiLight--;
								ReDrawSelectScreen(Back,BackDrop,MyFont,HiLight);
							}
							break;
						case KEY_DOWN:
							if(HiLight<5) {
								HiLight++;
								ReDrawSelectScreen(Back,BackDrop,MyFont,HiLight);
							}
							break;
						case KEY_RETURN:
							pressed=1;
							break;
						case KEY_ESC:
							pressed=1;
							HiLight=6;
							break;
						default:
							break;
					}
				}
				XPutImage(display,win,gc,Back,0,0,0,0,1024,768);
				XSync(display,False);
			}
			if(HiLight==3) {
				DoOptions(display,win,gc,Back,BackDrop,MyFont,backs,shad);
				ReDrawSelectScreen(Back,BackDrop,MyFont,0);
				XPutImage(display,win,gc,Back,0,0,0,0,1024,768);
				XSync(display,False);
			}
		}
	 	FreeBackDrop(BackDrop);
	  }	
	  FreeFont(MyFont);
	}
	if(HiLight<4) {
		HiLight++;
	}
	fprintf(stdout,"Returning: %d\n",HiLight);
	return(HiLight);
}

static void 
ShowHostList(XImage *Back,struct Picture_Type *pic,AFont *font,
			char Hosts[150][20],int First, int Selected)
{
	int i;
	ClearScreen(Back);
	CopyArea(pic->Data,0,0,1024,Back->data,0,0,1024,1024,768);
	for(i=0;i<8;i++) {
		DrawText(Back,font,Hosts[First+i],170,100+(i*65));
	}
	for(i=0;i<8;i++) {
		if(i+First==Selected) {
			DrawText(Back,font,">",100,100+(i*65));
		//} else {
			//DrawText(Back,font," ",100,100+(i*65));
		}
	}
}

int
GetOtherHost(Display *display,Window win,GC gc,XImage *Back,int BasePix,
                 char *host_return,Colormap ColMap)
{
	AFont *font;
	char Hosts[150][20] = { { 0 } };
	XEvent report;
	int i,NumHosts=1;
	int picked=0,Selected=0,First=0;
	struct Picture_Type *BackDrop;
	FILE *fp;
	fp=fopen("hosts","r");
	if(fp) {
		for(i=0;i<139;i++) {
			if(fgets(Hosts[i],20,fp)) {
				Hosts[i][strlen(Hosts[i])-1]=0;
				NumHosts++;
			}
		}
		fclose(fp);
	}
	strcpy(Hosts[NumHosts-1],"Cancel");
	Selected=0;
	First=0;
	font=LoadFont("textures/font.pcx",BasePix);
	if(font) {
		BackDrop=LoadBackDrop(BasePix);
		if(BackDrop) {
			SetPaletteFromFile(display,ColMap,BasePix,"textures/optback.pcx");
			// Build up list
			ShowHostList(Back,BackDrop,font,Hosts,0,0);
			XPutImage(display,win,gc,Back,0,0,0,0,1024,768);
			while(!picked) {
				if(XCheckMaskEvent(display,KeyPressMask,&report)) {
					switch(report.xkey.keycode) {
						case KEY_PGDN:
							Selected+=8;
							if(Selected>=NumHosts) {
								Selected=NumHosts-1;
							}
							if(Selected>First+7) {
								First=Selected-7;
							}
							break;
						case KEY_PGUP:
							Selected-=8;
							if(Selected<0) {
								Selected=0;
							}
							if(Selected<First) {
								First=Selected;
							}
							break;
						case KEY_DOWN:
							Selected++;
							if(Selected>=NumHosts) {
								Selected--;
							}
							if(Selected>First+7) {
								First++;
							}
							break;
						case KEY_UP:
							Selected--;
							if(Selected<0) {
								Selected=0;
							}
							if(Selected<First) {
								First--;
							}
							break;
						case KEY_RETURN:
							picked=1;
							strcpy(host_return,Hosts[Selected]);
							break;
					}
				}
				ShowHostList(Back,BackDrop,font,Hosts,First,Selected);
				XPutImage(display,win,gc,Back,0,0,0,0,1024,768);
			}
		}
	}
	SetPaletteFromFile(display,ColMap,BasePix,"textures/player1.pcx");
	if(Selected+1==NumHosts) {
		return(0);
	}
	return(1); // Didn't cancel
} 

